	subroutine make_ray_table(num_rays, ray_time,ray_table, rot_dir)
C
	integer num_rays
	real ray_time(num_rays)
	integer ray_table(num_rays)
	integer rot_dir
C
c find start ray number
	time_start = 1440000.0
	time_end = -time_start
	do i = 1, num_rays
	     if( ray_time(i) .ge. 0.0) then
		if(ray_time(i).lt.time_start) then
			time_start = ray_time(i)
			ifirst_ray = i
		end if
		if(ray_time(i).gt.time_end) then
			time_end = ray_time(i)
			last_ray = i
		end if
	     end if
	end do
	write(6,*)'First and last ray ',ifirst_ray, last_ray
C now use first and last ray to figure out totation and load
	if( ifirst_ray .gt. last_ray)then
C widdershins (counter-clockwise)
	  rot_dir = -1
	  iray = 1
	  do i = ifirst_ray, num_rays
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = 1, last_ray
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray+1, ifirst_ray-1, 1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C 
	else if( ifirst_ray .lt. last_ray)then
C clockwise
	  rot_dir = 1
	  iray = 1
	  do i = ifirst_ray, 1, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = num_rays, last_ray, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray-1, ifirst_ray+1, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C
	end if
C Now flad rays with time of -1.0
	do i = 1, num_rays
	  if( ray_time(ray_table(i)) .lt. 0.0) then
		ray_table(i) = -1
	   end if
	end do

C debug, dump ray_table
cd	write(6,*)'debug. ray table'
cd	do i = 1, num_rays
cd	 if(ray_table(i) .gt. 0) then
cd	  write(6,*)'Ray Table ',i,ray_table(i),ray_time(ray_table(i))
cd	 else
cd	  write(6,*)'Ray Table ',i,ray_table(i), -1.0
cd	 endif
cd	end do
cd	write(6,*)' found rot_dir ', rot_dir
	return
	end
C ====================================
	subroutine check_tdr_angles(num_rays,ray_table,
     +	   az_el, rot_dir, daz_avg, daz_min, daz_max)
c
	integer num_rays, ray_table(num_rays)
	integer rot_dir ! 1 = clockwise, -1 counterclockwise
	real az_el(2,num_rays)
	real daz_avg, daz_min, daz_max
C
	write(6,*)'input n rays, rot dir ',num_rays, rot_dir
c now use the ray_table to look at antenna
C rotation angles
	prev_az = az_el(1, ray_table(1))
	daz_min = 360.0
	daz_max = -daz_min
	daz_avg = 0.0
	num_good_rays = 1

	do i = 2, num_rays
	  if(ray_table(i) .ne. -1) then
	    num_good_rays = num_good_rays + 1
	    del_az = az_el(1,ray_table(i)) - prev_az
C fix over large del az at 0/360 crossing
	    if(rot_dir .eq. -1) then
c nav angles decrease in ccw rotation, do del az
c should be a negative number.
	      if(del_az .gt. 180.0) then
		del_az = del_az - 360.0
	      end if
	    else ! clockwise
	      if(del_az .lt. -180.0) then
		del_az = 360.0 + del_az
	      endif
	    end if
	    prev_az = az_el(1,ray_table(i))
	    if(del_az .gt. daz_max) then
		daz_max = del_az
	    end if
	    if(del_az .lt. daz_min) then
		daz_min = del_az
	    end if
	    daz_avg = daz_avg + del_az
	  end if
	end do
	daz_avg = daz_avg / (num_good_rays - 1)
	
C
	return
	end
C ====================================
	subroutine check_abs_tdr_angles(num_rays,ray_table,
     +	   az_el, rot_dir, daz_avg, daz_min, daz_max)
c
	integer num_rays, ray_table(num_rays)
	integer rot_dir ! 1 = clockwise, -1 counterclockwise
	real az_el(2,num_rays)
	real daz_avg, daz_min, daz_max
C
c now use the ray_table to look at antenna
C rotation angles
	prev_az = az_el(1, ray_table(1))
	daz_min = 360.0
	daz_max = -daz_min
	daz_avg = 0.0
	num_good_rays = 1

	do i = 2, num_rays
	  if(ray_table(i) .ne. -1) then
	    num_good_rays = num_good_rays + 1
	    del_az = abs(az_el(1,ray_table(i)) - prev_az)
C fix over large del az at 0/360 crossing
	    if(del_az .gt. 180.0) then
		del_az = 360.0 - del_az
	    end if
	    prev_az = az_el(1,ray_table(i))
	    if(del_az .gt. daz_max) then
		daz_max = del_az
	    end if
	    if(del_az .lt. daz_min) then
		daz_min = del_az
	    end if
	    daz_avg = daz_avg + del_az
	  end if
	end do
	daz_avg = daz_avg / (num_good_rays - 1)
	
C
	return
	end




