C	profram inv_iris_sweeps
C mod of read iris sweeps to read a list
C of raw rvp8 files and dump out info about 
C sweeps...
C version for gnu fortran which does not
C like the structur and record statements
	program inv_iris_sweeps
c /read in a radar tape file and write out sweeos in the
c SIGMET/Vaisala IRIS Raw data format. to simlate sweeps
C written out by the RVP8. Oh how I did not want to
C write this code.... started 9 Dec 2008. Peter Dodge,
C radar data p;umber, HRD 
C Iris data structures
	parameter(max_rays = 500, max_gates = 2048)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...

	integer*4 swapped, read_stuff
	character*80 sweep_fn, temp_fn
	character *80 file_list_fn
C swp_lu is actually a pointer to a file descriptor. On thor
C pointersare 4 byte but on helios, a 64 bit machine, thr pointers are 8 bytes
Cout	integer*4 swp_lu
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
	integer*4 num_fields
	integer*4 io_error

	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
					
	type ( struct_hdr ) str_hdr
	type ( product_config ) prod_conf
	type ( product_end ) prod_end
	type ( ingest_configuration) i_config
	type ( task_sched_info ) t_sched
	type ( task_dsp_info ) t_dsp
	type ( task_calib_info ) t_calib
	type ( task_range_info ) t_range
	type ( task_scan_info ) t_scan

	type ( ymds_time ) start_time_str
	type ( ymds_time ) end_time_str
	real sweep_start_time
	
	type ( task_misc_info ) t_misc
	type ( task_end_info ) t_end

	type ( task_rhi_scan_info ) t_rhi
	type ( task_ppi_scan_info ) t_ppi
	
	type ( ingest_data_hdr ) idh(MAX_FIELDS) ! /* should be more general! */
	type ( raw_prod_bhdr ) rpbh
	type ( ray_hdr ) rh(max_rays)
	type ( TDR_hdr ) air_hdr(max_rays)

C and here are the arrays for the pther data types:
	real*4 dbz(max_gates)
	real*4 dop(max_gates)
	real*4 wid(max_gates)
	real*4 vel_nyq
C  and 3 arrays i can use for displaying sweeps
	real dbz_sweep(max_gates, max_rays)
	real dop_sweep(max_gates, max_rays)
	real spw_sweep(max_gates, max_rays)
	real az_el( 2, max_rays)

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

	character*80 radar_fn
	character*4 time_string

c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	include "hrd_radar_common_blocks.f"

	logical french_antenna
	character*1 antenna_type
C
	integer list_lu
C array of flags to select data
	integer data_sel_flags(3)

C
	real time_start, time_end
	real az_first, az_last, el_first, el_last
	integer ih_s,im_s,is_s,is100_s
	integer ih_e,im_e,is_e,is100_e
	integer num_good_rays
C default data types to retrieve
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_WIDTH2
C
	list_lu = 10
	bad_val = -999.0
	igood_read = 1 ! for testing io_error in get tdr ray
C
	open(1, file = '/dev/tty')
	
	read_stuff = 0 ! set to  1 to get massive dump of info
	call getarg(1, file_list_fn)
	if(file_list_fn .eq. ' ')then
	  write(6,*)' IRIS radar  file: '
	  read(5,'(a)') file_list_fn
	end if
	open(list_lu,file=file_list_fn,form='formatted',status='old')
123	read(list_lu,'(a)', end = 999, err= 999)sweep_fn
c
	call open_iris_file(swp_lu, sweep_fn, iostat)
D	write(6,*)iostat,' iostat opening ', sweep_fn
D	write(6,*)' returned file pointer ', swp_lu
	if(iostat .ne. 1) then
		stop ' Coild not open file. adios '
	else
D		write(6,*) "Opened sweep file", sweep_fn
	end if

	call check_byte_swapping(swp_lu, swapped)
c
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
D	write(6,*)' read first record'
	call read_product_hdr(6, prod_conf, prod_end)

	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_sched, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	tot_read = 2 * BLK_LENGTH
C
D	write(6,*)' Read record 2'

	call read_task_hdr(6, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C print task_calib_info.flag bits
	call show_cal_flag_bits(6,t_calib%flags)
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
	wavelength= t_misc%wavelength * 0.0001
	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )
D	write(6, *)"Myquist velocity ",vel_nyq," m/s"
	if(t_dsp%prf_mode .eq. 0) then
D	   write(6,*)" Single PRF mode", vel_nyq
	else
D	   write(6,*)" Dual PRF mode ",t_dsp%prf_mode, vel_nyq
	end if


C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.
	num_sweeps = t_scan%num_sweeps
C change 19 June 2012
C file with multiple sweeps will list more than one
C associated file for each variable...
	num_fields = i_config%num_assoc_files/num_sweeps
D	write(6,*)'mun fields, sweeps ',num_fields, num_sweeps
	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C Dump some Ingest configuration stuff
D	write(6,*)'Ingest config stuff: '
D	write(6,*)'index_first_ray: ',
D     +		i_config%index_first_ray
D	write(6,*)'n_rays_sweep: ',
D     +		i_config%n_rays_sweep
	   avg_roll = 0.0
D	   write(6,*)" *** Sweep # ",isweep," of file ",sweep_fn
	call flush(6)

C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
C
C
	start_time_str = idh(1)%date
	call read_time_structure(6, iyear, month, iday,
     +		 ih, im, is, is100, start_time_str)
	time = start_time_str%seconds + is100 * 0.01
	time_start = 180000.0 ! 50 hours
	time_end = -1.0
	num_good_rays = 0
	sweep_start_time= time
D	write(6,"('Sweep start: ',3i2.2,'.',i2.2)")ih,im,is,is100
	  num_rays = idh(num_fields)%expected_num_rays
	  num_hdr_rays = idh(num_fields)%num_rays_in_file
C dump ingest data header variavles
D	write(6,*)'First ingest data header'
D	write(6,*)'sweep_num ',idh(1)%sweep_num
D	write(6,*)'ray_resolution ',
D     +		idh(1)%ray_resolution
D	write(6,*)'first_ray_index ',
D     +		idh(1)%first_ray_index
D	write(6,*)'expected_num_rays ',
D     +		idh(1)%expected_num_rays
D	write(6,*)'num_rays_in_file ',
D     +		idh(1)%num_rays_in_file

	call flush(6)

C finally read the rays and expand the data, including the extended headers
	  do i = 1, num_rays
D	write( 6, '("ray # ", i3,1x, 58("=") )'), i
	call flush(6)

	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dbz, dop, wid, 
     +		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)
	   if( io_error .ne. igood_read) then
D		write(6,*)'crud. read rat error: ', io_error
		go to 333 ! break out
	   end if
D update time:
	  time = sweep_start_time + 
     +		air_hdr(i)%time_since_sweep_start * 0.001
	  call convert_time(time,ih,im,is)
	  is100 = (time-ih*3600.0-im*60.0-is)*100
D
C Archaeology... which pad word now holds removed velocity?
D	write(6,*)'Pad woeds: ',air_hdr(i)%pad_1,
D     +	  air_hdr(i)%pad_2,air_hdr(i)%pad_4,
D     |	  air_hdr(i)%pad_5
c
D	write(6,*)'read ray successful'
	call flush(6)
	   call  read_TDR_hdr(0, air_hdr(i) )
D	write(6,*)'read extended header'
	call flush(6)

	   avg_roll = avg_roll + roll
	   num_bins = rh(i)%num_bins_in_ray
c load sweep arrays for later display
	   do ib = 1, num_bins
		dbz_sweep( ib, i) = dbz(ib)
		dop_sweep(ib, i) = dop(ib)
		spw_sweep( ib, i) = wid( ib )
	   end do
C note taht i swap az and el, so first angle is the rotation, 2nd is the tilt
	   az_el(1, i) = bam16_TO_de g(rh(i)%el_beg )
	   az_el(2, i) =bam16_TO_de g( rh(i)%az_beg )
	  if(num_bins .gt. 0) then
	    num_good_rays = num_good_rays + 1
	    if(time .lt. time_start)then
		time_start = time
		az_first = az_el(1,i)
		el_first = az_el(2,i)
	    else if(time .gt. time_end) then
		time_end = time
		az_last = az_el(1,i)
		el_last = az_el(2,i)
	    end if
	  end if


	   call get_ray_min_max(dbz, num_bins, bad_val,dbz_min, dbz_max)
	   call get_ray_min_max(dop, num_bins, bad_val,dop_min, dop_max)
	   call get_ray_min_max(wid, num_bins, bad_val,wid_min, wid_max)
	if(num_bins.gt.0)then
D	   write(6, 111)i,ih,im,is,is100, 
D     +		az_el(1,i), az_el(2,i), dbz_min, dbz_max,
D     +		dop_min, dop_max, wid_min, wid_max
111	   format('Ray # ',i3, 1x,3i2.2,'.',i2.2,1x, f7.2, 1x, f6.2, 
     +		1x,6(f6.2,1x) )
	   else
D	     write(6,1111)i
1111	     format("Ray # ",i3," 0 bins. Empty ray")
	   end if
	   if((dop_max .gt. vel_nyq) .or.
     +		(dop_min .lt. -vel_nyq) ) then
D	      write(6,119)i,dop_min,dop_max,vel_nyq
119	      format("Shit. ",i3,1x,2(1x,f7.2), 1x, f5.2)
	   end if

C some stuff to look at az angles
	   az_beg = bam16_TO_de g(rh(i)%el_beg )
	   az_end = bam16_TO_de g(rh(i)%el_end )
	del_az = az_end - az_beg
cout	if( num_bins .gt. 0 ) then
cout	write(33,*)i, rh(i)%secs_from_start,
cout     +		air_hdr(i)%time_since_sweep_start,
cout     +		az_beg, az_end, del_az
cout	else
cout	write(33,*)-i, rh(i)%secs_from_start,
cout +		air_hdr(i)%time_since_sweep_start,
cout     +		az_beg, az_end, del_az
cout	end if

	  end do ! rays loop

	   avg_roll = avg_roll / num_rays
d	  write(6,*)avg_roll,' deg avg roll in ',sweep_fn
d	  write(6,*)'nrem after last ray: ',nrem
D	  write(6,*)'pausing'
D	  read(5,*)
	  if(nrem .gt. 0) then
	     call skip_iris_words(swp_lu, nrem)
	     nrem = 0
	  end if
	call convert_time(time_start,ih_s,im_s,is_s)
	is100_s = (time_start-ih_s*3600.0-im_s*60.0-is_s)*100
	call convert_time(time_end,ih_e,im_e,is_e)
	is100_e = (time_end-ih_e*3600.0-im_e*60.0-is_e)*100
	if(az_first.lt. 0.0)then
	  az_first = az_first + 360.0
	end if
	if(az_last .lt. 0.0)then
	   az_last = az_last + 360.0
	end if
	write(22,3331)ih_s,im_s, is_s,is100_s,
     +	  ih_e,im_e, is_e, is100_e,az_first,az_last,
     *	  el_first, 
     +	  num_rays, num_hdr_rays, num_good_rays
3331	format(2(3i2.2,'.',i2.2,1x),2(1x,f6.1),1x,f5.1,3(1x,i3) )

	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


333	call close_iris_file(swp_lu)
C get another file
	go to 123
999	write(6,*)'end of sweep files'
	end
