C version for gnu fortran which does not
C like the structur and record statements
	program read_iris_sweeps
c /read in a radar tape file and write out sweeos in the
c SIGMET/Vaisala IRIS Raw data format. to simlate sweeps
C written out by the RVP8. Oh how I did not want to
C write this code.... started 9 Dec 2008. Peter Dodge,
C radar data p;umber, HRD 
C Iris data structures
	parameter(max_rays = 500, max_gates = 1024)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...

	integer*4 swapped, read_stuff
	character*80 sweep_fn, temp_fn
C swp_lu is actually a pointer to a file descriptor. On thor
C pointersare 4 byte but on helios, a 64 bit machine, thr pointers are 8 bytes
Cout	integer*4 swp_lu
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
	integer*4 num_fields
	integer*4 io_error

	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
					
	type ( struct_hdr ) str_hdr
	type ( product_config ) prod_conf
	type ( product_end ) prod_end
	type ( ingest_configuration) i_config
	type ( task_sched_info ) t_sched
	type ( task_dsp_info ) t_dsp
	type ( task_calib_info ) t_calib
	type ( task_range_info ) t_range
	type ( task_scan_info ) t_scan

	type ( ymds_time ) start_time_str
	type ( ymds_time ) end_time_str
	
	type ( task_misc_info ) t_misc
	type ( task_end_info ) t_end

	type ( task_rhi_scan_info ) t_rhi
	type ( task_ppi_scan_info ) t_ppi
	
	type ( ingest_data_hdr ) idh(MAX_FIELDS) ! /* should be more general! */
	type ( raw_prod_bhdr ) rpbh
	type ( ray_hdr ) rh(max_rays)
	type ( TDR_hdr ) air_hdr(max_rays)

C and here are the arrays for the pther data types:
	real*4 dbz(max_gates)
	real*4 dop(max_gates)
	real*4 wid(max_gates)
	real*4 vel_nyq
C  and 3 arrays i can use for displaying sweeps
	real dbz_sweep(max_gates, max_rays)
	real dop_sweep(max_gates, max_rays)
	real spw_sweep(max_gates, max_rays)
	real az_el( 2, max_rays)

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

	character*80 radar_fn
	character*4 time_string

c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	include "hrd_radar_common_blocks.f"

	logical french_antenna
	character*1 antenna_type
C array of flags to select data
	integer data_sel_flags(3)

C
C default data types to retrieve
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_WIDTH2
C
	bad_val = -999.0
	igood_read = 1 ! for testing io_error in get tdr ray
C
	open(1, file = '/dev/tty')
	
	read_stuff = 1 ! set to  1 to get massive dump of info
	call getarg(1, sweep_fn)
	if(sweep_fn .eq. ' ')then
	  write(1,*)' IRIS radar  file: '
	  read(1,'(a)') sweep_fn
	end if

c
	call open_iris_file(swp_lu, sweep_fn, iostat)
	write(6,*)iostat,' iostat opening ', sweep_fn
	write(6,*)' returned file pointer ', swp_lu
	if(iostat .ne. 1) then
		stop ' Coild not open file. adios '
	else
		write(6,*) "Opened sweep file", sweep_fn
	end if

	call check_byte_swapping(swp_lu, swapped)
c
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
	write(6,*)' read first record'
	call read_product_hdr(6, prod_conf, prod_end)

	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_sched, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	tot_read = 2 * BLK_LENGTH
C
	write(6,*)' Read record 2'

	call read_task_hdr(6, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
	wavelength= t_misc%wavelength * 0.0001
	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )
	write(6, *)"Myquist velocity ",vel_nyq," m/s"
	if(t_dsp%prf_mode .eq. 0) then
	   write(6,*)" Single PRF mode", vel_nyq
	else
	   write(6,*)" Dual PRF mode ",t_dsp%prf_mode, vel_nyq
	end if


C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.
	num_sweeps = t_scan%num_sweeps
	num_fields = i_config%num_assoc_files
	write(6,*)'mun fields, sweeps ',num_fields, num_sweeps
	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C Dump some Ingest configuration stuff
	write(6,*)'Ingest config stuff: '
	write(6,*)'index_first_ray: ',
     +		i_config%index_first_ray
	write(6,*)'n_rays_sweep: ',
     +		i_config%n_rays_sweep
	   avg_roll = 0.0
	   write(6,*)" *** Sweep # ",isweep," of file ",sweep_fn
	call flush(6)

C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
C
	  num_rays = idh(num_fields)%expected_num_rays
C dump ingest data header variavles
	write(6,*)'First ingest data header'
	write(6,*)'sweep_num ',idh(1)%sweep_num
	write(6,*)'ray_resolution ',
     +		idh(1)%ray_resolution
	write(6,*)'first_ray_index ',
     +		idh(1)%first_ray_index
	write(6,*)'expected_num_rays ',
     +		idh(1)%expected_num_rays
	write(6,*)'num_rays_in_file ',
     +		idh(1)%num_rays_in_file

	call flush(6)

C finally read the rays and expand the data, including the extended headers
	  do i = 1, num_rays
	write( 6, '("ray # ", i3,1x, 58("=") )'), i
	call flush(6)

	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dbz, dop, wid, 
     +		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)
	   if( io_error .ne. igood_read) then
		write(6,*)'crud. read rat error: ', io_error
		go to 333 ! break out
	   end if
C Archaeology... which pad word now holds removed velocity?
	write(6,*)'Pad woeds: ',air_hdr(i)%pad_1,
     +	  air_hdr(i)%pad_2,air_hdr(i)%pad_4,
     |	  air_hdr(i)%pad_5
c
	write(6,*)'read ray successful'
	call flush(6)
	   call  read_TDR_hdr(0, air_hdr(i) )
	write(6,*)'read extended header'
	call flush(6)

	   avg_roll = avg_roll + roll
	   num_bins = rh(i)%num_bins_in_ray
c load sweep arrays for later display
	   do ib = 1, num_bins
		dbz_sweep( ib, i) = dbz(ib)
		dop_sweep(ib, i) = dop(ib)
		spw_sweep( ib, i) = wid( ib )
	   end do
C note taht i swap az and el, so first angle is the rotation, 2nd is the tilt
	   az_el(1, i) = bam16_TO_de g(rh(i)%el_beg )
	   az_el(2, i) =bam16_TO_de g( rh(i)%az_beg )

	   call get_ray_min_max(dbz, num_bins, bad_val,dbz_min, dbz_max)
	   call get_ray_min_max(dop, num_bins, bad_val,dop_min, dop_max)
	   call get_ray_min_max(wid, num_bins, bad_val,wid_min, wid_max)
	   write(6, 111)i, az_el(1,i), az_el(2,i), dbz_min, dbz_max,
     +		dop_min, dop_max, wid_min, wid_max
111	   format('Ray # ',i3, 1x, f7.2, 1x, f6.2, 1x,6(f6.2,1x) )
	   if((dop_max .gt. vel_nyq) .or.
     +		(dop_min .lt. -vel_nyq) ) then
	      write(6,119)i,dop_min,dop_max,vel_nyq
119	      format("Shit. ",i3,1x,2(1x,f7.2), 1x, f5.2)
	   end if

C some stuff to look at az angles
	   az_beg = bam16_TO_de g(rh(i)%el_beg )
	   az_end = bam16_TO_de g(rh(i)%el_end )
	del_az = az_end - az_beg
cout	if( num_bins .gt. 0 ) then
cout	write(33,*)i, rh(i)%secs_from_start,
cout     +		air_hdr(i)%time_since_sweep_start,
cout     +		az_beg, az_end, del_az
cout	else
cout	write(33,*)-i, rh(i)%secs_from_start,
cout +		air_hdr(i)%time_since_sweep_start,
cout     +		az_beg, az_end, del_az
cout	end if

	  end do ! rays loop

	   avg_roll = avg_roll / num_rays
	  write(6,*)avg_roll,' deg avg roll in ',sweep_fn
	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


333	call close_iris_file(swp_lu)
	end
