      PROGRAM WINDTOASCII
c      USE NETCDF
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80,OUTFILNAM*80
      CHARACTER INFILEFILE*80, OUTFILEFILE*80,SUMMARYFLIGHTID*8
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      LOGICAL SUMMARYEXISTS
C
C     U=EAST-WEST WIND COMPONENT
C     V=NORTH-SOUTH WIND COMPONENT
C     W=VERTICAL WIND COMPONENT
C     DBZ=RADAR REFLECTIVITY
C     WS=WIND SPEED
C     TW=TANGENTIAL WIND
C     RW=RADIAL WIND
C
C DBZWRITE ARE THE 3D AND 2D REFLECTIVITY VALUES FOR EVENLY SPACED
C LAT-LON GRIDS, WHICH ARE USED IN AWIPS FILES
C   
      REAL DBZWRITE(8000000),DBZWRITE1(1000000)
C
C U,V,W,DBZ ARE THE ORIGINAL VALUES FROM THE "WFILE" WIND PRODUCTS
C THAT IS, THEY ARE THE ORIGINAL OUTPUT OF THE AUTOMATED ANALYSIS
C THEY ARE INTENDED TO REMAIN IN EVENLY SPACED X-Y CARTESIAN GRID
C
      REAL U(8000000),V(8000000),W(8000000),DBZ(8000000),VORT(8000000)
C
C U1,V1,W1,DBZ1 WILL BE U,V,W,DBZ INTERPOLATED TO EVENLY SPACED LAT-LON
C GRID WHICH COULD BE USED FOR 3D NETCDF FILES BUT DEFINITELY ARE USED
C FOR THE AWIPS GRIDS
C
      REAL U1(8000000),V1(8000000),W1(8000000),DBZ1(8000000)
C
C WIND SPEED (WS), TANGENTIAL WIND (TW), RADIAL WIND (RW)
C LAT AND LON ARE THE LATITUDES AND LONGITUDES OF GRID POINTS IN THE
C X-Y CARTESIAN COOORDINATE GRID
C
      REAL WS(8000000),TW(8000000),RW(8000000),LAT(8000000)
C
C WINDS SPEED (WS1), TANGENTIAL WIND (TW1), RADIAL WIND (RW1) IN THE
C LAT-LON COORDINATE GRID
C
      REAL WS1(8000000),TW1(8000000),RW1(8000000),LON(8000000)
C
C X AND Y WILL EVENTUALLY BE THE LATITUDES AND LONGITUDES OF THE
C EVENLY SPACED (IN DEGREES) LATITUDE AND LONGITUDE GRID USED BY AWIPS
C Z IS THE HEIGHT IN KM
C U2 IS USED AS A LOCATION FOR TRANSPOSING OR TRANSFORMING VARIABLES
C
      REAL X(800),Y(800),Z(800),U2(8000000)
C
C XKM AND YKM ARE THE OIRGINAL POSITIONS OF GRID POINTS IN THE ANALYSIS 
C OUTPUT IN KM, RELATIVE TO THE ORIGIN
C
      REAL XKM(800),YKM(800)
C
C UWRITE AND VWRITE ARE 3D GRIDS OF U AND V IN KNOTS
C MAXDBZ IS THE MAXIMUM REFLECTIVITY IN EACH COLUMN OF A 2D AWIPS ARRAY
C
      REAL UWRITE(8000000),VWRITE(8000000),MAXDBZ(100000)
C
C UWRITE1 AND VWRITE1 AND U AND V IN KNOTS FOR EACH 2D ARRAY AT GIVEN HEIGHT
C
      REAL UWRITE1(1000000),VWRITE1(1000000)
C
      INTEGER IconvertMD(1000000)
      CHARACTER CDUMMY*1,CDUMMY13*13,CDUMMY15*15,CDUMMY25*25
      CHARACTER ACCEPTABLE1*1,ACCEPTABLE2*1
      LU=80
      INCLUDEINCOMPOSITE=1
c      WRITE(6,*)'Enter input file names file name'
c      READ(5,*)INFILEFILE
c      WRITE(6,*)'Enter output file names file name'
c      READ(5,'(A80)')OUTFILEFILE
C     INFILEFILE CONTAINS THE NAMES OF HRD-FORMAT 3D WIND FILES
C     OUTFILEFILE CONTAINS THE NAME OF NETCDF 3D WIND FILES
      ICALLTEST=0
      INFILEFILE='infiles_netcdf'
      OUTFILEFILE='outfiles'
      OPEN(82,FILE=INFILEFILE)
      OPEN(83,FILE=OUTFILEFILE)
C     LOOP THROUGH ALL THE INPUT FILES UNTIL EOF
1     READ(82,*,END=999)DISPLACEMENT_FACTOR
      READ(82,'(A80)',END=999)FILNAM
      READ(83,'(A80)',END=999)OUTFILNAM
      WRITE(6,180)FILNAM
      NAMELENGTH=LEN_TRIM(FILNAM)
      IF(NAMELENGTH.EQ.18)THEN
         ICALLTEST=0
      ELSE
         ICALLTEST=1
      ENDIF
      WRITE(6,*)'ICALLTEST = ',ICALLTEST
      WRITE(6,181)OUTFILNAM
180   FORMAT('INPUT FILE NAME IS ',A80)
181   FORMAT('OUTPUT FILE NAME IS ',A80)
      LUOUT=81
C      ICALLTEST=ICALLTEST+1
c      OPEN(LUOUT,FILE=OUTFILNAM)
C     READ THE HEADER OF THE HRD-FORMAT BINARY FILE
      CALL READHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
C KEYWORD=WIND MEANS 16-BIT INTEGER BINARY DATA
C KEYWORD=RUV MEANS 32-BIT REAL DATA
      IF(KEYWORD.EQ.'WIND'.OR.KEYWORD.EQ.'wind')THEN
       IUV=0
       WRITE(6,*)'IUV = ',IUV
      ELSEIF(KEYWORD.EQ.'RUV '.OR.KEYWORD.EQ.'ruv ')THEN
       IUV=1
       WRITE(6,*)'IUV = ',IUV
      ELSE
       WRITE(6,89)KEYWORD
89     FORMAT('KEYWORD IS ',A4,'....STOPPING')
       STOP
      ENDIF
C      WRITE(6,*)'FLTNAME = ',FLTNAME
      WRITE(6,'(A4)')KEYWORD
      WRITE(LUOUT,'(A4)')KEYWORD
      WRITE(6,'(A8)')FLTNAME
      WRITE(LUOUT,'(A8)')FLTNAME
      WRITE(6,'(A12)')STMNAME
      WRITE(LUOUT,'(A12)')STMNAME
      WRITE(6,'(A4)')RADAR
      WRITE(LUOUT,'(A4)')RADAR
      WRITE(6,'(A32)')EXPERIMENT
      WRITE(LUOUT,'(A32)')EXPERIMENT
      WRITE(6,'(A32)')CREATIME
      WRITE(LUOUT,'(A32)')CREATIME
      WRITE(6,'(A28)')EXTRA1
      WRITE(LUOUT,'(A28)')EXTRA1
      IF(IABS(KOUNT).GT.100)KOUNT=100
      WRITE(6,'(7I10)')IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN
      WRITE(LUOUT,'(7I10)')IMAX,JMAX,KMAX,KOUNT,NMOSM,IUNFLD,IATTEN
      WRITE(6,'(3I10)')FLAG,EXTRA2,EXTRA3
      WRITE(LUOUT,'(3I10)')FLAG,EXTRA2,EXTRA3
      WRITE(6,'(4E14.6)')STIME,ETIME,OLAT,OLON
      WRITE(LUOUT,'(4E14.6)')STIME,ETIME,OLAT,OLON
      WRITE(6,'(6F10.3)')SX,SY,SZ,XZ,YZ,ZZ
      WRITE(LUOUT,'(6F10.2)')SX,SY,SZ,XZ,YZ,ZZ
      WRITE(6,'(4E14.6)')ROT,RA,CO1,CO2
      WRITE(LUOUT,'(4E14.6)')ROT,RA,CO1,CO2
      WRITE(6,'(6E13.5)')AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL
      WRITE(LUOUT,'(6E13.5)')AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL
      WRITE(6,'(4E14.6)')ETIME1,STIME2,EXTRA6,EXTRA7
      WRITE(LUOUT,'(4E14.6)')ETIME1,STIME2,EXTRA6,EXTRA7
C
C LOAD THE WIND AND REFLECTIVITY DATA FROM THE HRD-FORMAT 3D FILE
C
      CALL LDPLN(LU,U,V,W,DBZ,IMAX,JMAX,KMAX,IUV,ZZ,SZ)
C
C COMPUTE WIND SPEED (WS), TANGENTIAL WIND (TW), AND RADIAL WIND (RW)
C FROM U AND V
C
      CALL ALLWIND(SX,SY,XZ,YZ,IMAX,JMAX,KMAX,U,V,WS,TW,RW,VORT)
C
C WRITENETCDF WILL CREATE A NETCDF FILE, REMAP FROM X-Y COORDINATES 
C RELATIVE TO THE STORM CENTER, REMAP FROM FORTRAN STORAGE HIERARCHY
C TO NETCDF (C) STORAGE HIERARCY, DECLARE AND WRITE ALL METADATA, DIMENSIONS
C AND VARIABLES TO NETCDF FILE, AND THEN CLOSE THE FILE
C
      INCLUDEINCOMPOSITE=1
      WRITE(6,*)INCLUDEINCOMPOSITE
      INQUIRE(FILE='summary',EXIST=SUMMARYEXISTS)
      IF(SUMMARYEXISTS)THEN
         OPEN(LUIN,FILE="summary")
         READ(LUIN,'(A13,A8)')CDUMMY13,SUMMARYFLIGHTID
         IF(SUMMARYFLIGHTID.NE.FLTNAME)THEN
            INCLUDEINCOMPOSITE=0
         ENDIF
         WRITE(6,'(A13,1X,A13,1X,I1)')
     +        SUMMARYFLIGHTID,FLTNAME,INCLUDECOMPOSITE
         DO K=1,4
            READ(LUIN,'(A1)')CDUMMY
         ENDDO
         READ(LUIN,'(A15,3I2)')CDUMMY15,IHSS,IMSS,ISSS
         DO K=1,3
            READ(LUIN,'(A1)')CDUMMY
         ENDDO
         READ(LUIN,'(A13,3I2)')CDUMMY13,IHES,IMES,ISES
         DO K=1,5
            READ(LUIN,'(A1)')CDUMMY
         ENDDO
         READ(LUIN,'(A25,2A1)')CDUMMY25,ACCEPTABLE1,ACCEPTABLE2
         CLOSE(LUIN)
         WRITE(6,*)'ACCEPTABLE1,ACCEPTABLE2 = ',
     1              ACCEPTABLE1,ACCEPTABLE2
         IF(ACCEPTABLE1.NE.'1'.AND.ACCEPTABLE2.NE.'1')
     1     INCLUDEINCOMPOSITE=0
         STIMES=IHSS*3600.+IMSS*60.+ISSS*1.
         ETIMES=IHES*3600.+IMES*60.+ISES*1.
         WRITE(6,*)'STIME,STIMES,ETIME,ETIMES,STIME1,ETIME2 = ',
     1        STIME,STIMES,ETIME,ETIMES,STIME1,ETIME2
         IF(STIMES.NE.STIME.OR.ETIMES.NE.ETIME)INCLUDEINCOMPOSITE=0
      ENDIF
      WRITE(6,*)'INCLUDEINCOMPOSITE = ',INCLUDEINCOMPOSITE
      CALL WRITENETCDF(IMAX,JMAX,KMAX,SX,SY,SZ,XZ,YZ,ZZ,
     1 U,V,W,DBZ,X,Y,Z,KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,
     1 CREATIME,EXTRA1,KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,
     1 STIME,ETIME,OLAT,OLON,ROT,RA,CO1,CO2,
     1 AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,
     1 EXTRA7,U2,OUTFILNAM,WS,RW,TW,ICALLTEST,
     1 UWRITE,VWRITE,DBZWRITE,UWRITE1,VWRITE1,DBZWRITE1,MAXDBZ,
     1 IconvertMD,
     1 INCLUDEINCOMPOSITE,XKM,YKM,U1,V1,W1,DBZ1,WS1,TW1,RW1,LAT,LON,
     1 VORT,DISPLACEMENT_FACTOR)
c      CALL WRITEDATA(LUOUT,U,V,W,DBZ,IMAX,JMAX,KMAX)
      CLOSE(80)
      CLOSE(81)
C GO TO 1 AND SEE IF THERE ARE ANY MORE FILES TO CONVERT
      GO TO 1
999   STOP
      END
      SUBROUTINE ALLWIND(SX,SY,XZ,YZ,IMAX,JMAX,KMAX,U,V,WS,TW,RW,VORT)
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),WS(IMAX,JMAX,KMAX)
      REAL TW(IMAX,JMAX,KMAX),RW(IMAX,JMAX,KMAX),VORT(IMAX,JMAX,KMAX)
      DO K=1,KMAX
         DO J=1,JMAX
            Y=-.5*SY+J*SY-YZ
            DO I=1,IMAX
               VORT(I,J,K)=-999.9
               IF(I.GT.1.AND.I.LT.IMAX.AND.J.GT.1.AND.J.LT.JMAX)THEN
                  IF(U(I,J+1,K).GT.-900..AND.U(I,J-1,K).GT.-900..AND.
     +               V(I+1,J,K).GT.-900..AND.V(I-1,J,K).GT.-900.)THEN
                     VORT(I,J,K)=(V(I+1,J,K)-V(I-1,J,K))/SX-
     +                           (U(I,J+1,K)-U(I,J-1,K))/SY
                     VORT(I,J,K)=VORT(I,J,K)
                  ENDIF
               ENDIF
               X=.5*SX+I*SY-XZ
               RADIUS=SQRT(X*X+Y*Y)
               U1=U(I,J,K)
               V1=V(I,J,K)
               IF(U1.GT.-900)THEN
                  WS(I,J,K)=SQRT(U1*U1+V1*V1)
                  TW(I,J,K)=(V1*X-U1*Y)/RADIUS
                  RW(I,J,K)=(U1*X+V1*Y)/RADIUS
               ELSE
                  WS(I,J,K)=-999.9
                  TW(I,J,K)=-999.9
                  RW(I,J,K)=-999.9
               ENDIF
            ENDDO
         ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE READHEADER(LU,FILNAM,KEYWORD,FLTNAME,
     + STMNAME,RADAR,EXPERIMENT,
     + CREATIME,EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,STIME,ETIME,OLAT,OLON,
     + SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,CO2,AZMCOR,ELCOR,THRESH,
     + POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,EXTRA7)
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80
      INTEGER IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      OPEN(LU,FILE=FILNAM,STATUS='OLD',FORM='UNFORMATTED')
      READ(LU)KEYWORD,FLTNAME,STMNAME,
     + RADAR,EXPERIMENT,CREATIME,
     + EXTRA1,IMAX,JMAX,KMAX,KOUNT,NMOSM,
     + IUNFLD,IATTEN,FLAG,EXTRA2,
     + EXTRA3,STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      RETURN
      END
      SUBROUTINE LDPLN(LU,U,V,W,DBZ,IMAX,JMAX,KMAX,IUV,ZZ,SZ)
c      USE NETCDF
      REAL U(IMAX,JMAX,KMAX),V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL DBZ(IMAX,JMAX,KMAX)
      INTEGER*2 IU(800),IV(800),IW(800),IDB(800),IDV(800)
      REAL RU(800),RV(800),RW(800),RDV(800)
      FLAG=-999.9
      WRITE(6,*)'INSIDE LDPLNW'
      WRITE(6,*)'IMAX,JMAX,KMAX,IUV = ',IMAX,JMAX,KMAX,IUV
      DO K=1,KMAX
       DO J=1,JMAX
        IF(IUV.EQ.0)THEN
         READ(LU)(IU(I),IV(I),IW(I),IDB(I),IDV(I),I=1,IMAX)
c         write(6,*)'j,k,iu = ',(j,k,iu(i),i=1,imax)
c         write(6,*)'j,k,iv = ',(j,k,iv(i),i=1,imax)
c         write(6,*)'j,k,iw = ',j,k,(iw(i),i=1,imax)
c         write(6,*)'j,k,idb = ',j,k,(idb(i),i=1,imax)
c         write(6,*)'j,k,idv = ',(j,k,idv(i),i=1,imax)
        ELSE
         READ(LU)(RU(I),RV(I),RW(I),IDB(I),RDV(I),I=1,IMAX)
        ENDIF
        DO I=1,IMAX
         IF(IDB(I).GT.-1000)THEN
          DBZZ=IDB(I)*.1
          DBZ(I,J,K)=DBZZ
         ELSE
          DBZZ=FLAG
          DBZ(I,J,K)=FLAG
         ENDIF
         IF(IUV.EQ.0)THEN
          IF(IU(I).LT.-9990)THEN
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
          ELSE
           WDR=IU(I)*.1
           WSP=IV(I)*.1
           XU=-SIN(WDR*3.14159/180.)*WSP
           XV=-COS(WDR*3.14159/180.)*WSP
           U(I,J,K)=XU
           V(I,J,K)=XV
          ENDIF
C
C MODIFICATION ON 1 OCTOBER 2021 TO FLAG BOTTOM LEVEL TO AVOID
C IT'S MISUSE
C
          IF(IW(I).GT.-9990.AND.DBZZ.GT.FLAG)THEN
           W(I,J,K)=IW(I)*.01
          ELSE
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
          ENDIF
          IF(K.EQ.1)THEN
             U(I,J,K)=FLAG
             V(I,J,K)=FLAG
             W(I,J,K)=FLAG
             DBZ(I,J,K)=FLAG
          ENDIF
c          IF(U(I,J,K).GT.FLAG.AND.W(I,J,K).LE.FLAG)THEN
c           WRITE(6,*)'I,J,K,U,V,W,IU,IV,IW = ',
c     1    I,J,K,U(I,J,K),V(I,J,K),W(I,J,K),IU(I),IV(I),IW(I)
c          ENDIF
         ELSE
          IF(RU(I).GT.FLAG.AND.RV(I).GT.FLAG.AND.RW(I).GT.FLAG)THEN
           U(I,J,K)=RU(I)
           V(I,J,K)=RV(I)
           DBZ(I,J,K)=IDB(I)*.1
           W(I,J,K)=RW(I)
          ELSE
           U(I,J,K)=FLAG
           V(I,J,K)=FLAG
           W(I,J,K)=FLAG
           DBZ(I,J,K)=FLAG
          ENDIF
          IF(K.EQ.1)THEN
             U(I,J,K)=FLAG
             V(I,J,K)=FLAG
             W(I,J,K)=FLAG
             DBZ(I,J,K)=FLAG
          ENDIF
         ENDIF
        ENDDO
c        WRITE(6,*)'J,K,U = ',J,K,(U(I,J,K),I=1,IMAX)
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE WRITENETCDF(IMAX,JMAX,KMAX,SX,SY,SZ,XZ,YZ,ZZ,
     1 U,V,W,DBZ,X,Y,Z,KEYWORD,FLTNAME,STMNAME,RADAR,EXPERIMENT,
     1 CREATIME,EXTRA1,KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3,
     1 STIME,ETIME,OLAT,OLON,ROT,RA,CO1,CO2,
     1 AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,EXTRA6,
     1 EXTRA7,U2,OUTFILNAM,WS,RW,TW,ICALLTEST,
     1 UWRITE,VWRITE,DBZWRITE,UWRITE1,VWRITE1,DBZWRITE1,MAXDBZ,
     1 IconvertMD,
     1 INCLUDEINCOMPOSITE,XKM,YKM,U1,V1,W1,DBZ1,WS1,TW1,RW1,LAT,LON,
     1 VORT,DISPLACEMENT_FACTOR)
C
C ALERTS COMPILER THAT THIS ROUTINE WILL REFER TO MODULES WITHIN
C THE FILE netcdf.mod WHICH IN MY CASE IS IN /usr/include/mpich-x86_64
C WHICH IS INSTALLED ON THIS CENTOS 7 SYSTEM USING yum
C I USE THE FOLLOWING COMMAND:
C gfortran -O -o windtonetcdf windtonetcdf.f -I/usr/include 
C -I/usr/include/mpich-x86_64 -lnetcdf -lnetcdff
C
      USE NETCDF
      CHARACTER DUMMY*80,ONEBYONE(80)*1,FIRSTYESNO*3,DUMMY2*160
      CHARACTER RTXY*2,ATTEN*1
      CHARACTER KEYWORD*4,FLTNAME*8,STMNAME*12,RADAR*4,EXPERIMENT*32
      CHARACTER CREATIME*32,EXTRA1*28,FILNAM*80,OUTFILNAM*80
      CHARACTER TIMESIG*13
      CHARACTER OUTFILERADAR*80
      INTEGER KOUNT,NMOSM,IUNFLD,IATTEN,FLAG,EXTRA2,EXTRA3
      REAL STIME,ETIME,OLAT,OLON,SX,SY,SZ,XZ,YZ,ZZ,ROT,RA,CO1,
     + CO2,AZMCOR,ELCOR,THRESH,POWERT,BIEL,AZBIEL,ETIME1,STIME2,
     + EXTRA6,EXTRA7
      INTEGER IKEYWORD,IFLTNAME,ISTMNAME,IRADAR,IEXPERIMENT
      INTEGER ICREATIME,IKOUNT,INMOSM,IIUNFLD,IIATEN,IFLAG,IEXTRA2
      INTEGER IEXTRA3,ISTIME,IETIME,IOLAT,IOLON,ISX,ISY,ISZ
      INTEGER IXZ,IYZ,IZZ,IROT,IRA,ICO1,ICO2,IAZMCOR,IELCOR,ITHRESH
      INTEGER IPOWERT,IBIEL,IAZBIEL,IETIME1,ISTIME2,IEXTRA6,IEXTRA7
      INTEGER IMAX,JMAX,KMAX,ITMAX
      INTEGER IDIMIDS(4),ICOUNT(4),ISTART(4),NCID,ICOUNT1(1)
      INTEGER ISTART1(1)
      INTEGER IDIMIDS3(3),ICOUNT3(3),ISTART3(3)
      INTEGER ISTARTX,ISTARTY,ISTARTZ,test
      INTEGER ICOUNTX,ICOUNTY,ICOUNTZ
      INTEGER IXVARID,IYVARID,IZVARID,ITVARID,INVARID,INC(1)
      INTEGER ILONVARID,ILATVARID
      INTEGER IXDIMID,IYDIMID,IZDIMID,ITDIMID
      INTEGER IUVARID,IVVARID,IWVARID,IDBZVARID,ISTAT,IVORTVARID
      INTEGER IULEVELVARID(37),IVLEVELVARID(37),IDBZLEVELVARID(37)
      INTEGER IWSVARID,ITWVARID,IRWVARID,IANALYSISLEVEL
      CHARACTER ULEVELC(37)*8,VLEVELC(37)*8,LONGNAMEU*41,LONGNAMEV*43
      CHARACTER LONGNAMEDBZ*43
      CHARACTER TIMEWRITE*10,DATEWRITE*8,ZONEWRITE*5
      CHARACTER DBZLEVELC(37)*10
      INTEGER INCLUDEINCOMPOSITE,IBST,INOB
      REAL UWRITE(IMAX,JMAX,KMAX),VWRITE(IMAX,JMAX,KMAX)
      REAL DBZWRITE(IMAX,JMAX,KMAX)
      REAL UWRITE1(IMAX,JMAX),VWRITE1(IMAX,JMAX),DBZWRITE1(IMAX,JMAX)
C      INTEGER NF90_CLASSIC_MODE
      REAL X(IMAX),Y(JMAX),Z(KMAX),U(IMAX,JMAX,KMAX),U2(KMAX,JMAX,IMAX)
      REAL XKM(IMAX),YKM(JMAX),LAT(IMAX,JMAX),LON(IMAX,JMAX)
      REAL V(IMAX,JMAX,KMAX),W(IMAX,JMAX,KMAX)
      REAL V1(IMAX,JMAX,KMAX),W1(IMAX,JMAX,KMAX)
      REAL U1(IMAX,JMAX,KMAX),VORT(IMAX,JMAX,KMAX)
      REAL DBZ(IMAX,JMAX,KMAX),TT(1),VALID_RANGE(2),VALID_RANGE_DBZ(2)
      REAL DBZ1(IMAX,JMAX,KMAX)
      REAL TW(IMAX,JMAX,KMAX),RW(IMAX,JMAX,KMAX),WS(IMAX,JMAX,KMAX)
      REAL TW1(IMAX,JMAX,KMAX),RW1(IMAX,JMAX,KMAX),WS1(IMAX,JMAX,KMAX)
      REAL MAXDBZ(IMAX,JMAX)
      DOUBLE PRECISION DSECS,SECS
      REAL DFLAG,NULLW
      REAL VALID_MIN,VALID_MAX,UMOVE,VMOVE
      CHARACTER*80 NETCDFPATH,OUTFILEWIND
      CHARACTER*39 WRITECHAR
      CHARACTER*2 YEAR,MONTH,DAY,HR,MN
      CHARACTER YYYY*19
      CHARACTER*100 NOTE1
      INTEGER IconvertMD(IMAX,JMAX)
      CHARACTER STORMNAME*12
      LOGICAL PARAMETERSFILEEXISTS
c      NF90_FLOAT=32
C
C OUTFILNAM IS THE NAME OF THE OUTPUT 3D NETCDF FILE (READ IN MAIN PROGRAM)
C
      READ(OUTFILNAM,'(A13)')TIMESIG
C
C FROM OUTFILE NAME COME UP WITH NAMES FOR THE NETCDF FILES FOR INPUT INTO
C AWIPS-II
C
      WRITE(OUTFILERADAR,'("AWIPSMaxdb_",A13,"z.nc")')TIMESIG
      WRITE(OUTFILEWIND,'("AWIPSWindComponents_",A13,"z.nc")')TIMESIG
C
C SETTING UP THE ARRAYS FOR THE LAT-LON GRID, STARTING FROM THE CARTESIAN
C
      DO K=1,KMAX
         DO J=1,JMAX
            DO I=1,IMAX
               UWRITE(I,J,K)=-999.9
               VWRITE(I,J,K)=-999.9
               DBZWRITE(I,J,K)=-999.9
               U1(I,J,K)=U(I,J,K)
               V1(I,J,K)=V(I,J,K)
               W1(I,J,K)=W(I,J,K)
               DBZ1(I,J,K)=DBZ(I,J,K)
               WS1(I,J,K)=WS(I,J,K)
               TW1(I,J,K)=TW(I,J,K)
               RW1(I,J,K)=RW(I,J,K)
            ENDDO
         ENDDO
      ENDDO
C
C CHECK FORTRAN NETCDF FOR NETCDFMODE
C
      NETCDFMODE=0
C
C CREATE NETCDF FILE FOR FULLY-3D NON-AWIPS-II NETCDF FILE
C
      ISTAT=NF90_CREATE(OUTFILNAM,NF90_CLASSIC_MODEL,NCID)
      WRITE(6,*)'NF90_FORMAT_NETCDF4 = ',NF90_FORMAT_NETCDF4
      WRITE(6,*)'CREATE,ISTAT,NCID = ',ISTAT,NCID
C
C SET DATA FLAG FOR VARIABLES
C
      DFLAG=-999.9
C
C SET VALID RANGES FOR REFLECTIVITY VARIABLES
C
      VALID_RANGE_DBZ(1)=-31.9
      VALID_RANGE_DBZ(2)=70.
C
C SET VALID RANGES FOR WIND VELOCITIES
C
      VALID_RANGE(1)=-900.
      VALID_RANGE(2)=900.
C
C GENERIC VALID MIN AND MAX?
C
      VALID_MIN=-900.
      VALID_MAX=900.
C
C CONVERT Y COORDINATE (DISTANCE FROM CENTER) TO LATITUDE
C 111.111 KM = 1 DEG SINCE 10,000 KM IS DISTANCE FROM POLE TO EQUATOR
C
C OLAT AND OLON ARE THE LATITUDE AND LONGITUDE OF THE STORM CENTER 
C
      DO J=1,JMAX
         Y(J)=(.5+FLOAT(J-1))*SY-YZ
         YKM(J)=Y(J)
         Y(J)=OLAT+Y(J)/111.111
         DO I=1,IMAX
            LAT(I,J)=Y(J)
         ENDDO
      ENDDO
C
C XKM AND YKM ARE THE DISTANCES (KM) EAST AND NORTH OF (OLAT,OLON)
C X IS THE LONGITUDE OF THE GRID FOR AWIPS AND IS BASED UPON THE
C MAXIMUM LATITUDE.  THIS PERMITS A SINGLE-DIMENSION VARIABLE FOR
C LATITUDE AND LONGITUDE IN THE GRID FOR AWIPS
C REMAP WILL INTERPOLATE VARIABLES FROM XKM,YKM TO X,Y
C XKM,YKM IS USED FOR FULLY 3D NETCDF FILES AND X,Y FOR AWIPS
C LAT AND LON ARE THE ACTUAL LATITUDES AND LONGITUDES FOR THE XKM,YKM POINTS
C
      DO I=1,IMAX
         X(I)=(.5+FLOAT(I-1))*SX-XZ
         XKM(I)=X(I)
         X(I)=OLON+X(I)/(COS(Y(JMAX)*3.14159/180.)*111.111)
         DO J=1,JMAX
            LON(I,J)=OLON+XKM(I)/(COS(Y(J)*3.14159/180.)*111.111)
         ENDDO
      ENDDO
      DO K=1,KMAX
       Z(K)=(K-1)*SZ+ZZ
      ENDDO
C     
C REMAP ALL 7 VARIABLES FROM THE X-Y COORDINATE SYSTEM TO THE LAT-LON
C COORDINATE SYSTEM SET ABOVE.  PRESENTLY THESE ARE ONLY USE FOR THE
C AWIPS-II
C
      CALL REMAP(U1,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(V1,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(W1,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(RW1,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(TW1,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(WS1,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
      CALL REMAP(DBZ1,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
C
C FIND THE MAXIMUM VALUE FOR EACH ARRAY INDEX OF (I,J), AND THEREFORE
C ALONG K, THE VERTICAL DIMENSION
C
      MAXDBZ(:,:)=MAXVAL(DBZ1,3)
c      WHERE(MAXDBZ(:,:)<-30.)MAXDBZ(:,:)=0.0
C     IconvertMAXDBZ=MAXDBZ(:,:)
      ITMAX=1
C
C DEFINE THE 4 VARIABLES WHICH ARE THE DIMENSIONS OF THE 3D GRID
C DEFINE THE TIME DIMENSION WHICH IN THIS CASE HAS A SIZE OF ONE
C
      ISTAT=NF90_DEF_DIM(NCID,"time",ITMAX,ITDIMID)
      WRITE(6,*)'IDIM1,ISTAT = ',ISTAT
C
C DEFINE THE HEIGHT DIMENSION WHICH HAS A SIZE OF KMAX
C
      ISTAT=NF90_DEF_DIM(NCID,"level",KMAX,IZDIMID)
      WRITE(6,*)'IDIM2,ISTAT = ',ISTAT
C
C DEFINE THE NORTH-SOUTH CARTESIAN GRID DIMENSION WHICH HAS A SIZE OF JMAX
C
      ISTAT=NF90_DEF_DIM(NCID,"y",JMAX,IYDIMID)
      WRITE(6,*)'IDIM3,ISTAT = ',ISTAT
C
C DEFINE THE EAST-WEST CARTESIAN GRID DIMENSION WHICH HAS A SIZE OF IMAX
C
      ISTAT=NF90_DEF_DIM(NCID,"x",IMAX,IXDIMID)
      WRITE(6,*)'IDIM4,ISTAT = ',ISTAT
C
C PLACE THE DIMENSIONS IN VARIABLES IN IDIMIDS (TIME + 3D) AND
C IDIMIDS3 (TIME + 2D---FOR AWIPS-II)
C
C 3D
C
      IDIMIDS(1)=ITDIMID
      IDIMIDS(2)=IZDIMID
      IDIMIDS(3)=IYDIMID
      IDIMIDS(4)=IXDIMID
C 
C 2D--AWIPS-II
C
      IDIMIDS3(1)=ITDIMID
      IDIMIDS3(2)=IYDIMID
      IDIMIDS3(3)=IXDIMID
C
C DEFINE THE TWO-DIMENSIONAL(PLUS TIME) U AND V VARIABLES FOR EACH HEIGHT THAT
C ARE IN THE AWIPS-II FILE.
C EXAMPLES:  u_00500, u_01000,....u_18000
C DBZLEVELS ARE SET UP FOR WHEN NHC WILL TAKE DBZ IN THE THE 2D+TIME AWIPS-II
C
      DO K=2,KMAX
         KK=K
c         WRITE(6,*)NINT(Z(K)*1000.)
         WRITE(ULEVELC(K),'("u_",I5.5)')NINT(Z(K)*1000.)
c         WRITE(6,*)'ULEVELC FOR LEVEL ',K,'= ',ULEVELC(K)
         WRITE(VLEVELC(K),'("v_",I5.5)')NINT(Z(K)*1000.)
c         WRITE(6,*)'VLEVELC FOR LEVEL ',K,'= ',VLEVELC(K)
         WRITE(DBZLEVELC(K),'("dBZ_",I5.5)')NINT(Z(K)*1000.)
         KK=K
C
C Setting up 3D UWRITE and VWRITE for later writing of
C 2D u- and v-component wind variables
C DBZ1 CAN BE USED LATER IN AWIPS-II FILE WHEN AGREED TO
C
         CALL U1U21LEVEL(U1,UWRITE,KK,IMAX,JMAX,KMAX)
         CALL U1U21LEVEL(V1,VWRITE,KK,IMAX,JMAX,KMAX)
         CALL U1U21LEVEL(DBZ1,DBZWRITE,KK,IMAX,JMAX,KMAX)
C
C Conversion of UWRITE AND VWRITE TO KNOTS WHILE LEAVING U AND V IN M/S
C
         DO J=1,JMAX
            DO I=1,IMAX
               IF(UWRITE(I,J,K).GT.-900.)THEN
                  UWRITE(I,J,K)=UWRITE(I,J,K)*1.94384
                  VWRITE(I,J,K)=VWRITE(I,J,K)*1.94384
               ENDIF
            ENDDO
         ENDDO
C END OF AWIPS INITIAL WIND CONFIGURATION
      ENDDO
C 
C U1U2 TRANSPOSES THE MATRICES THE 3D MATRICES, FIRST ARGUMENT IS BOTH 
C INPUT AND OUTPUT AND U2 IS USED FOR THE TRANSPOSITION
C
      CALL U1U2(U,U2,IMAX,JMAX,KMAX)
      CALL U1U2(V,U2,IMAX,JMAX,KMAX)
      CALL U1U2(W,U2,IMAX,JMAX,KMAX)
      CALL U1U2(RW,U2,IMAX,JMAX,KMAX)
      CALL U1U2(TW,U2,IMAX,JMAX,KMAX)
      CALL U1U2(WS,U2,IMAX,JMAX,KMAX)
      CALL U1U2(DBZ,U2,IMAX,JMAX,KMAX)
      CALL U1U2(VORT,U2,IMAX,JMAX,KMAX)
      CALL U1U2(U1,U2,IMAX,JMAX,KMAX)
      CALL U1U2(V1,U2,IMAX,JMAX,KMAX)
      CALL U1U2(W1,U2,IMAX,JMAX,KMAX)
      CALL U1U2(RW1,U2,IMAX,JMAX,KMAX)
      CALL U1U2(TW1,U2,IMAX,JMAX,KMAX)
      CALL U1U2(WS1,U2,IMAX,JMAX,KMAX)
      CALL U1U2(DBZ1,U2,IMAX,JMAX,KMAX)
C
C INITIAL AWIPS MAX DBZ CONFIGURATION
C
      CALL U1U2(MAXDBZ,U2,IMAX,JMAX,1)
      CALL U1U2(LAT,U2,IMAX,JMAX,1)
      CALL U1U2(LON,U2,IMAX,JMAX,1)
C
C END OF INITIAL CONFIGURATION
C
C DEFINE THE TIME VARIABLE THAT IS USED IN THE TIME DIMENSION
C
      WRITE(6,*)'NCID,IDIMIDS = ',NCID,IDIMIDS
      ISTAT=NF90_DEF_VAR(NCID,"time",NF90_FLOAT,ITDIMID,ITVARID)
C
C WRITE THE UNITS DESCRIPTION FOR THE TIME AS USED BY HRD
C THAT IS, SECONDS SINCE 0000 UTC ON THE DAY THE FLIGHT BEGAN
C
C GET THE YEAR (4DIGITS), MONTH (2DIGITS) AND DAY (2DIGITS) FROM NAME
C OF HRD "W" FILE
C
      READ(FLTNAME,'(3I2)')IYEAR,IMONTH,IDAY
      IF(IYEAR.GT.50.)THEN
       IYEAR=IYEAR+1900
      ELSE
       IYEAR=IYEAR+2000
      ENDIF
C
C WRITECHAR IS THE UNITS DESCRIPTION FOR "HRD TIME"
C
      WRITE(WRITECHAR,8777)IYEAR,IMONTH,IDAY
 8777 FORMAT('seconds since ',i4,'-',i2.2,'-',i2.2,' 00:00:00 00:00')
      WRITE(6,8777)IYEAR,IMONTH,IDAY
C
C ADD ATTRIBUTES FOR VARIABLE "time"
C
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'UNITS',
     1WRITECHAR)
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'STANDARD_NAME','time')
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'AXIS',"T")
C
C DEFINE THE HEIGHT VARIABLE "level"
C
      ISTAT=NF90_DEF_VAR(NCID,"level",NF90_FLOAT,IZDIMID,IZVARID)
C
C ADD ATTRIBUTES FOR VARIABLE "level"
C
      ISTAT=NF90_PUT_ATT(NCID,IZDIMID,'UNITS','km')
      ISTAT=NF90_PUT_ATT(NCID,IZDIMID,'STANDARD_NAME','level')
      ISTAT=NF90_PUT_ATT(NCID,IZDIMID,'AXIS',"Z")
C
C DEFINE THE NORTH-SOUTH CARTESIAN VARIABLE "y"
C
      ISTAT=NF90_DEF_VAR(NCID,"y",NF90_FLOAT,IYDIMID,IYVARID)
C 
C ADD ATTRIBUTES FOR VARIABLE "y"
C
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'UNITS','km-north-of-center')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'STANDARD_NAME','y')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'AXIS',"YKM")
C
C DEFINE THE EAST-WEST CARTESIAN VARIABLE "x"
C
      ISTAT=NF90_DEF_VAR(NCID,"x",NF90_FLOAT,IXDIMID,IXDIMID)
C
C ADD ATTRIBUTES FOR VARIABLE "x"
C
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'UNITS','km-east-of-center')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'STANDARD_NAME','x')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'AXIS',"XKM")
      WRITE(6,*)'IXDIMID,IYDIMID,IZDIMID,ITDIMID = ',
     1 IXDIMID,IYDIMID,IZDIMID,ITDIMID
C
C DEFINE VARIABLE "INCLUDEINCOMPOSITE" WHICH TELL HRD REAL-TIME RADAR
C GRAPHICS SOFTWARE WHETHER TO INCLUDE THIS ANALYSIS IN FLIGHT COMPOSITE
C
      ISTAT=NF90_DEF_VAR(NCID,"includeincomposite",NF90_INT,
     + ITDIMID,INVARID)
      WRITE(6,*)'def_var_includeincomposite, ISTAT = ',ISTAT
C
C INPUT INCLUDEINCOMPOSITE ATTRIBUTE
C
      ISTAT=NF90_PUT_ATT(NCID,INVARID,'1_OR_0','integer')
      WRITE(6,*)'PUT_ATT includeincomposite, ISTAT = ',ISTAT
C
C DEFINE VORTICITY
C
      ISTAT=NF90_DEF_VAR(NCID,"VORT",NF90_FLOAT,IDIMIDS,IVORTVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IVORTVARID = ',ISTAT,IDIMIDS,IVORTVARID
C
C INPUT ATTRIBUTES FOR VORTICITY NETCDF VARIABLE
C
      ISTAT=NF90_PUT_ATT(NCID,IVORTVARID,'UNITS','.001/seconds')
      ISTAT=NF90_PUT_ATT(NCID,IVORTVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IVORTVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IVORTVARID,'valid_max',VALID_MAX)
C
C DEFINE EAST-WEST WIND COMPONENENT U
C
      ISTAT=NF90_DEF_VAR(NCID,"U",NF90_FLOAT,IDIMIDS,IUVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IUVARID = ',ISTAT,IDIMIDS,IUVARID
C
C INPUT ATTRIBUTES FOR EAST-WEST WIND COMPONENT U NETCDF VARIABLE
C
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'valid_max',VALID_MAX)
C
C DEFINE NORTH-SOUTH WIND COMPONENENT V NETCDF VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"V",NF90_FLOAT,IDIMIDS,IVVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IVVARID = ',ISTAT,IDIMIDS,IVVARID
C
C DEFINE VERTICAL-WIND W COMPONENENT NETCDF VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"W",NF90_FLOAT,IDIMIDS,IWVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IWVARID = ',ISTAT,IDIMIDS,IWVARID
C
C DEFINE REFLECTIVITY NETCDF VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"REFLECTIVITY",
     1 NF90_FLOAT,IDIMIDS,IDBZVARID)
C
C DEFINE WIND-SPEED NETCDF VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"WIND_SPEED",
     1 NF90_FLOAT,IDIMIDS,IWSVARID)
C
C DEFINE LATITUDE NETCDF VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"LATITUDE",
     1 NF90_FLOAT,IDIMIDS3,ILATVARID)
C
C DEFINE LONGITUDE NETCDF VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"LONGITUDE",
     1 NF90_FLOAT,IDIMIDS3,ILONVARID)
C
C DEFINE RADIAL WIND SPEED NETCDF VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"RADIAL_WIND",
     1 NF90_FLOAT,IDIMIDS,IRWVARID)
C
C DEFINE TANGENTIAL WIND SPEED NETCDF VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"TANGENTIAL_WIND",
     1 NF90_FLOAT,IDIMIDS,ITWVARID)
      WRITE(6,*)'ISTAT,IDIMIDS,IWSVARID = ',ISTAT,IDIMIDS,IWSVARID
      WRITE(6,*)'ISTAT,IDIMIDS,IRWVARID = ',ISTAT,IDIMIDS,IRWVARID
      WRITE(6,*)'ISTAT,IDIMIDS,ITWVARID = ',ISTAT,IDIMIDS,ITWVARID
      WRITE(6,*)'ISTAT,IDIMIDS,IDBZVARID = ',ISTAT,IDIMIDS,IDBZVARID
C
C ENTER ATTRIBUTES FOR NETCDF V-COMPONENT VARIABLE
C
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'valid_max',VALID_MAX)
C
C ENTER ATTRIBUTES FOR NETCDF W-COMPONENT VARIABLE
C
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'valid_max',VALID_MAX)
C
C ENTER ATTRIBUTES FOR NETCDF RADAR-REFLECTIVITY VARIABLE
C
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'valid_min',-31)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'valid_max',100)
C
C ENTER ATTRIBUTES FOR NETCDF VARIABLE WIND SPEED
C

      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'valid_max',VALID_MAX)
C
C ENTER ATTRIBUTES FOR NETCDF VARIABLE RADIAL WIND
C
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'valid_max',VALID_MAX)
C
C ENTER ATTRIBUTES FOR NETCDF VARIABLE TANGENTIAL WIND
C
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'UNITS','meters per second')
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'valid_min',VALID_MIN)
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'valid_max',VALID_MAX)
C
C ENTER ATTRIBUTES FOR NETCDF VARIABLES LONGITUDE AND LONGITUDE
C THESE ARE THE LATITUDES AND LONGITUDES FOR ALL THE CARTESIAN GRID POINTS
C FROM XKM AND YKM
C
      ISTAT=NF90_PUT_ATT(NCID,ILONVARID,'UNITS','degrees')
      ISTAT=NF90_PUT_ATT(NCID,ILATVARID,'UNITS','degrees')
C
C ENTER MISSING VALUE ATTRIBUTES FOR ALL THE NETCDF WIND AND DBZ VARIABLES
C
      ISTAT=NF90_PUT_ATT(NCID,IVORTVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IUVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IVVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IWVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IWSVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,IRWVARID,'missing_value',DFLAG)
      ISTAT=NF90_PUT_ATT(NCID,ITWVARID,'missing_value',DFLAG)
C
C COPYING OVER ATTRIBUTES IN THE "W" FILE AS IS TO GLOBAL METADATA
C IT MUST BE NOTED THAT MANY OF THE VALUES BELOW ARE 
      NOTE1='0-KM WIND AND REFLECTIVITY NOT REPRESENTATIVE OF '//
     +      'SURFACE--REMOVED'
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"NOTE1",NOTE1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"KEYWORD",KEYWORD)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"FLTNAME",FLTNAME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"STMNAME",STMNAME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"RADAR",RADAR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXPERIMENT",EXPERIMENT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"CREATIME",CREATIME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA1",EXTRA1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"KOUNT",KOUNT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"NMOSM",NMOSM)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"IUNFLD",IUNFLD)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"IATTEN",IATTEN)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA2",EXTRA2)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA3",EXTRA3)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"START_TIME",STIME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"END_TIME",ETIME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ORIGIN_LATITUDE",OLAT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ORIGIN_LONGITUDE",OLON)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"FLAG",FLAG)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "EAST_WEST_RESOLUTION_KM",SX)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "NORTH_SOUTH_RESOLUTION_KM",SY)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "VERTICAL_RESOLUTION_KM",SZ)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "ORIGIN_EAST_WEST_DISTANCE_FROM_LOWER_LEFT_CORNER_KM",XZ)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "ORIGIN_NORTH_SOUTH_DISTANCE_FROM_LOWER_LEFT_CORNER_KM",YZ)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     1 "HEIGHT_OF_LOWEST_HORIZONTAL_LEVEL_KM",ZZ)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ROTATION_IN_DEGREES",ROT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"RA",RA)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"CO1",CO1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"CO2",CO2)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"AZMCOR",AZMCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ELCOR",ELCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"THRESH",THRESH)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"POWERT",POWERT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"BIEL",BIEL)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"AZBIEL",AZBIEL)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"STIME2",STIME2)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ETIME1",ETIME1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA6",EXTRA6)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"EXTRA7",EXTRA7)
C 
C THE NEXT SECTION LOOKS FOR A "parameters.txt" FILE THAT IS MADE DURING
C A PRODUCTION RUN OF THE AUTOMATED QC/ANALYSIS 
C THESE PROVIDE FURTHER METADATA FOR A FUTURE USER REGARDING THE PARAMETERS 
C THAT WERE SET WITH UNDERSTANDABLE VARIABLE NAMES
C
      PARAMETERSECS=-1
      INQUIRE(FILE='parameters.txt',EXIST=PARAMETERSFILEEXISTS)
      IF(PARAMETERSFILEEXISTS.EQV..FALSE.)GO TO 3782
      OPEN(81,FILE='parameters.txt')
      READ(81,*,ERR=3782,END=3782)IYEAR,IMONTH,IDAY
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"FLIGHT YEAR",IYEAR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"FLIGHT MONTH",IMONTH)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"FLIGHT DAY",IDAY)
      READ(81,'(A12)',ERR=3782,END=3782)STORMNAME
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"STORM NAME",STORMNAME)
      READ(81,'(3I2,X,3I2)',ERR=3782,END=3782)IHS,IMS,ISS,IHE,IME,ISE
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ANALYSIS START HOUR",IHS)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "ANALYSIS START MINUTE",IMS)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "ANALYSIS START SECOND",ISS)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ANALYSIS END HOUR",IHE)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "ANALYSIS END MINUTE",IME)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "ANALYSIS END SECOND",ISE)
      READ(81,*,ERR=3782,END=3782)UMOVE,VMOVE
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "NORTHWARD STORM MOTION (METERS PER SECOND)",VMOVE)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "EASTWARD STORM MOTION (METERS PER SECOND)",UMOVE)
      READ(81,'(3I2)',ERR=3782,END=3782)IHC,IMC,ISC
      PARAMETERSECS=IHC*3600+IMC*60+ISC
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"ANALYSIS CENTER HOUR",IHC)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "ANALYSIS CENTER MINUTE",IMC)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "ANALYSIS CENTER SECOND",ISC)
      READ(81,*,ERR=3782,END=3782)IBST,INOB
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "NUMBER OF ORIGINAL DATA BINS OUT FROM RADAR IGNORED AS JUNK",
     + IBST)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +"NUMBER OF ORIGINAL DATA BINS AVERAGED FOR BARGEN-BROWN DE-ALIAS",       
     + INOB)
      READ(81,*,ERR=3782,END=3782)AFTAZMCOR,AFTELCOR,AFTRDEL
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "AFT AZIMUTH CORRECTION (DEGREES)",AFTAZMCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "AFT TILT CORRECTION (DEGREES)",AFTELCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "AFT RANGE DELAY CORRECTION (KM)",AFTRDEL)
      READ(81,*,ERR=3782,END=3782)AFTPCOR,AFTDCOR
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "AFT PITCH CORRECTION (DEGREES)",AFTPCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "AFT DRIFT CORRECTION (DEGREES)",AFTDCOR)
      READ(81,*,ERR=3782,END=3782)FOREAZMCOR,FOREELCOR,FORERDEL
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FORE AZIMUTH CORRECTION (DEGREES)",FOREAZMCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FORE TILT CORRECTION (DEGREES)",FOREELCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FORE RANGE DELAY CORRECTION (KM)",FORERDEL)
      READ(81,*,ERR=3782,END=3782)FOREPCOR,FOREDCOR
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FORE PITCH CORRECTION (DEGREES)",FOREPCOR)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FORE DRIFT CORRECTION (DEGREES)",FOREDCOR)
      READ(81,*,ERR=3782,END=3782)DBZSLOPE
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "INPUT TO OUTPUT DBZSLOPE",DBZSLOPE)
      READ(81,*,ERR=3782,END=3782)SQI
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "SIGNAL QUALITY INDEX DIFFERENT FOR RVP-5 VERSUS LATER",SQI)
C
C BEGIN SECTION DESCRIBING HOW FALL SPEED VARIES BETWEEN RAIN, SNOW, GRAUPEL
C
      READ(81,*,ERR=3782,END=3782)HTMELT,TKMELT
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "HEIGHT OF CENTER OF MELTING BAND (KM)",HTMELT)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "THICKNESS OF MELTING BAND (KM)",TKMELT)
      READ(81,*,ERR=3782,END=3782)ZLOW,ZHIGH
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "REFLECTIVITY BELOW WHICH ALL SNOW (ABOVE MELTING LEVEL) (dBZ)",
     + ZLOW)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "REFLECTIVITY ABOVE WHICH ALL RAIN (ABOVE MELTING LEVEL) (dBZ)",
     +  ZHIGH)
C
C END OF SECTION REGARDING FALL SPEED
C
      READ(81,*,ERR=3782,END=3782)AZMIN,AZMOUT
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "'AVERAGE' HEADING FROM STORM CENTER FOR INBOUND LEG (DEG)",
     +  AZMIN)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "'AVERAGE' HEADING FROM STORM CENTER FOR OUTBOUND LEG (DEG)",
     +  AZMOUT)
      READ(81,*,ERR=3782,END=3782)IANTENNA
      IF(IANTENNA.EQ.1)THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +   "ANTENNA TYPE","NOAA PARABOLIC")
      ELSEIF(IANTENNA.EQ.2)THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +   "ANTENNA TYPE","FRENCH")
      ELSEIF(IANTENNA.EQ.3)THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +   "ANTENNA TYPE","MALIBU P-3 ANTENNA")
      ENDIF
      READ(81,'(A)',ERR=3782,END=3782)DUMMY
c      WRITE(6,'(A)')DUMMY
C
C DETERMINE WHETHER A FIRST PASS GUESS WAS DONE--THIS IS DONE IN ALL CASES
C EXCEPT A MAJOR HURRICANE.  IF DONE GET INTERPOLATION PARAMETERS
C
      IF(DUMMY.EQ.'firstpass'.and.FIRSTPASSTEST.EQ.0)THEN
         FIRSTYESNO='YES'
         READ(81,*,ERR=3782,END=3782)IGAP
         READ(81,*,ERR=3782,END=3782)RRMAX1,RTMAX1,RZMAX1
         READ(81,*,ERR=3782,END=3782)ERMAX1,ETMAX1,EZMAX1
         READ(81,*,ERR=3782,END=3782)FACTRH1,FACTRZ1
         READ(81,*,ERR=3782,END=3782)FACTFILL1
         READ(81,*,ERR=3782,END=3782)RADRAT,RADMAX
      ELSE
         FIRSTYESNO='NO '
         IGAP=1
         RRMAX1=-999.9
         RTMAX1=-999.9
         RZMAX1=-999.9
         ERMAX1=-999.9
         ETMAX1=-999.9
         EZMAX1=-999.9
         FACTRH1=-999.9
         FACTRZ1=-999.9
         FACTFILL1=-999.9
         READ(DUMMY,*)RADRAT,RADMAX
      ENDIF
      WRITE(DUMMY2,'(A)')
     + "WAVE NO. 0 + MEAN-FLOW FIRST PASS DONE? YES OR NO"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FIRSTYESNO)
      WRITE(DUMMY2,'(A,A)')
     + "RADIAL (KM) GAP ON FIRST PASS THROUGH DATA ALLOWED ",
     + "FOR BARGEN-BROWN"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,IGAP)
      WRITE(6,*)'FIRSTYESNO,IGAP = ',FIRSTYESNO,IGAP
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "RADIAL RADIUS OF INFLUENCE (KM) ON WAVE NO. 0-MEAN PASS",
     + RRMAX1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "AZIMUTHAL RADIUS OF INFLUENCE (DEG) ON WAVE NO. 0-MEAN PASS",
     + RTMAX1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "VERTICAL RADIUS OF INFLUENCE (KM) ON WAVE NO. 0-MEAN PASS",
     + RZMAX1)
      WRITE(6,*)'RRMAX1,RTMAX1,RZMAX1 = ',RRMAX1,RTMAX1,RZMAX1
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "RADIAL EFOLD DISTANCE (KM)  ON WAVE NO. 0-MEAN PASS",
     + ERMAX1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "AZIMUTHAL EFOLD DISTANCE (DEG) ON WAVE NO. 0-MEAN PASS",
     + ETMAX1)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "VERTICAL EFOLD DISTANCE (KM) ON WAVE NO. 0-MEAN PASS",
     + EZMAX1)
      WRITE(6,*)'ERMAX1,ETMAX1,EZMAX1 = ',ERMAX1,ETMAX1,EZMAX1
      WRITE(DUMMY2,'(A,A)')
     + "NORMALIZED RADIAL 2-DELTAX HORIZONTAL ",
     + "FILTERING ON WAVE NO. 0-MEAN PASS"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTRH1)
      WRITE(DUMMY2,'(A,A)')
     + "NORMALIZED VERTICAL 2-DELTAX HORIZONTAL ",
     + "FILTERING ON WAVE NO. 0-MEAN PASS"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTRZ1)
      WRITE(DUMMY2,'(A,A)')
     + "NORMALIZED 2-DELTAX ",
     + "FILTERING ON FILLED SPACES IN WAVE NO. 0-MEAN PASS"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTFILL1)
      WRITE(6,*)'FACTRH1,FACTRZ1,FACTFILL1 = ',
     +           FACTRH1,FACTRZ1,FACTFILL1
      WRITE(DUMMY2,'(A,A)')"MASK IS APPLIED OUT TO THIS MANY TIMES ",
     + "THE FLIGHT ALITITUDE OF AIRCRAFT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,RADRAT)
      WRITE(DUMMY2,'(A,A)')"MAXIMUM RADIUS (KM) MASK IS APPLIED",
     + "IF GREATER THAN ABOVE"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,RADMAX)
      WRITE(6,*)'RADRAT,RADMAX = ',RADRAT,RADMAX
      READ(81,*,ERR=3782,END=3782)G4P3RADMIN,GROUNDADJUST
      WRITE(6,*)'G4P3RADMIN,GROUNDADJUST = ',G4P3RADMIN,GROUNDADJUST
      WRITE(DUMMY2,'(A,A)')"MINIMUM RADIUS TO RADAR TO USE DATA"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,G4P3RADMIN)
      WRITE(DUMMY2,'(A,A)')"AMOUNT (KM) TO SUBTRACT FROM AIRCRAFT",
     + "ALTITUDE WHEN DETERMINING SURFACE HEIGHT TO REMOVE"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,GROUNDADJUST)
      READ(81,*,ERR=3782,END=3782)RRMAX,RTMAX,RZMAX
      WRITE(6,*)'RRMAX,RTMAX,RZMAX = ',RRMAX,RTMAX,RZMAX
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "RADIAL RADIUS OF INFLUENCE (KM) FOR SECOND PASS",
     +  RRMAX)
      ISTAT=NF90_PUT_att(NCID,NF90_GLOBAL,
     + "AZIMUTHAL RADIUS OF INFLUENCE (DEG) FOR SECOND PASS",
     +  RTMAX)
      ISTAT=NF90_PUT_att(NCID,NF90_GLOBAL,
     + "VERTICAL RADIUS OF INFLUENCE (KM) FOR SECOND PASS",
     +  RZMAX)
      READ(81,*,ERR=3782,END=3782)ERMAX,ETMAX,EZMAX
      WRITE(6,*)'ERMAX,ETMAX,EZMAX = ',ERMAX,ETMAX,EZMAX
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "RADIAL E-FOLD DISTANCE (KM) FOR SECOND PASS",
     +  ERMAX)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "AZIMUTHAL E-FOLD DISTANCE (DEG) FOR SECOND PASS",
     +  ETMAX)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "VERTICAL E-FOLD DISTANCE (KM) FOR SECOND PASS",
     +  EZMAX)
      READ(81,*,ERR=3782,END=3782)ISIGMET
      WRITE(6,*)'ISIGMET = ',ISIGMET
      IF(ISIGMET.EQ.5)THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"RADAR SYSTEM","RVP-5")
      ELSEIF(ISIGMET.EQ.8)THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"RADAR SYSTEM",
     +        "RVP-8 OR RVP-900")
      ENDIF
      READ(81,*,ERR=3782,END=3782)IAPPLYMASK
      IF(IAPPLYMASK.EQ.1)THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"MASK APPLIED","YES")
      ELSE
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"MASK APPLIED","NO ")
      ENDIF
      WRITE(6,*)'IAPPLYMASK = ',IAPPLYMASK
      READ(81,*,ERR=3782,END=3782)ROLLTOL
      WRITE(6,*)'ROLLTOL = ',ROLLTOL
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "MAXIMUM AIRCRAFT ROLL (DEG) TO INCLUDE DATA",ROLLTOL)
      READ(81,*,ERR=3782,END=3782)NSKIP
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "NUMBER OF SWEEPS SKIPPED AFTER 1 USED",NSKIP)
      WRITE(6,*)"NSKIP = '",NSKIP
      READ(81,*,ERR=3782,END=3782)FACTRH,FACTRZ
      WRITE(6,*)'FACTRH,FACTRZ = ',FACTRH,FACTRZ
      READ(81,*,ERR=3782,END=3782)FACTFILL
      WRITE(6,*)'FACTFILL = ',FACTFILL
      WRITE(DUMMY2,'(A,A)')
     + "NORMALIZED RADIAL 2-DELTAX HORIZONTAL ",
     + "FILTERING ON WAVE NO. 0-1 PASS"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTRH)
      WRITE(DUMMY2,'(A,A)')
     + "NORMALIZED VERTICAL 2-DELTAX HORIZONTAL ",
     + "FILTERING ON WAVE NO. 0-1 PASS"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTRZ)
      WRITE(DUMMY2,'(A,A)')
     + "NORMALIZED 2-DELTAX ",
     + "FILTERING ON FILLED SPACES IN WAVE NO. 0-1 PASS"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTFILL)
      READ(81,'(A)',ERR=3782,END=3782)RTXY
      WRITE(6,'(A,A2)')'RTXY = ',RTXY
      IF(RTXY.EQ.'RT')THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "FILTERING IN CARTESIAN-ANALYSIS INTERPOLATION",
     +    "CYLINDRICAL")
      ELSEIF(RTXY.EQ.'XY')THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "FILTERING IN CARTESIAN-ANALYSIS INTERPOLATION",
     +    "CARTESIAN")
      ENDIF
      READ(81,'(A)',ERR=3782,END=3782)ATTEN
      WRITE(6,'(A,A1)')'ATTEN = ',ATTEN
      IF(ATTEN.EQ.'N')THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "ALONG-RADIAL ATTENUATION CORRECTIONAPPLIED?",
     +        "NO ")
      ELSEIF(ATTEN.EQ.'Y')THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "ALONG-RADIAL ATTENUATION CORRECTIONAPPLIED?",
     +        "YES")
      ENDIF
      READ(81,*,ERR=3782,END=3782)ZXYCHECK,PERCENTCHECK,ALLOWEDDIFF
      WRITE(6,*)'ZXYCHECK,PERCENTCHECK,ALLOWEDDIFF = ',
     +           ZXYCHECK,PERCENTCHECK,ALLOWEDDIFF
      WRITE(DUMMY2,'(A,A)')"MAXIMUM RMS VARIATION AROUND MEAN RADIAL ",
     + "VELOCITY ALLOWED TO USE VELOCITY DATA AT GRID POINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,ZXYCHECK)
      WRITE(DUMMY2,'(A,A)')"PERCENTAGE OF WEIGHTED DATA THAT MUST BE ",
     + "EXCEEDED TO USE DATA AT GRID POINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,PERCENTCHECK)
      WRITE(DUMMY2,'(A,A)')"MAXIMUM DIFFERENCE BETWEEN RADIAL ",
     + "VELOCITY AND PROJECTED FIRST GUESS ALLOWED (METERS PER SECOND)"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,ALLOWEDDIFF)
      READ(81,*,ERR=3782,END=3782)SXB,SYB,SZB
      WRITE(6,*)'SXB,SYB,SZB = ',SXB,SYB,SZB
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "EAST-WEST GRID SPACING IN ANALYSIS (KM)",SXB)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "NORTH-SOUTH GRID SPACING IN ANALYSIS (KM)",SYB)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "VERTICAL GRID SPACING IN ANALYSIS (KM)",SZB)
      IF(RTXY.EQ.'XY')THEN
         READ(81,*,ERR=3782,END=3782)NUMRX,NUMRY,NUMRZ
         WRITE(6,*)'NUMRX,NUMRY,NUMRZ = ',NUMRX,NUMRY,NUMRZ
         RXMAX = SXB*NUMRX
         RYMAX = SYB*NUMRY
         RZMAX = SZB*NUMRZ
         WRITE(6,*)'RXMAX,RYMAX,RZMAX = ',RXMAX,RYMAX,RZMAX
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "EAST-WEST RADIUS OF INFLUENCE (KM) FOR CARTESIAN PASS",
     +        RXMAX)
         ISTAT=NF90_PUT_att(NCID,NF90_GLOBAL,
     +        "NORTH-SOUTH RADIUS OF INFLUENCE (KM) FOR CARTESIAN PASS",
     +        RYMAX)
         ISTAT=NF90_PUT_att(NCID,NF90_GLOBAL,
     +        "VERTICAL RADIUS OF INFLUENCE (KM) FOR CARTESIAN  PASS",
     +        RZMAX)
         READ(81,*,ERR=3782,END=3782)NUMEX,NUMEY,NUMEZ
         WRITE(6,*)'NUMRX,NUMRY,NUMRZ = ',NUMEX,NUMEY,NUMEZ
         EXMAX = SXB*NUMEX
         EYMAX = SYB*NUMEY
         EZMAX = SZB*NUMEZ
         WRITE(6,*)'EXMAX,EYMAX,EZMAX = ',EXMAX,EYMAX,EZMAX
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "EAST-WEST E-FOLD DISTANCE (KM) FOR CARTESIAN PASS",
     +        EXMAX)
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "NORTH-SOUTH E-FOLD DISTANCE (KM) FOR CARTESIAN PASS",
     +        EYMAX)
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "VERTICAL E-FOLD DISTANCE (KM) FOR CARTESIAN PASS",
     +        EZMAX)
      ELSE
         READ(81,*,ERR=3782,END=3782)NUMRR,NUMRT,NUMRZ
         WRITE(6,*)'NUMRR,NUMRT,NUMRZ = ',NUMRR,NUMRT,NUMRZ
         RRMAX = SXB*NUMRR
         RTMAX = SYB*NUMRT
         RZMAX = SZB*NUMRZ
         WRITE(6,*)'RHMAX,RTMAX,RZMAX = ',RHMAX,RTMAX,RZMAX
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "RADIAL RADIUS OF INFLUENCE (KM) FOR CARTESIAN PASS",
     +        RRMAX)
         ISTAT=NF90_PUT_att(NCID,NF90_GLOBAL,
     +        "AZIMUTHAL RADIUS OF INFLUENCE (KM) FOR CARTESIAN  PASS",
     +        RTMAX)
         ISTAT=NF90_PUT_att(NCID,NF90_GLOBAL,
     +        "VERTICAL RADIUS OF INFLUENCE (KM) FOR CARTESIAN  PASS",
     +        RZMAX)
         READ(81,*,ERR=3782,END=3782)NUMER,NUMET,NUMEZ
         WRITE(6,*)'NUMER,NUMET,NUMEZ = ',NUMER,NUMET,NUMEZ
         ERMAX = SXB*NUMER
         ETMAX = SYB*NUMET
         EZMAX = SZB*NUMEZ
         WRITE(6,*)'ERMAX,ETMAX,EZMAX = ',ERMAX,ETMAX,EZMAX
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "RADIAL E-FOLD DISTANCE (KM) FOR CARTESIAN PASS",
     +        ERMAX)
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "AZIMUTHAL E-FOLD DISTANCE (KM) FOR CARTESIAN PASS",
     +        ETMAX)
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "VERTICAL E-FOLD DISTANCE (KM) FOR CARTESIAN PASS",
     +        EZMAX)
      ENDIF
      IF(IAPPLYMASK.EQ.1)THEN
         READ(81,*,ERR=3782,END=3782)IAFTADD,IAFTDBZMASK
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "AMOUNT TO ADD TO AFT DBZ",IAFTADD)
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "AMOUNT(DBZ) TO EXCEED MASK FOR AFT ANTENNA",IAFTDBZMASK)
         READ(81,*,ERR=3782,END=3782)IFOREADD,IFOREDBZMASK
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "AMOUNT TO ADD TO FORE DBZ",IFOREADD)
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     +        "AMOUNT(DBZ) TO EXCEED MASK FOR FORE ANTENNA",
     +        IFOREDBZMASK)
      ENDIF
      READ(81,*,ERR=3782,END=3782)IVTSUB
      WRITE(6,*)'IVTSUB = ',IVTSUB
      IF(IVTSUB.EQ.0)THEN
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FALL SPEED SUBTRACTED DURING INTERPOLATION","YES")
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FALL SPEED SUBTRACTED DURING SYNTHESIS","NO ")
      ELSE
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FALL SPEED SUBTRACTED DURING INTERPOLATION","NO ")
         ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FALL SPEED SUBTRACTED DURING SYNTHESIS","YES")
      ENDIF
      READ(81,*,ERR=3782,END=3782)XACC,YACC,ZACC
      XACC=DISPLACEMENT_FACTOR*XACC
      YACC=DISPLACEMENT_FACTOR*YACC
      ZACC=DISPLACEMENT_FACTOR*ZACC
      WRITE(6,*)'XACC,YACC,ZACC = ',XACC,YACC,ZACC
      WRITE(DUMMY2,'(A,A)')
     + "MAXIMUM ALLOWED EAST-WEST DISPLACEMENT (KM) OF WEIGHT MEAN ",
     + "POSITION OF DATA FROM GRID POINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,XACC)    
      WRITE(DUMMY2,'(A,A)')
     + "MAXIMUM ALLOWED NORTH-SOUTH DISPLACEMENT (KM) OF WEIGHT MEAN ",
     + "POSITION OF DATA FROM GRID POINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,YACC)    
      WRITE(DUMMY2,'(A,A)')
     + "MAXIMUM ALLOWED VERTICAL DISPLACEMENT (KM) OF WEIGHT MEAN ",
     + "POSITION OF DATA FROM GRID POINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,ZACC)    
      READ(81,*,ERR=3782,END=3782)FACTRH
      WRITE(6,*)'FACTRH = ',FACTRH
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "NORMALIZED 2-DELTA-X FILTERING WEIGHT",FACTRH)
      READ(81,*,ERR=3782,END=3782)FACTZ
      WRITE(6,*)'FACTZ = ',FACTZ
      WRITE(DUMMY2,'(A,A)')
     + "FACTOR TIMES EXPECTED WEIGHT FOR ",
     +  "FOURTH-ORDER CONTINUITY EQUATION CONSTRAINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTZ)
      READ(81,*,ERR=3782,END=3782)FACTWP,FACTWBOT,FACTWTOP,FACTVR2
      WRITE(6,*)'FACTWP,FACTWBOT,FACTWTOP,FACTVR2 = ',
     +           FACTWP,FACTWBOT,FACTWTOP,FACTVR2
      WRITE(DUMMY2,'(A,A)')
     + "FACTOR TIMES EXPECTED WEIGHT FOR ",
     +  "SECOND-ORDER CONTINUITY EQUATION CONSTRAINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTWP)
      WRITE(DUMMY2,'(A,A)')
     + "FACTOR TIMES EXPECTED WEIGHT FOR ",
     + "BOTTOM BOUNDARY CONDITION CONSTRAINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTWBOT)
      WRITE(DUMMY2,'(A,A)')
     + "FACTOR TIMES EXPECTED WEIGHT FOR ",
     + "TOP BOUNDARY CONDITION CONSTRAINT"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,FACTWTOP)
      READ(81,*,ERR=3782,END=3782)SINMIN
      WRITE(6,*)'SINMIN = ',SINMIN
      WRITE(DUMMY2,'(A,A)')
     + "MINIMUM ALLOWED ANGULAR SEPARATION (DEGREES) BETWEEN ",
     + "THE AVERAGE POINTING DIRECTION OF FORE AND AFT RADIALS"
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,DUMMY2,SINMIN)
      READ(81,*,ERR=3782,END=3782)WTBACKU,WTBACKV,WTBACKW
      WRITE(6,*)'WTBACKU,WTBACKV,WTBACKW = ',WTBACKU,WTBACKV,WTBACKW
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FIRST GUESS BACKGROUND WEIGHT FOR EAST-WEST WIND COMPONENT",
     + WTBACKU)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FIRST GUESS BACKGROUND WEIGHT FOR NORTH-SOUTH WIND COMPONENT",
     + WTBACKU)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "FIRST GUESS BACKGROUND WEIGHT FOR VERTICAL WIND COMPONENT",
     + WTBACKU)
      READ(81,'(A)',ERR=3782,END=3782)DATEWRITE
      READ(81,'(A)',ERR=3782,END=3782)TIMEWRITE
      READ(81,'(A)',ERR=3782,END=3782)ZONEWRITE
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "DATE OF SYNTHESIS (YYYYMMDD)",DATEWRITE)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "TIME OF SYNTHESIS (HHMMSS.XXX)",TIMEWRITE)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "ZONE DIFFERENCE FROM UTC (HHMM)",ZONEWRITE)
      READ(81,*,ERR=3782,END=3782)IANALYSISLEVEL
      WRITE(6,*)'IANALYSISLEVEL = ',IANALYSISLEVEL
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,
     + "ANALYSIS LEVEL (1--REAL-TIME,2--RESEARCH QUALITY)",
     + IANALYSISLEVEL)
C 
C END OF THE DEFINITION OF DIMENSIONS AND VARIABLES
C
 3782 ISTAT=NF90_ENDDEF(NCID)
      ICOUNT1(1)=IMAX
      ISTART1(1)=1
      ISTART(1)=1
      ISTART(2)=0
      ISTART(3)=0
      ICOUNT(1)=IMAX
      ICOUNT(2)=0
      ICOUNT(3)=0
c***
C
C PUT THE XKM-AXIS VALUES IN THE X DIMENSION OF NETCDF FILE
C
C      ISTAT=NF90_PUT_VAR(NCID,IXDIMID,X,ISTART1,ICOUNT1)
      ISTAT=NF90_PUT_VAR(NCID,IXDIMID,XKM,ISTART1,ICOUNT1)
C
C PUT THE YKM-AXIS VALUES IN THE Y DIMENSION OF NETCDF FILE
C
      ICOUNT1(1)=JMAX
c      ISTAT=NF90_PUT_VAR(NCID,IYDIMID,Y,ISTART1,ICOUNT1)
      ISTAT=NF90_PUT_VAR(NCID,IYDIMID,YKM,ISTART1,ICOUNT1)
C
C PUT THE Z-AXIX VALUES IN THE Z DIMENSION OF NETCDF FILE
C
      ICOUNT1(1)=KMAX
      ISTAT=NF90_PUT_VAR(NCID,IZDIMID,Z,ISTART1,ICOUNT1)
C 
C ARRAY ISTART3 AND ICOUNT3 HAVE THE BEGINNING AND ENDING RANGE OF DATA
C IN THREE DIMENSIONS THAT WILL BE PUT IN A NETCDF VARIABLE 
C THE RANGE OF TIME IS JUST 1:1 BUT IT IS STANDARD IN DATA LIKE THIS
      ISTART3(1)=1
      ISTART3(2)=1
      ISTART3(3)=1
      ICOUNT3(1)=1
      ICOUNT3(2)=JMAX
      ICOUNT3(3)=IMAX
C
C WRITE LATITUDE AND LONGITUDE INTO NETCDF VARIABLES
C
      ISTAT=NF90_PUT_VAR(NCID,ILATVARID,LAT,ISTART3,ICOUNT3)
      ISTAT=NF90_PUT_VAR(NCID,ILONVARID,LON,ISTART3,ICOUNT3)
      ICOUNT1(1)=1
      IF(ETIME1.GE.STIME.AND.ETIME1.LE.ETIME)THEN
         TT(1)=ETIME1
      ELSE
         TT(1)=FLOAT(INT((STIME+ETIME)/2.))
      ENDIF
      WRITE(6,*)'TT,ETIME1,STIME,ETIME = ',
     1  TT(1),ETIME1,STIME,ETIME
      IF(PARAMETERSECS.GT.0)THEN
         TT(1)=PARAMETERSECS
      ELSE
         READ(OUTFILNAM,'(9X,I2)')IHR
         READ(OUTFILNAM,'(11X,I2)')IMIN
         SECS=IHR*3600+IMIN*60
         TT(1)=SECS
      ENDIF
      WRITE(6,*)'PARAMETERSECS,TT = ',PARAMETERSECS,TT(1)
      ISTAT=NF90_PUT_VAR(NCID,ITDIMID,TT,ISTART1,ICOUNT1)
      INC(1)=INCLUDEINCOMPOSITE
      ISTAT=NF90_PUT_VAR(NCID,INVARID,INC,ISTART1,ICOUNT1)
      WRITE(6,*)'PUT_VAR includeincomposite, ISTAT = ',ISTAT
c***
      ICOUNT(1)=1
      ICOUNT(2)=KMAX
      ICOUNT(3)=JMAX
      ICOUNT(4)=IMAX
      ISTART(1)=1
      ISTART(2)=1
      ISTART(3)=1
      ISTART(4)=1
C
C WRITE OUT THE 3D+TIME DIMENSION VARIABLES EAST-WEST WIND (M/S), NORTH-SOUTH
C WIND (M/S), VERTICAL WIND (M/S), RADAR REFLECTIVIY (DBZ), TOTAL WIND SPEED 
C (M/S), RADIAL WIND (M/S), TANGENTIAL WIND (M/S)
C
      ISTAT=NF90_PUT_VAR(NCID,IVORTVARID,VORT,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IUVARID,U,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IVVARID,V,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IWVARID,W,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IDBZVARID,DBZ,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IWSVARID,WS,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,IRWVARID,RW,ISTART,ICOUNT)
      ISTAT=NF90_PUT_VAR(NCID,ITWVARID,TW,ISTART,ICOUNT)
      ISTAT=NF90_CLOSE(NCID)
C FIRST TIME WRITENETCDF IS CALLED IS FOR THE EARTH RELATIVE WIND FILE
C BUT SECOND TIME IS FOR THE STORM RELATIVE.  STORM RELATIVE AWIPS FILES
C NOT NEEDED SO RETURN HERE FOR SECOND CALL TO WRITENETCDF
      WRITE(6,*)'ICALLTEST = ',ICALLTEST
      IF(ICALLTEST.NE.0)RETURN
C Beginning of making AWIPS max radar 2D file
C
C CREATE/OPEN THE 1-LEVEL 2D+TIME MAXIMUM DBZ AWIPS-II FILE, WHICH SHOWS THE 
C MAXIMUM DBZ AT ANY LEVEL IN THE COLUMN ABOVE A GRID CELL
C
      ISTAT=NF90_CREATE(OUTFILERADAR,NF90_NETCDF4,NCID)
C
C THE DIMENSIONS ARE TIME (RANGE 1:1), LATITUDE, AND LONGITUDE
C
      ISTAT=NF90_DEF_DIM(NCID,"time",ITMAX,ITDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"lats",JMAX,IYDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"lons",IMAX,IXDIMID)
      IDIMIDS3(1)=ITDIMID
      IDIMIDS3(2)=IYDIMID
      IDIMIDS3(3)=IXDIMID
      write(*,*)ITDIMID 
      WRITE(6,*)'IXDIMID,IYDIMID,ITDIMID = ',
     1 IXDIMID,IYDIMID,ITDIMID
      WRITE(6,*)'WRITECHAR = ',WRITECHAR
      test=1507204800
C
C GET THE DATE AND TIME (TO THE NEAREST MINUTE) OF ANALYSIS FROM 
C OUTPUT FILE NAME
C
      YEAR=OUTFILNAM(1:2)
      MONTH=OUTFILNAM(3:4)
      DAY=OUTFILNAM(5:6)
      HR=OUTFILNAM(10:11)
      MN=OUTFILNAM(12:13)
      READ(OUTFILNAM,'(9X,I2)')IHR
      READ(OUTFILNAM,'(11X,I2)')IMIN
C
C SECONDS SINCE MIDNIGHT OF THE DAY FLIGHT BEGAN
C
      SECS=IHR*3600+IMIN*60
C
C DETERMINE THE EPOCH TIME (SECONDS SINCE MIDNIGHT JAN 1 1970)
C
      CALL SECS1970(IYEAR,IMONTH,IDAY,SECS,DSECS)
      YYYY="20"//YEAR//"-"//MONTH//"-"//DAY//" "//HR//":"//MN//":00"
C
C YYYY WILL BE ADDED AS AN ATTRIBUTE FOR THE TIME AS "TIME ORIGIN"
C
      WRITE(6,'("YYYY = ",A19)')YYYY
      WRITE(6,*)'IYEAR,IMONTH,IDAY,IHR,IMIN = ',IYEAR,IMONTH,IDAY,
     & IHR,IMN
      WRITE(6,*)'SECS,DSECS = ',SECS,DSECS
C      PAUSE
C
C DEFINE THE TIME VARIABLE
C
      ISTAT=NF90_DEF_VAR(NCID,"time",NF90_DOUBLE,ITDIMID,ITVARID)
C
C ENTER ATTRIBUTES FOR THE TIME VARIABLE
C
C UNITS SHOWS THE TIME VARIABLE WILL BE SECONDS SINCE 1970/01/01/1200AM
C
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'units',
     & "seconds since 1970-01-01 00:00:00")
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'time_origin',YYYY)           
       ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'long_name',"Valid Time")
C
C DEFINE THE Y VARIABLE, WHICH IN THIS CASE IS DEGREES LATITUDE
C
      ISTAT=NF90_DEF_VAR(NCID,"lats",NF90_DOUBLE,IYDIMID,IYVARID)
C
C ENTER ATTRIBUTES FOR LATITUDE
C
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'units','degrees_north')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'standard_name','latitude')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'long_name','latitude')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'_Storage','contiguous')
C
C DEFINE THE X VARIABLE, WHICH IN THIS CASE IS DEGREES LONGITUDE
C
      ISTAT=NF90_DEF_VAR(NCID,"lons",NF90_DOUBLE,IXDIMID,IXVARID)
C
C ENTER ATTRIBUTES FOR LONGITUDE
C
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'units','degrees_east')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'Standard_name','longitude')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'long_name','longitude')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'_Storage','contiguous')
C
C ENTER GLOBAL ATTRIBUTES INFORMATION
C
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"title","Recon Radar Data") 
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"time_origin",YYYY)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"source","TSB testing")
c      DO I=1,IMAX
c      write(*,*)(MAXDBZ(J,I),J=1,JMAX)
c      ENDDO
c      write(*,*) 'shape =', shape(MAXDBZ)
c      write(*,*) "xxxxxxxxxxxxxxxxxx"
c      write(*,*) IDIMIDS3
c      write(*,*) "xxxxxxxxxxxxxxxxxx"
C
C THIS PORTION OF THE CODE WAS WRITTEN BY CHRISTOPHER MELLO WHILE HE WAS
C AT NHC
C
C
C DEFINE THE VARIBABLE "MAXREFLECTIVITY", WHICH IS THE HIGHEST REFLECTIVITY
C IN THE COLUMN ABOVE A GIVEN GRID CELL
C
      ISTAT=nf90_def_var(ncid,"MAXREFLECTIVITY", nf90_double,
c SNS - IYDIMID/IXDIMID switched
     &                   (/ IXDIMID, IYDIMID /),IDBZVARID)
C
C ENTER THE ATTRIBUTES FOR THE MAXREFLECTIVITY VARIABLE
C
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'valid_range',VALID_RANGE)
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'long_name', "Recon DBZ")
      ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'coordinates',"time lats lons")
      WRITE(6,*)'PUTIDBZVARID,ISTAT = ',ISTAT
C
C END DEFINITION OF VARIABLES AND AXES
C
      ISTAT=NF90_ENDDEF(NCID)
      WRITE(6,*)'ENDDEF,ISTAT = ',ISTAT
      ISTART1(1)=1
      ICOUNT1(1)=JMAX
C
C PUT IN DATA IN FILE FOR THE LATITUDE COORDINATE
C
      ISTAT=NF90_PUT_VAR(NCID,IYDIMID,Y,ISTART1,ICOUNT1) 
      ICOUNT1(1)=IMAX 
C
C PUT IN DATA IN FILE FOR THE LONGITUDE COORDINATE
C
      ISTAT=NF90_PUT_VAR(NCID,IXDIMID,X,ISTART1,ICOUNT1)
      TT(1)=DSECS
      WRITE(6,*)'AWIPS DBZ TT(1) - ',TT(1)
C      PAUSE
C      ICOUNT1(1)=JMAX
C
C PUT IN VALUE OF TIME OF ANALYSIS ORIGIN RELATIVE TO 12AM 01/01/1970
C
      ISTAT=NF90_PUT_VAR(NCID,ITDIMID,TT)
      ICOUNT3(1)=1
      ICOUNT3(2)=JMAX
      ICOUNT3(3)=IMAX
      ISTART3(1)=1
      ISTART3(2)=1
      ISTART3(3)=1
      IconvertMD=MAXDBZ(:,:)
C
C APPARENTLY AWIPS-II INPUTS NEED TO BE TRANSPOSED BACK SINCE MAXDBZ
C WAS ALREADY TRANSPOSED BY U1U2
C
      IconvertMD=transpose(IconvertMD) 
C
C PUT THE COLUMN-MAXIMUM DBZ VALUES IN THE NETCDF FILE
C APPARENTLY THEY ARE DESIRED ROUNDED TO WHOLE NUMBERS, BUT IN FLOAT FORM
C
      ISTAT=NF90_PUT_VAR(NCID,IDBZVARID,float(IconvertMD))
      WRITE(6,*)'PUTDBZ,ISTAT = ',ISTAT
      ISTAT=NF90_CLOSE(NCID)
C End of making AWIPS 2D max dBZ file
C Beginning of making wind 2D VARIABLES IN ONE FILE
C      OUTFILERADAR='WindComponents.nc'
      ISTAT=NF90_CREATE(OUTFILEWIND,NF90_NETCDF4,NCID)
      ISTAT=NF90_DEF_DIM(NCID,"time",ITMAX,ITDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"lats",JMAX,IYDIMID)
      ISTAT=NF90_DEF_DIM(NCID,"lons",IMAX,IXDIMID)
C
C AWIPS-II IS REALLY DESIGNED AS A 2-D DISPLAY SYSTEM SO THE INPUT NETCDF FILE 
C TO AWIPS IS A 2D+TIME ARRAY OF SEPARATE WIND VARIABLES FOR EACH HEIGHT
C
C
C TIME
C
      IDIMIDS3(1)=ITDIMID
C
C LATITUDE
C
      IDIMIDS3(2)=IYDIMID
C
C LONGITUDE
C
      IDIMIDS3(3)=IXDIMID
      write(*,*)ITDIMID 
      WRITE(6,*)'IXDIMID,IYDIMID,ITDIMID = ',
     1 IXDIMID,IYDIMID,ITDIMID
      WRITE(6,*)'WRITECHAR = ',WRITECHAR
C
C DEFINE THE TIME VARIABLE (THROUGH ITVARID)
C
      ISTAT=NF90_DEF_VAR(NCID,"time",NF90_DOUBLE,ITDIMID,ITVARID)
C
C ENTER ATTRIBUTES FOR TIME
C
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'units',"seconds since 1970-01-01
     &00:00:00")
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'time_origin',YYYY)
      ISTAT=NF90_PUT_ATT(NCID,ITDIMID,'long_name',"Valid Time")
C
C DEFINE THE LATITUDE VARIABLE (THROUGH IYVARID)
C
      ISTAT=NF90_DEF_VAR(NCID,"lats",NF90_DOUBLE,IYDIMID,IYVARID)
C
C ENTER ATTRIBUTES FOR LATITUDE
C
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'units','degrees_north')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'standard_name','latitude')
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'long_name','latitude')
C
C STORAGE CONTIGUOUS MUST BE SOMETHING THAT AWIPS-II NEEDS
C
      ISTAT=NF90_PUT_ATT(NCID,IYDIMID,'_Storage','contiguous')
C
C DEFINE THE LONGITUDE VARIABLE (THROUGH IXVARID)
C
      ISTAT=NF90_DEF_VAR(NCID,"lons",NF90_DOUBLE,IXDIMID,IXVARID)
C
C ENTER ATTRIBUTES FOR LONGITUDE
C
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'units','degrees_east')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'Standard_name','longitude')
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'long_name','longitude')
C
C STORAGE CONTIGUOUS MUST BE SOMETHING THAT AWIPS-II NEEDS
C
      ISTAT=NF90_PUT_ATT(NCID,IXDIMID,'_Storage','contiguous')
C
C ENTER GLOBAL ATTRIBUTES OF AWIPS-II NETCDF FILE
C
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"title","Recon Radar Data") 
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"time_origin",YYYY)
      ISTAT=NF90_PUT_ATT(NCID,NF90_GLOBAL,"source","TSB testing")
C
c      DO I=1,IMAX
c      write(*,*)(MAXDBZ(J,I),J=1,JMAX)
c      ENDDO
c      write(*,*) 'shape =', shape(MAXDBZ)
c      write(*,*) "xxxxxxxxxxxxxxxxxx"
c      write(*,*) IDIMIDS3
c      write(*,*) "xxxxxxxxxxxxxxxxxx"
C
C AT THIS POINT THE AWIPS-II FILE IS HARDWIRED TO 36 LEVELS STARTING
C AT LEVEL 2 OF INPUT DATA (500 M USUALLY) AND GOING TO LEVEL 37 (18000 M
C USUALLY) ULEVELC(2) WOULD BE NAMED "u_05000" AND
C ULVELC(37) WOULD BE NAMED "v_00500"
C
      DO K=2,37
C
C DEFINE ALL THE U-COMPONENT VARIABLES (IULEVELVARID(K)) 
C FOR EACH LEVEL IN THIS LOOP
C
         ISTAT=nf90_def_var(ncid,ULEVELC(K), nf90_double,
c SNS - switched IYDIMID/IXDIMID
     &                   (/ IXDIMID, IYDIMID /),IULEVELVARID(K))
C
C SET ATTRIBUTES FOR U-COMPONENT VARIABLE
C
         ISTAT=
     &    NF90_PUT_ATT(NCID,IULEVELVARID(K),'valid_range',VALID_RANGE)
         ISTAT=
     &    NF90_PUT_ATT(NCID,IULEVELVARID(K),'UNITS','knots')
         WRITE(LONGNAMEU,
     & '("east-west wind component at ",I6," meters")')
     & NINT(Z(K)*1000.)
         ISTAT=NF90_PUT_ATT(NCID,IULEVELVARID(K),'long_name',longnameu)
C         ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'long_name', "Recon DBZ")
         ISTAT=NF90_PUT_ATT
     &    (NCID,IULEVELVARID(K),'coordinates',"time lats lons")
C
C DEFINE ALL THE V-COMPONENT VARIABLES (IVLEVELVARID(K)) 
C FOR EACH LEVEL IN THIS LOOP
C
         ISTAT=nf90_def_var(ncid,VLEVELC(K), nf90_double,
c SNS - switched IYDIMID/IXDIMID
     &                   (/ IXDIMID, IYDIMID /),IVLEVELVARID(K))
C
C SET ATTRIBUTES FOR U-COMPONENT VARIABLE
C
         ISTAT=
     &    NF90_PUT_ATT(NCID,IVLEVELVARID(K),'valid_range',VALID_RANGE)
         ISTAT=
     &    NF90_PUT_ATT(NCID,IVLEVELVARID(K),'UNITS','knots')
         WRITE(LONGNAMEV,
     & '("north-south wind component at ",I6," meters")')
     & NINT(Z(K)*1000.)
         ISTAT=NF90_PUT_ATT(NCID,IVLEVELVARID(K),'long_name',longnamev)
C         ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'long_name', "Recon DBZ")
         ISTAT=NF90_PUT_ATT
     &    (NCID,IVLEVELVARID(K),'coordinates',"time lats lons")
C
C THE FOLLOWING ARE COMMENTED STATEMENTS THAT CAN BE UNCOMMENTED
C WHEN NHC IS READY TO TAKE 3D REFLECTIVITY WHICH HAS BEEN REQUESTED
C BUT THE FORMAT HAS NOT BEEN TESTED AND APPROVED
C
CDBZ         ISTAT=nf90_def_var(ncid,DBZLEVELC(K), nf90_double,
CDBZc SNS - switched IYDIMID/IXDIMID
CDBZ     &                   (/ IXDIMID, IYDIMID /),IDBZLEVELVARID(K))
CDBZ         WRITE(6,*)'I GOT HERE 1B'
CDBZ         ISTAT=
CDBZ     &    NF90_PUT_ATT(NCID,IDBZLEVELVARID(K),'valid_range',VALID_RANGE)
CDBZ         WRITE(6,*)'I GOT HERE 1C'
CDBZ         ISTAT=
CDBZ     &    NF90_PUT_ATT(NCID,IDBZLEVELVARID(K),'UNITS','dBZ')
CDBZ         WRITE(6,*)'I GOT HERE 1D'
CDBZ         WRITE(LONGNAMEDBZ,
CDBZ     & '("radar reflectivity at ",I6," meters")')
CDBZ     & NINT(Z(K)*1000.)
CDBZ         WRITE(6,*)'I GOT HERE 1E'
CDBZ         ISTAT=NF90_PUT_ATT(NCID,IDBZLEVELVARID(K),'long_name',
CDBZ     &   longnamedbz)
CDBZC         ISTAT=NF90_PUT_ATT(NCID,IDBZVARID,'long_name', "Recon DBZ")
CDBZ         WRITE(6,*)'I GOT HERE 1F'
CDBZ         ISTAT=NF90_PUT_ATT
CDBZ     &    (NCID,IDBZLEVELVARID(K),'coordinates',"time lats lons")
      ENDDO
C 
C END OF DEFINITION AND ATTRIBUTES OF VARIABLES FOR AWIPS-II WIND FILE
C
      ISTAT=NF90_ENDDEF(NCID)
      WRITE(6,*)'ENDDEF,ISTAT = ',ISTAT
      ISTART1(1)=1
      ICOUNT1(1)=JMAX
C
C PUT LATITUDE VALUES IN 1D AWIPS-II DIMENSION VARIABLE IYDIMID
C
      ISTAT=NF90_PUT_VAR(NCID,IYDIMID,Y,ISTART1,ICOUNT1) 
      ICOUNT1(1)=IMAX 
C
C PUT LATITUDE VALUES IN 1D AWIPS-II DIMENSION VARIABLE IXDIMID
C
      ISTAT=NF90_PUT_VAR(NCID,IXDIMID,X,ISTART1,ICOUNT1)
      TT(1)=DSECS
      ICOUNT1(1)=JMAX
      WRITE(6,*)'AWIPS WINDS TT(1) - ',TT(1)
C      PAUSE
      ISTAT=NF90_PUT_VAR(NCID,ITDIMID,TT)
      DO K=2,37
         ICOUNT3(1)=1
         ICOUNT3(2)=JMAX
         ICOUNT3(3)=IMAX
         ISTART3(1)=1
         ISTART3(2)=1
         ISTART3(3)=1
C      IconvertMAXDBZ=MAXDBZ(:,:)
         DO I=1,IMAX
c            WRITE(6,*)'K,IULEVELVARID(K) = ',K,IULEVELVARID(K)
c            WRITE(6,*)(UWRITE(I,J,K),J=1,JMAX)
            DO J=1,JMAX

               UWRITE1(I,J)=UWRITE(I,J,K)
               VWRITE1(I,J)=VWRITE(I,J,K)
CDBZ               DBZWRITE1(I,J)=DBZWRITE(I,J,K)
 
           ENDDO
         ENDDO
c         PAUSE

        where (UWRITE1 .lt. -250 ) UWRITE1 = UWRITE1 * (-0) 
        where (VWRITE1 .lt. -250 ) VWRITE1 = VWRITE1 * (-0)       
CDBZ        where (DBZWRITE1 .lt. -250 ) DBZWRITE1 = DBZWRITE1 * (-0)       
 
         UWRITE1=transpose(UWRITE1) 
         VWRITE1=transpose(VWRITE1) 
CDBZ         DBZWRITE1=transpose(DBZWRITE1) 

         ISTAT=NF90_PUT_VAR(NCID,IULEVELVARID(K),UWRITE1)
         ISTAT=NF90_PUT_VAR(NCID,IVLEVELVARID(K),VWRITE1)
CDBZ         ISTAT=NF90_PUT_VAR(NCID,IDBZLEVELVARID(K),DBZWRITE1)
      ENDDO
      WRITE(6,*)'PUTDBZ,ISTAT = ',ISTAT
      ISTAT=NF90_CLOSE(NCID)
C End of making AWIPS WIND FILE WITH MANY LEVELS OF 2D VARIABLES
      RETURN
      END
      SUBROUTINE U1U2(U,U2,IMAX,JMAX,KMAX)
C THIS ROUTINE CONVERTS FROM FORTRAN VARIABLE-STORAGE HIERACHRY TO
C THE C VARIABLE-STORAGE THAT NETCDF USES
      REAL U(IMAX,JMAX,KMAX),U2(KMAX,JMAX,IMAX)
C
C REVERSE I,J,K TO TRANSPOSE THE U ARRAY IN U2 ARRAY
C
      DO I=1,IMAX
       DO J=1,JMAX
        DO K=1,KMAX
         U2(K,J,I)=U(I,J,K)
        ENDDO
       ENDDO
      ENDDO
C
C PLACE THE U2 TRANSPOSED VALUES BACK INTO U ARRAY
C THUS, U1U2 REPLACES THE OUTPUT TRANSPOSED ARRAY IN THE ORIGINAL INPUT ARRAY
C U2 CAN BE REUSED IN THE MAIN PROGRAM THIS WAY
C
      CALL RESETU1U2(U,U2,IMAX,JMAX,KMAX)
      RETURN
      END
      SUBROUTINE U1U21LEVEL(U,UWRITE,K,IMAX,JMAX,KMAX)
C
C THIS ROUTINE CONVERTS FROM FORTRAN VARIABLE-STORAGE HIERACHRY TO
C THE C VARIABLE-STORAGE THAT NETCDF USES
C SINCE THE FINAL VARIABLES WILL JUST BE 2D INSTEAD OF 3D,
C ONLY THE I AND J DIMENSIONS ARE TRANSPOSED
C THE UWRITE VARIABLES WILL THEN BE USED TO POPULATE THE 2D LEVEL ARRAYS
C
      REAL U(IMAX,JMAX,KMAX),UWRITE(JMAX,IMAX,KMAX)
      DO I=1,IMAX
       DO J=1,JMAX
         UWRITE(J,I,K)=U(I,J,K)
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE RESETU1U2(U,U2,IMAX,JMAX,KMAX)
      REAL U(IMAX,JMAX,KMAX),U2(IMAX,JMAX,KMAX)
C
C THIS IS DESIGNED TO TAKE THE U2 TRANSPOSED VARIABLE AND THEN PLACE IT
C IT BACK INTO THE ARRAY THAT HAD THE UNTRANSPOSED VARIABLE
C
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         U(I,J,K)=U2(I,J,K)
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE REMAP(U,U2,X,Y,SX,XZ,IMAX,JMAX,KMAX,OLON)
C
C THIS ROUTINE REMAPS DATA THAT ARE MAPPED TO AN EAST-WEST AND NORTH-SOUTH
C DISTANCE FROM STORM CENTER, AND REMAPS TO LATITUDE AND LONGITUDE,
C ACCOUNTING FOR THE COSINE OF LATITUDE WHEN DETERMINING LONGITUDE, 
C AND USING BI-LINEAR INTERPOLATION OF X,Y DATA TO LAT, LON
C
C U COMES INTO ROUTINE AS MAPPED IN THE X-Y DISTANCE GRID
C AND U GOES OUT OF THE ROUTINE MAPPED TO THE LAT LON GRID
C U2 IS THE WORK VARIABLE USED TO REMAP
C
C X IS THE LON GRIDPOINT BASED UPON THE NORTHERNMOST LATITUDE OF THE DATA
C WHERE LONGITUDE RANGE IS THE LARGEST
C X2 IS THE LATITUDE OF THE ACTUAL DATA IN THE X-Y DISTANCE GRID BASED UPON
C THE LATITUDE OF A GIVEN DATUM IN THE X-Y DISTANCE GRID
C Y IS LATITUDE
C
      REAL U(IMAX,JMAX,KMAX),U2(IMAX,JMAX,KMAX),
     1 X(IMAX),X2(1000),Y(JMAX)
      INTEGER A,B
C U2, THE WORK VARIABLE IS SET TO ALL UNFLAGGED VALUES TO BEGIN
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         U2(I,J,K)=-999.9
        ENDDO
       ENDDO
      ENDDO
      DO J=1,JMAX
C
C DETERMINE THE ACTUAL LONGITUDE (X2) OF THE VARIABLES STORED IN HRD-FORMAT
C FOR A GIVEN LATITUDE Y(J)
C
       DO I=1,IMAX
        X2(I)=(.5+FLOAT(I-1))*SX-XZ
        X2(I)=OLON+X2(I)/(COS(Y(J)*3.14159/180.)*111.111)
c        WRITE(6,*)'I,J,OLON,Y(J),SX,XZ,OLON,X2 = ',
c     1         I,J,OLON,Y(J),SX,XZ,OLON,X2(I)
       ENDDO
C
C FOR LATITUDE Y(J) REMAP DATA STORED AS A FUNCTION OF EAST-WEST
C DISTANCE INTO DATA STORED AS A FUNCTION OF LONGITUDE
C
       DO I=1,IMAX
        A=1
        B=2
C X(A) AND X(B) BELOW WILL THE DATA ON EACH SIDE OF THE LONGITUDE GRID
C POINT X2(I) BEING ADDRESSED, WHERE X IS IN THE ORIGINAL DISTANCE GRID
C U IS THE ORIGINALLY MAPPED VARIABLE AND U2 IS THE VARIABLE MAPPED ON TO
C THE NEW LONGITUDE DIMENSION
C
C FOR EACH OUTPUT VALUE X2(I) FIND THE TWO X ARRAY MEMBERS THAT STRADDLE X2(I)
C
        DO WHILE(X2(I).GT.X(B))
         A=A+1
         B=B+1
        ENDDO
c        WRITE(6,*)'I,J,A,B,X(A),X(B),X2(I) = ',
c     1   I,J,A,B,X(A),X(B),X2(I)
C
C THE FIRST TWO ARE IF EITHER X(A) OR X(B) IS EXACTLY EQUAL TO X2(I)
C
        IF(X2(I).EQ.X(A).AND.A.LE.IMAX)THEN
c         WRITE(6,*)'A'
         DO K=1,KMAX
          IF(U(A,J,K).GT.-900.)U2(I,J,K)=U(A,J,K)
         ENDDO
        ELSEIF(X2(I).EQ.X(B).AND.B.LE.IMAX)THEN
c         WRITE(6,*)'B'
         DO K=1,KMAX
          IF(U(B,J,K).GT.-900.)U2(I,J,K)=U(B,J,K)
         ENDDO
        ELSE
C THE LAST IS A LINEAR INTERPOLATION OF THE TWO STRADDLING U VALUES TO U2(I)
c         WRITE(6,*)'C'
         DO K=1,KMAX
C LINEAR INTERPOLATION OF U TO U2
          IF(U(A,J,K).GT.-900..AND.U(B,J,K).GT.-900.)
     1    U2(I,J,K)=((X2(I)-X(A))*U(B,J,K)+(X(B)-X2(I))*U(A,J,K))
     1          /(X(B)-X(A))
         ENDDO
        ENDIF
       ENDDO 
      ENDDO
C
C COPY THE REMAPPED VALUES U2 BACK INTO THE INPUT U VARIABLE
C
      DO K=1,KMAX
       DO J=1,JMAX
        DO I=1,IMAX
         U(I,J,K)=U2(I,J,K)
        ENDDO
       ENDDO
      ENDDO
      RETURN
      END
      SUBROUTINE SECS1970(IYEAR,IMONTH,IDAY,SECS,DSECS)
C
C THIS ROUTINE COMPUTES EPOCH TIME WHICH IS THE NUMBER OF SECONDS
C SINCE 12 AM 1 JANUARY 1970 
C
      DOUBLE PRECISION SECS,DSECS
c      WRITE(6,*)'IYEAR,IMONTH,IDAY = ',IYEAR,IMONTH,IDAY
      IJULIAN=JULIAN_DATE(IYEAR,IMONTH,IDAY)
C      WRITE(6,*)'JULIAN DAY = ',IJULIAN
C
C COMPUTE THE JULIAN DAY NUMBER FOR 1 JANUARY 1970
C
      IY=1970
      IM=1
      ID=1
      IJDAY1=JULIAN_DATE(IY,IM,ID)
C
C COMPUTE THE JULIAN DAY NUMBER FOR INPUT YEAR MONTH AND DAY TO SECS1970
C
      IJDAY2=JULIAN_DATE(IYEAR,IMONTH,IDAY)
C
C DIFFERENCE GIVES HOW MANY DAYS SINCE 1 JANUARY 1970
C
      IJDAY3=IJDAY2-IJDAY1
c      WRITE(6,*)'IJDAY1,IJDAY2,IJDAY3 = ',IJDAY1,IJDAY2,IJDAY3
C
C MULITPLY DIFFERENCE IN JULIAN DAY NUMBER BY 86400 AND ADD INPUT SECONDS
C
      DSECS=DFLOAT(IJDAY3)*8.64D+04+SECS
      RETURN
      END
      FUNCTION JULIAN_DATE(YYYY,MM,DD)
C
C ACTUALLY THIS IS NOT JULIAN DATE, BUT JULIAN DAY NUMBER
C
      INTEGER YYYY,MM,DD
      JULIAN_DATE = dd-32075+1461*(yyyy+4800+(mm-14)/12)/4 + 
     1 367*(mm-2-((mm-14)/12)*12)/12- 
     1 3*((yyyy + 4900 + (mm - 14)/12)/100)/4
      RETURN
      END
