      SUBROUTINE SWEEPIN(SWEEP,SWEEPZ,MAX_RAYS,MAX_GATES,NUM_RAYS,RDTAI,
     + AZ_EL,ICALLSWEEPIN,NUMREC,VRRAD,UNFVEL,TMP1,TMP2,JINDEX,
     + JIINDEX,NYQ,ILATERSWEEP,SWEEPSAVE,U,V,W,IMX,JMX,KMX,SX,SY,SZ,
     + OLAT,OLON,XZ,YZ,ZZ,IUSEWIND,EAZM,EEV,TMSWEEP,RRLAT,RRLON,RRA,
     + SMOTIONU0,SMOTIONV0,CENTIME0,PELEV,IPLANE,IVARIATIONAL,IAFTFORE,
     + INOUT,ISIGMET,IREALTIME,ROLLTOL,NDO,IDBZADD,IDBZMASK,
     + G4P3RADMIN,GROUNDADJUST,ALLOWEDDIFF,RADRAT,RADMASK,IAPPLYMASK,
     + IUNDERONLY,JTRAKAZMMIN,JTRAKAZMMAX)
C 
C     Doppler/Reflectivity processing program. 
C     This program reads the radar tapes and writes rays of Doppler data on
C     disc.  The file contains time in seconds, radar altitude in meters, 
C     latitude and longitude in degrees, earth relative azimuths in degrees,
C     earth relative elevation in degrees and 256 doppler velocities at 300
C     meter intervals.  The data is written to disc and then transfer via 
C     ftp to NCEP.
C 
C     To use: ncepwrite_file ncepwrite_file.job
C     ncepwrite_file.job - data file containing input information. 
C 
C  Subroutines use: 
C     READTAPE - Reads merged tapes and returns 1 record.
C 
C  Logical units: 
C     unit(1) - user's terminal 
C     unit(LUNR) - tape drive LU #
C     unit(LP) - line printer LU #. (6/7 dot-matrix printer)
C  Variables in Common Block and Main Program:
C     NIX - Flag for end-of-file/end-of-tape.(NIX=-100).
C     NGATE1 - Gate number to start mapping the data, for negative range del.
C     IFLT/INM - Flight date/ project name.
C     STIME/ETIME - Starting/Ending times of disc file in seconds.
C     WD/WS - Wind direction(deg) and Wind Speed (m/s).
C     IVT - flag to calculate  and subtract the terminal velocity (y/n).
C     RAMFL - flag to open and read the ram data with the GPS information.
C     XR,YR,ZR - east-west,north-south,and vertical distances of radar gate
C      from the radar
C 
      COMMON /AREA1/ INM,IFLT,STIME,ETIME,WD,WS,NIX,NGATE1,LP,LUNR,
     +               IVT,RAMFL
      include "hrd_radar_common_blocks_johns.f"
c      include "flag_common_block.f"
      COMMON /PARAMS/ trakazm,trakelev,driftnew,
     +                rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(2),
     +                inob(2),ileg,xniq,irsw,maxnbins,v0,
     +                pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
     +                iunfoldflag,iattenflag,
     +                badstabflag,surfelimflag,echoflag,atmflag
      common /tsearch/ kountrec,firstsweep(2),keylf(1024,2),
     +                 keyta(4096,2),
     +                 numsweep(2),itimex(2),lastpoint(2),
     +                 iheadertime,ioldsweep(2),kwords,nwords,krays,
     +                 ibuf(2048)
      LOGICAL badstabflag, surfelimflag, echoflag, atmflag
      LOGICAL ALTITUDERINGEXISTS,IBSTFILEEXISTS,ZRDIFFMAXEXISTS
      CHARACTER ALTRINGREMOVE*1
      LOGICAL DESPECKLEEXISTS
      LOGICAL SQIEXISTS
      REAL TIMEONE,RLATONE,RLONONE,RAONE,AZMONE,EVONE
c      INTEGER, ALLOCATABLE::ICOL(:,:),JCOL(:,:)
c      INTEGER, ALLOCATABLE::XRSWEEP(:,:),YRSWEEP(:,:),ZRSWEEP(:,:)
      INTEGER ICOL(MAX_HRD_DIM,800),JCOL(MAX_HRD_DIM,800)
      REAL BINONE(MAX_HRD_DIM),REFONE(MAX_HRD_DIM)
      INTEGER OLDTIME,IITEST(9),JJTEST(9),IKEEP(MAX_HRD_DIM,800)
      REAL AVGDBZ1(610,360),AVGDBZ2(610,360)
      REAL UNFVEL(MAX_GATES,MAX_RAYS)
      REAL TMP1(MAX_GATES,MAX_RAYS),TMP2(MAX_GATES,MAX_RAYS)
      INTEGER JINDEX(MAX_GATES,MAX_RAYS),JIINDEX(MAX_GATES,MAX_RAYS)
      REAL SWEEP(MAX_GATES,MAX_RAYS),RDTAI(MAX_HRD_DIM)
      REAL AZ_EL(2,MAX_RAYS),AZEL(2,800)
      REAL PELEV(MAX_RAYS),RDTAIIN(MAX_HRD_DIM)
      REAL RDVWS(800)
      REAL PAZM(800)
      REAL SWEEPSAVE(MAX_GATES,MAX_RAYS)
      REAL PCORS(2),DCORS(2),RCORS(2)
      REAL AZMCORS(2),RDELCORTAS(2),ELCORS(2)
      REAL RAY(MAX_HRD_DIM),URAY(MAX_HRD_DIM),V0SAVE(800)
      CHARACTER*1 DESPECKLEYESNO
c      REAL VROUT(MAX_HRD_DIM,800)
      REAL VRRAD(MAX_HRD_DIM,800),NYQ(MAX_HRD_DIM,800)
      REAL XRSWEEP(MAX_HRD_DIM,800),YRSWEEP(MAX_HRD_DIM,800)
      REAL ZRSWEEP(MAX_HRD_DIM,800)
      REAL XRMIN(MAX_HRD_DIM,800),YRMIN(MAX_HRD_DIM,800)
      REAL ZRMIN(MAX_HRD_DIM,800)
      REAL XRMAX(MAX_HRD_DIM,800),YRMAX(MAX_HRD_DIM,800)
      REAL ZRMAX(MAX_HRD_DIM,800)
      REAL AZMIN(MAX_HRD_DIM,800),AZMAX(MAX_HRD_DIM,800)
      REAL SWEEPZ(MAX_HRD_DIM,MAX_RAYS),ZDIFF(MAX_HRD_DIM,800)
      REAL ZMIN(MAX_HRD_DIM,800),ZMAX(MAX_HRD_DIM,800)
      REAL XR(MAX_HRD_DIM),YR(MAX_HRD_DIM),ZR(MAX_HRD_DIM)
      REAL U(IMX,JMX,KMX),V(IMX,JMX,KMX),W(IMX,JMX,KMX)
      REAL EAZM(800),EEV(800),RRLAT(800),RRLON(800),RRA(800)
      INTEGER NAZSUM(2)
      REAL AZSUMX(2),AZSUMY(2)
      REAL TMSWEEP(800),BINOUT(MAX_HRD_DIM)
      INTEGER ISEG(MAX_HRD_DIM,800),ISEGB(MAX_HRD_DIM,800)
      INTEGER ISEGE(MAX_HRD_DIM,800)
      CHARACTER*1 CAIRCRAFT(2),CCHECK
      CHARACTER*7 IFLTCHK,IFLTCHK2
      CHARACTER DUMMYREAD*1
      CHARACTER IFLT*8, INM*12, CDUMMY*1
      CHARACTER *1 TAPE, RAMFL, IVT, IATTEN
      CHARACTER *80 NAMERAM, IFILE, NAMEO
      CHARACTER*80 RADARFILE
      CHARACTER CHARDATE*8,CHARTIME*10,CHARZONE*5
      INTEGER TIMEVALUES(8)
      DIMENSION BIN(MAX_HRD_DIM),REF(MAX_HRD_DIM),BIN1(MAX_HRD_DIM)
      DIMENSION REF1(MAX_HRD_DIM),RADIIATTEN(MAX_HRD_DIM)
c      SAVE ISWEEPCHECK,BINONE,REFONE,TIMEONE,RLATONE,RLONONE
c      SAVE RAONE,AZMONE,EVONE,RCAZM,AZELONE,AZELTWO,PELEVONE
c      SAVE ICONSERVE,ITAPEOPEN,RDTAIIN,RADTEST,PAZMONE
c      SAVE NAZSUM,AZSUMX,AZSUMY,IFRANCE
c      SAVE TIMESLAST,TIME,TIMES
c      SAVE PCORS,DCORS,ELCORS,RCORS,RDELCORTAS,AZMCORS
c      SAVE V0ONE,RDVWSONE,RDVWS
c      SAVE AZIIN,AZIOUT,PROFILEANGLE,ELEVLIMIT
c      SAVE IHS,IMS,ISS,IHE,IME,ISE
c      SAVE IFLIGHTCHECK,IADD86400
      SAVE
      DATA AT1/5.33E-5/, AT2/0.889/
c      ALLOCATE(ICOL(MAX_HRD_DIM,800),JCOL(MAX_HRD_DIM,800))
c      ALLOCATE(XRSWEEP(MAX_HRD_DIM,800))
c      ALLOCATE(YRSWEEP(MAX_HRD_DIM,800))
c      ALLOCATE(ZRSWEEP(MAX_HRD_DIM,800))
 4275 DBZRADIUSMIN=100.
      INQUIRE(FILE='altitude_ring_remove',EXIST=ALTITUDERINGEXISTS)
C      IF(IAPPLYMASK.EQ.1.AND.IUNDERONLY.EQ.1)THEN
C         JTRAKAZMMIN=135
C         JTRAKAZMMAX=225
C      ELSE
C         JTRAKAZMMIN=-1
C         JTRAKAZMMAX=2001
C      ENDIF
      WRITE(6,*)'JTRAKAZMMIN,JTRAKAZMMAX = ',JTRAKAZMMIN,JTRAKAZMMAX
      IBLANKSWEEP=0
      write(6,*)'entered sweepread'
      write(6,*)'IDBZADD,IDBZMASK = ',IDBZADD,IDBZMASK
c      write(6,*)'RADRAT,RADMASK,IAPPLYMASK = ',RADRAT,RADMASK,IAPPLYMASK
c      PAUSE
c      WRITE(6,*)'IAFTFORE = ',IAFTFORE
c      PAUSE
      IMAXBINS=MAX_HRD_DIM
      JMAXRAYS=800
      CAIRCRAFT(1)='H'
      CAIRCRAFT(2)='I'
      IBST1=IBST(1)
c      write(6,*)'icallsweepin = ',icallsweepin
      DO I=1,800
       RDVWS(I)=-888.8
      ENDDO
      IF(ICALLSWEEPIN.EQ.0)THEN
      OPEN(89,FILE='looksweep')
      IF(ALTITUDERINGEXISTS)THEN
         OPEN(88,FILE='altitude_ring_remove')
         READ(88,'(A1)')ALTRINGREMOVE
         IF(ALTRINGREMOVE.EQ.'Y'.OR.ALTRINGREMOVE.EQ.'y')THEN
            IALTRINGREMOVE=1
         ELSE
            IALTRINGREMOVE=0
         ENDIF
         CLOSE(88)
      ELSE
         IALTRINGREMOVE=0
      ENDIF
      INQUIRE(FILE='maskzrdiffmax',EXIST=ZRDIFFMAXEXISTS)
      IF(ZRDIFFMAXEXISTS)THEN
         OPEN(88,FILE='maskzrdiffmax')
         READ(88,*)ZRDIFFMAX
         READ(88,*)ZSPECKLEMAX
         CLOSE(88)
         WRITE(6,'(A,F7.2)')'ZRDIFFMAX WAS READ AND IS',ZRDIFFMAX
      ELSE
         ZRDIFFMAX=100.
         ZSPECKLEMAX=100.
         WRITE(6,'(A,F7.2)')'ZRDIFFMAX WAS NOT READ AND IS',ZRDIFFMAX
      ENDIF
c       OPEN(93,FILE='profileangle.txt')
c       READ(93,*)PROFILEANGLE
       OPEN(99,FILE='BINOUT')
       PROFILEANGLE=91.
       ELEVLIMIT=90-PROFILEANGLE
c       CLOSE(93)
c       write(6,*)'profileangle,elevlimit = ',profileangle,elevlimit
       IFRANCE=0
       IFILECHECK=0
       TIMESLAST=0.
       RADTEST=-1.
       IFLIGHTCHECK=0
       DO I=1,2
        NAZSUM(I)=0
        AZSUMX(I)=0.
        AZSUMY(I)=0.
       ENDDO
       IF(INOUT.EQ.1.AND.IAFTFORE.EQ.1)THEN
        OPEN(95,FILE='inaftradazi_profile.txt')
        OPEN(96,FILE='inaftaircraftdata.txt')
       ELSEIF(INOUT.EQ.1.AND.IAFTFORE.EQ.2)THEN
        OPEN(95,FILE='inforeradazi_profile.txt')
        OPEN(96,FILE='inforeaircraftdata.txt')
       ELSEIF(INOUT.EQ.2.AND.IAFTFORE.EQ.1)THEN
        OPEN(95,FILE='outaftradazi_profile.txt')
        OPEN(96,FILE='outaftaircraftdata.txt')
       ELSEIF(INOUT.EQ.2.AND.IAFTFORE.EQ.2)THEN
        OPEN(95,FILE='outforeradazi_profile.txt')
        OPEN(96,FILE='outforeaircraftdata.txt')
       ELSEIF(INOUT.EQ.1)THEN
        OPEN(95,FILE='inbothradazi_profile.txt')
        OPEN(96,FILE='inbothaircraftdata.txt')
       ELSEIF(INOUT.EQ.2)THEN
        OPEN(95,FILE='outbothradazi_profile.txt')
        OPEN(96,FILE='outbothaircraftdata.txt')
       ENDIF    
      ELSE
       IFILECHECK=1
       IFLIGHTCHECK=1
      ENDIF
      IF(IUSEWIND.EQ.1)THEN
       SMOTIONU=SMOTIONU0
       SMOTIONV=SMOTIONV0
       CENTIME=CENTIME0
      ELSE
       SMOTIONU=0.
       SMOTIONV=0.
       CENTIME=CENTIME0
      ENDIF
      sin45 = sin(45. * 3.14159/180.)
      deg2rad = acos(-1.0) / 180.0
      rad2deg = 1.0 / deg2rad
      if(iplane.eq.2)then
       half_beam_ta = 1.35 ! degrees, vertical
      else
       half_beam_ta = 1.00 ! degrees, vertical
      endif
c      half_beam_lf = 2.05 ! degrees, vertical
      beam_wid = 2.0 * half_beam_ta
      WFLAG=-1.0E+10
C 
C DOPPLER processing program
c      write(6,*)'icallsweepin = ',icallsweepin
      ISWEEPSET=2
      SWEEPOLD=0.
      NUM_RAYS=0
      WRITE(6,*)'NUM_RAYS,IBST1 = ',NUM_RAYS,IBST1
c      PAUSE
      DO I=1,MAX_GATES
       DO J=1,MAX_RAYS
        SWEEP(I,J)=-888.8
        SWEEPZ(I,J)=-32.0
       ENDDO
      ENDDO
c      write(6,*)'imx,jmx,kmx = ',imx,jmx,kmx
c      write(6,*)'sx,sy,sz = ',sx,sy,sz
c      write(6,*)'xz,yz,zz = ',xz,yz,zz
      IF(ICALLSWEEPIN.EQ.1)THEN
       NUM_RAYS=0
c       IF(IYEARTEST.GE.2017.AND.IPLANE.EQ.1)THEN
c       ENDIF
      ENDIF
      IF(ICALLSWEEPIN.EQ.0)THEN
       write(6,*)'go to jobfile reading'
       ISWEEPSET=0
c       OPEN(1,FILE='/dev/tty')
       IF(IUSEWIND.NE.1)THEN
c        WRITE(6,*)'be conservative on first pass y(1)/n(0)'
c        READ(5,*)ICONSERVE
        ICONSERVE=1
       ELSE
        ICONSERVE=0
       ENDIF
c       WRITE(6,*)'Enter job file name'
c       READ(5,'(A80)')IFILE
       IF(INOUT.EQ.1)THEN
        IFILE='jobfile_radar_in'
       ELSE
        IFILE='jobfile_radar_out'
       ENDIF
       OPEN(84,FILE=IFILE,IOSTAT=IERR,ERR=998,STATUS='OLD')
C The Following Parameters are read from input file  - ncepwrite_file.job
C Read Flight ID and Storm Name
      READ(84,'(A8)')IFLT
      READ(84,'(A12)')INM
      DO JIJ=1,7
       READ(84,'(A1)')DUMMYREAD
      ENDDO
C      READ(84,'(A8,1X,A12)',IOSTAT=IERR,ERR=999) IFLT,INM
C Read Line Printer LU#, Tape LU# & flag for printing parameters
      LP=6
      READ(84,*)LUNRT
c      WRITE(6,*)'LUNRT = ',LUNRT
C       READ(84,'(I2,1X,I2)',IOSTAT=IERR,ERR=999) LP,LUNRT
C1       READ(84,*)ITAPEOPEN
C       IF(LUNRT.GT.6)THEN
C        WRITE(6,*)'YOU ARE USING TAPE DRIVE ',LUNRT
C        WRITE(6,*)'IF CORRECT ENTER 1, OTHERWISE 0'
C        READ(5,*)ILUNRT
C        IF(ILUNRT.NE.1)THEN
C         WRITE(6,*)'REENTER TAPE DRIVE UNIT NUMBER'
C         WRITE(6,*)'IF YOU MEANT TO USE A FILE ENTER 0'
C         READ(5,*)LUNRT
C        ENDIF
C       ELSE
C        WRITE(6,*)'YOU WILL BE READING FROM A RADAR FILE'
C       ENDIF
C       READ(84,'(A80)')RADARFILE
      RADARFILE='DUMMY'
      IF(LUNRT.GT.6)THEN
       ITAPEOPEN=1
      ELSE
       ITAPEOPEN=0
      ENDIF
c      IF(ITAPEOPEN.EQ.1)THEN
C       CALL TAPEOPEN(LUNRT,0,LUNR)
C       CALL TAPECONTROL(LUNR,2,1) !back up 1 file
c       WRITE(6,*)'STOP AT 2'
c       STOP
c      ELSE
c       OPEN(80,FILE=RADARFILE,FORM='UNFORMATTED',RECL=2,
c     1       ACCESS='DIRECT')
c      ENDIF
      WRITE(LP,'(1X,"NCEP program to write doppler on disc: ",A)')
     +      IFILE
      WRITE(LP,'(2X,"Date:",1X,A8,2X,"Name: ",A12,/,
     +        2X,"Line-Printer:",1X,I2,2X,"Tape-LU#:",I2)')
     + IFLT,INM,LP,LUNRT
C Read Ram File Flag{Y/N} and the Ram File Name 
C       READ(84,'(A1,1X,A80)',IOSTAT=IERR,ERR=999) RAMFL,NAMERAM 
C       IF(RAMFL.EQ.'y')RAMFL='Y'
C       IF(RAMFL.EQ.'n')RAMFL='N'
      RAMFL='N'
C      CALL CASEFOLD(RAMFL)
C Open the Ram File 
      IF (RAMFL .EQ. 'Y') THEN
          CALL OPENRAMFILE(NAMERAM,LP,STIMERAM,ETIMERAM,DATARATE,IERR)
          IF (IERR .NE. 0) GO TO 1050
          WRITE(LP,'(2X,"RAMFL= ",A1,1X,A80)') RAMFL,NAMERAM
      ENDIF 
C Read Unfolding Flag{Y/N},first guess wind and speed
C       READ(84,*,IOSTAT=IERR,ERR=999) IUNFOLDFLAG,WD,WS
      INFOLDFLAG=1
      WD=0.
      WS=1.
c       iunfoldflag=0
      WRITE(LP,'(2X,"IUNFOLDFLAG= ",I1," WD= ",F6.1," WS= ",F6.1)')
     +      IUNFOLDFLAG,WD,WS
C Read the starting bin and the number of bins for averaging
      READ(84,*,IOSTAT=IERR,ERR=999) IBST(1),INOB(1) 
       INQUIRE(FILE='ibstfile',EXIST=IBSTFILEEXISTS)
       IF(IBSTFILEEXISTS)THEN
        WRITE(6,*)'Substituting IBST(1) and INOB(1) from backdoor file'
          OPEN(92,FILE='ibstfile')
          READ(92,*)IBST(1),INOB(1)
          CLOSE(92)
       ENDIF
      WRITE(LP,'(2X,"IBST= ",I4," INOB= ",I4)') IBST(1),INOB(1)
C Enter AZM, Elevation & rdel corrs.
      READ (84,*,IOSTAT=IERR,ERR=999) AZMCORS(1),ELCORS(1),
     +                                  RDELCORTAS(1)
      WRITE(LP,'(2X,"TA AZMCOR=",F6.2,2X,"ELCOR= ",F6.2,
     +      2X,"RDELCORTA= ",F6.2)') AZMCORS(1),ELCORS(1),
     +                               RDELCORTAS(1)
C Enter Pitch, drift and roll corrections:
      READ (84,*,IOSTAT=IERR,ERR=999) PCORS(1),DCORS(1),RCORS(1)
      WRITE(LP,'(2X,"TA PCOR= ",F5.1,2X,"DCOR= ",F5.1,
     +      2X,"RCOR= ",F5.1)') PCORS(1),DCORS(1),RCORS(1)
C Enter AZM, Elevation & rdel corrs.
      READ (84,*,IOSTAT=IERR,ERR=999) AZMCORS(2),ELCORS(2),
     +                                  RDELCORTAS(2)
      RDELCORTA=RDELCORTAS(1)
      WRITE(LP,'(2X,"TF AZMCOR=",F6.2,2X,"ELCOR= ",F6.2,
     +      2X,"RDELCORTA= ",F6.2)') AZMCORS(2),ELCORS(2),
     +                               RDELCORTAS(2)
C Enter Pitch, drift and roll corrections:
      READ (84,*,IOSTAT=IERR,ERR=999) PCORS(2),DCORS(2),RCORS(2)
      WRITE(LP,'(2X,"TF PCOR= ",F5.1,2X,"DCOR= ",F5.1,
     +      2X,"RCOR= ",F5.1)') PCORS(2),DCORS(2),RCORS(2)
C Read threshold value
      READ (84,*,IOSTAT=IERR,ERR=999) THRESH,DBZRS,DBZCOR,DBZSLOPE
      WRITE(LP,'(2X,"NOISE VALUE= ",F5.1,2X,"DBZRS= ",F5.1,
     +          "DBZSLOPE= ",F5.1,2X,"DBZCOR= ",F5.1)')
     +       THRESH,DBZRS,DBZSLOPE,DBZCOR
C Read spectral width threshold value
      READ (84,*,IOSTAT=IERR,ERR=999) swthresh
      INQUIRE(FILE='changesqi',EXIST=SQIEXISTS)
      IF(SQIEXISTS)THEN
        OPEN(88,FILE='changesqi')
        READ(88,*)SWTHRESH
        CLOSE(88)
      ENDIF
      INQUIRE(FILE='despeckleyesno',EXIST=DESPECKLEEXISTS)
      IF(DESPECKLEEXISTS)THEN
         OPEN(37,FILE='despeckleyesno')
         READ(37,'(A1)')DESPECKLEYESNO
         IF(DESPECKLEYESNO.EQ.'0'.OR.DESPECKLEYESNO.EQ.'N'.OR.
     +      DESPECKLEYESNO.EQ.'n')THEN
            IDESPECKLE=0
            IOLDDESPECKLE=0
         ELSEIF(DESPECKLEYESNO.EQ.'O'.OR.DESPECKLEYESNO.EQ.'o')THEN
            READ(37,*)NUMTIMES
            READ(37,*)NUMCONTIG
            IOLDDESPECKLE=1
            IDESPECKLE=1
         ELSE
            READ(37,*)NUMTIMES
            READ(37,*)NUMCONTIG
            IOLDDESPECKLE=0
            IDESPECKLE=1
         ENDIF
         CLOSE(37)
      ELSE
         IDESPECKLE=1
         NUMTIMES=3
         NUMCONTIG=3
         IOLDDESPECKLE=1
      ENDIF
      SWPASS=SWTHRESH
      IF (SWTHRESH.LE.0.0 .OR. SWTHRESH.GT.13.0) SWTHRESH=99.0
      SWTHRESH=99.
       WRITE(LP,'(2X,"SPECTRAL WIDTH THRESHOLD= ",F5.1)') swthresh
C Read Flag for adding the Terminal Velocity Corr. Value, the height &
C depth of the bright band, P. Willis or Joss VT.
      IVT='N'
      HTBB=5.5
      DBB=2.
      IRSW=0
C       READ (84,*,IOSTAT=IERR,ERR=999) IVT,HTBB,DBB,IRSW
      IF(IVT.EQ.'n')IVT='N'
      IF(IVT.EQ.'y')IVT='Y'
C      CALL CASEFOLD(IVT)
      WRITE(LP,'(2X,''VT= '',A1," HTBB= ",F6.2," DBB= ",F6.2, 
     +           " IRSW= ",I1)') 
     +      IVT,HTBB,DBB,IRSW
      IF (IVT .EQ. 'N') HTBB= -99.0
C Read flag to add the intervening attenuation
      IATTEN='N'
C       READ (84,*,IOSTAT=IERR,ERR=999) IATTEN
      IF(IATTEN.EQ.'y')IATTEN='Y'
      IF(IATTEN.EQ.'n')IATTEN='N'
C      CALL CASEFOLD(IATTEN) 
      IF (IATTEN .EQ. 'Y') THEN 
C compute attenuation table if flag is on 
          CALL MAKEATTENTABLE1(2)
          WRITE(LP,'(1X,"Intervening attenuation: A=",E10.2, 
     +   "*Z**",F4.2)') AT1,AT2
          IATTENFLAG = 1
      ELSE
         IATTENFLAG = 0
      ENDIF   
C Read Start Time and End Time
      READ(84,'(3I2,1X,3I2)',IOSTAT=IERR,ERR=999)
     +     IHS,IMS,ISS,IHE,IME,ISE
      WRITE(LP,'(2X,"Start Time:",3I2.2,2X,"End Time:",3I2.2)')
     +IHS,IMS,ISS,IHE,IME,ISE
C Read a second tape:
       TAPE='N'
C       READ(84,'(A1)',IOSTAT=IERR,ERR=999) TAPE
      IF(TAPE.EQ.'y')TAPE='Y'
      IF(TAPE.EQ.'n')TAPE='N'
C      CALL CASEFOLD(TAPE)
C 
C Read Disk File Name 
C       READ(84,'(A)',IOSTAT=IERR,ERR=999) NAMEO
      READ(84,*)DUMMY
      READ(84,*)DUMMY
      READ(84,*)DUMMY
      READ(84,'(A1)')CDUMMY
      READ(84,*)AZIIN,AZIOUT
      READ(84,'(A80)')RADARFILE
      WRITE(6,*)'RADARFILE = ',RADARFILE
c      PAUSE
      IF(LUNRT.GT.6)THEN
       ITAPEOPEN=1
      ELSE
       ITAPEOPEN=0
C       WRITE(6,*)'Enter name of radar file'
C       READ(84,'(A80)')RADARFILE
      ENDIF
      READ(84,*)IFRANCENO
      IF(IFRANCENO.EQ.3)THEN
       IFRANCE=2
      ELSE
       IFRANCE=IFRANCENO
      ENDIF
      WRITE(6,*)'IFRANCE,IFRANCENO = ',IFRANCE,IFRANCENO
c      PAUSE
      IF(ITAPEOPEN.EQ.1)THEN
       CALL TAPEOPEN(LUNRT,0,LUNR)
       CALL TAPECONTROL(LUNR,2,1) !back up 1 file
c        WRITE(6,*)'STOP AT 3'
c        STOP
      ELSE
       LUNR=80
       IF(ISIGMET.NE.5)THEN
        WRITE(6,*)'OPENED RADAR DIRECTORY'
        LUNRNC=LUNR
        CALL substitute_open_rvp8_file(RADARFILE,LUNRNC,1,IERROPEN)
C Use the following two lines when GPS data are not available in sweep files
c        nav_choice=1
c        alt_choice=3
        LUNR=LUNRNC
       ELSE
       LUNRNC=LUNR
       CALL OPENRADARFILE(RADARFILE,LUNRNC,1,IERROPEN)
       LUNR=LUNRNC
c        OPEN(80,FILE=RADARFILE,FORM='UNFORMATTED',RECL=2,
c     1       ACCESS='DIRECT')
       ENDIF
      ENDIF
      WRITE(6,*)'ISIGMET,IATCFNO, = ',ISIGMET
      IF(ISIGMET.EQ.5)THEN
       READ(84,*)IATCFNO
       READ(84,*,END=842)SWTHRESH
       GO TO 841
 842   SWTHRESH=6.25
       WRITE(6,*)'SWTHRESH = ',SWTHRESH
       GO TO 1840
      ENDIF
      IF(ISIGMET.EQ.8)THEN
       READ(84,*)IATCFNO
       WRITE(6,*)'IATCFNO = ',IATCFNO
c       PAUSE
       READ(84,*,END=840)SWPASS2
       GO TO 841
 840   IF(IYEARTEST.GE.2017.AND.IPLANE.EQ.1)THEN
        SWPASS2=0.63
       ELSEIF(IPLANE.EQ.2)THEN
        SWPASS2=SWPASS
       ELSE
        SWPASS2=0.
       ENDIF
       GO TO 1840
      ENDIF
 841  READ(84,*,END=1840)AFTVNYQ
      GO TO 1842
 1840 AFTVNYQ=-888.8
 1842 CLOSE(84)
      IF(ISIGMET.EQ.5)THEN
       WRITE(6,*)'SWTHRESH = ',SWTHRESH
      ELSE
       WRITE(6,*)'SWPASS,SWPASS2,AFTVNYQ = ',SWPASS,SWPASS2,AFTVNYQ
      ENDIF
      NAMEO='DUMMY'
      ENDIF
c      WRITE(LP,'(2X,"NCEP Output File Name:",A)') NAMEO
c      WRITE(LP,*)trakazm,trakelev,driftnew,
c     +         rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(1),ibst(2),
c     +         inob(1),inob(2),ileg,xniq,irsw,maxnbins,v0,
c     +         pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
c     +         iunfoldflag,iattenflag,
c     +         badstabflag,surfelimflag,echoflag,atmflag
C Open Disk File
c      OPEN(320,FILE=NAMEO,IOSTAT=IERR,ERR=1000,STATUS='UNKNOWN',
c     +     FORM='unformatted') 
C 
      STIME=FLOAT(IHS)*3600.0 + FLOAT(IMS)*60.0 + FLOAT(ISS)
      ETIME=FLOAT(IHE)*3600.0 + FLOAT(IME)*60.0 + FLOAT(ISE)
C
C Search for the start time:
c971   write(6,*)'itapeopen,icallsweepin = ',itapeopen,icallsweepin
971   IF(ICALLSWEEPIN.EQ.0)THEN
97100  ROLDTIME=200000.
c97100  WRITE(6,*)'CALLING READTAPE'
       kwords=0
       nwords=-1
       IF(ISIGMET.NE.5)THEN
        LUNRNC=LUNR
        STIMENC=STIME
        CALL RVP8_SEARCH(LUNRNC,2,2,STIMENC,IERR)
        LUNR=LUNRNC
        STIME=STIMENC
        write(6,*)'returned from rvp8_search first'
       ELSE
        LUNRNC=LUNR
        STIMENC=STIME
        CALL DISCSEARCH(LUNRNC,2,2,STIME,IERR)
        LUNR=LUNRNC
        STIME=STIMENC
       ENDIF 
       CALL READTAPE(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,RCAZM,
     +  ITAPEOPEN,RADARFILE,NUMREC,PCORS,DCORS,RCORS,AZMCORS,
     +  RDELCORTAS,ELCORS,ISIGMET,NDO)
       IF(IFLIGHTCHECK.EQ.0)THEN
        IFLIGHTCHECK=1
        INAIR=1
        IF(ISIGMET.NE.5)iyear=iyear-2000
        if(iyear.lt.0)iyear=iyear+100
        write(6,6104)iyear,month,iday,caircraft(inair)
        write(IFLTCHK,6104)iyear,month,iday,caircraft(inair)
6104    FORMAT(3I2.2,A)
        read(IFLT,'(A7)')IFLTCHK2
        WRITE(6,'(A7)')IFLTCHK
        write(6,'(A7)')IFLTCHK2
        READ(IFLT,'(3I2,A1)')IYEAR,MONTHTAPE,IDAYTAPE,CCHECK
        IYEARTAPE=IYEAR
        IF(CCHECK.EQ.'H')THEN
         NAIRCRAFT=42
        ELSEIF(CCHECK.EQ.'I')THEN
         NAIRCRAFT=43
        ELSEIF(CCHECK.EQ.'N')THEN
         NAIRCRAFT=49
        ENDIF
        IF(NAIRCRAFT.EQ.42)THEN
         INAIR=1
        ELSEIF(NAIRCRAFT.EQ.43)THEN
         INAIR=2
        ELSEIF(NAIRCRAFT.EQ.49)THEN
         INAIR=3
         WRITE(6,*)'NAIRCRAFT = ',NAIRCRAFT
         WRITE(6,*)'NAIRCRAFT DOES NOET EQUAL 42 OR 43'
c         STOP
        ENDIF
         WRITE(6,*)'IYEAR = ',IYEAR
c        PAUSE
        IF(IAFTFORE.EQ.1.AND.NAIRCRAFT.EQ.42)THEN
         OPEN(58,FILE='aft_42.mask')
         WRITE(6,*)'OPENED aft_42.mask'
        ELSEIF(IAFTFORE.EQ.2.AND.NAIRCRAFT.EQ.42)THEN
         OPEN(58,FILE='fore_42.mask')
         WRITE(6,*)'OPENED fore_42.mask'
        ELSEIF(IAFTFORE.EQ.1.AND.NAIRCRAFT.EQ.43)THEN
         OPEN(58,FILE='aft_43.mask')
         WRITE(6,*)'OPENED aft_43.mask'
        ELSEIF(IAFTFORE.EQ.2.AND.NAIRCRAFT.EQ.43)THEN
         OPEN(58,FILE='fore_43.mask')
         WRITE(6,*)'OPENED fore_43.mask'
        ELSEIF(IAFTFORE.EQ.1.AND.NAIRCRAFT.EQ.49)THEN
         OPEN(58,FILE='aft_49.mask')
         WRITE(6,*)'OPENED aft_49.mask'
        ELSEIF(IAFTFORE.EQ.2.AND.NAIRCRAFT.EQ.49)THEN
         OPEN(58,FILE='fore_49.mask')
         WRITE(6,*)'OPENED fore_49.mask'
        ENDIF
        IF(IAFTFORE.LE.2)THEN
           DO J=1,360
              READ(58,'(A)')CDUMMY
              READ(58,'(A)')CDUMMY
              READ(58,*)(AVGDBZ1(I,J),I=1,610)
              READ(58,'(A)')CDUMMY
              READ(58,*)(AVGDBZ2(I,J),I=1,610)
              DO I=66,610
                 AVGDBZ2(I,J)=-60.
              ENDDO
           ENDDO
           CLOSE(58)
        ELSE
           DO J=1,360
              DO I=1,610
                 AVGDBZ1(I,J)=0.
                 AVGDBZ2(I,J)=0.
              ENDDO
           ENDDO
        ENDIF
        IF(IYEAR.LT.50)THEN
         IYEARTEST=IYEAR+2000
        ELSE
         IYEARTEST=IYEAR+1900
        ENDIF
        CALL FINDIDAYS(IDAYSCHK,NAIRCHK,IFLTCHK)
        CALL FINDIDAYS(IDAYSCHK2,NAIRCHK2,IFLTCHK2)
        WRITE(6,*)'IDAYS FROM JOBFILE = ',IFLTCHK2
        WRITE(6,*)'IDAYS FROM TAPE = ',IFLTCHK
        IDAYSDIFF=IDAYSCHK-IDAYSCHK2
        IF(IDAYSDIFF.EQ.1)THEN
         IADD86400=1
        ELSE
         IADD86400=0
        ENDIF
        IADD86400=0
        IF(IFLTCHK2.NE.IFLTCHK)THEN
         write(6,*)'flight id on jobfile inconsistent with tape'
c         write(6,*)'do you want to continue?'
c         OPEN(1,FILE='/dev/tty')
c         READ(5,'(A1)')IYES
c         CLOSE(1)
c         IF(IYES.EQ.'N'.OR.IYES.EQ.'n')THEN
c          WRITE(6,*)'rerun jobfilemaker and continue'
c          STOP
c         ENDIF
        ENDIF
c        PAUSE
       ENDIF
       IF(IADD86400.EQ.1)TIME=TIME+86400.
c       WRITE(6,*)'TIME,RLAT,RLON = ',TIME,RLAT,RLON
c       WRITE(6,*)'TIME,OLDTIME = ',TIME,ROLDTIME
       IF(TIME.EQ.ROLDTIME)GO TO 97100
       TIMEMSTIME=TIME-STIME
c       WRITE(6,*)'TIME,STIME,TIMEMSTIME = ',TIME,STIME,TIMEMSTIME
       IF(TIMEMSTIME.LT.-72000..AND.ITAPEOPEN.EQ.1)THEN
c        WRITE(6,*)'BACKSPACING'
        CALL TAPECONTROL(LUNR,2,1)
        CALL TAPECONTROL(LUNR,2,1)
c         WRITE(6,*)'STOP AT 4'
c         STOP
        ROLDTIME=TIME
        GO TO 97100
       ENDIF
       write(6,*)'calling tapesearch'
97101  IF(IADD86400.EQ.1)THEN
        STIMESEARCH=STIME-86400
       ELSE
        STIMESEARCH=STIME
       ENDIF
       IF(LUNR.NE.80)THEN
        CALL TAPESEARCH(LUNR,2,2,STIMESEARCH,IERR)
c         WRITE(6,*)'STOP AT 1'
c         STOP
       ELSE
c        WRITE(6,*)'CALLING DISCSEARCH'
C        CALL DISCSEARCH(LUNR,2,2,STIMESEARCH,IERR)
c****March 17 2015
        IF(ISIGMET.EQ.5)THEN
c         WRITE(6,*)'CALLING DISCSEARCH'
         LUNRNC=LUNR
         CALL DISCSEARCH(LUNR,2,2,STIMESEARCH,IERR)
         LUNR=LUNRNC
        ENDIF
c****March 17 2015
       ENDIF
c        write(6,*)'called discsearch'
        timetest=itimex(2)
c        write(6,*)'timetest,etime = ',timetest,etime
        if(timetest.gt.etime)then
         itimex(2)=1
         time=itimex(2)
c         write(6,*)'new time,itimex = ',time,itimex(2)
         ierr=20
         go to 97101
        endif
       IF (IERR.LT.0) GO TO 970
      CALL READTAPE(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,RCAZM,
     +ITAPEOPEN,RADARFILE,NUMREC,PCORS,DCORS,RCORS,AZMCORS,
     +RDELCORTAS,ELCORS,ISIGMET,NDO)
      IF(IADD86400.EQ.1)TIME=TIME+86400.
       IF((TIME-STIME).LT.-60000..AND.ITAPEOPEN.EQ.1)THEN
        CALL TAPECONTROL(LUNR,2,1) !back up 1 file
        CALL TAPECONTROL(LUNR,2,1) !back up 1 file
        GO TO 97101
       ENDIF
       IF((TIME-STIME).LT.1.)THEN
c        WRITE(6,*)'SETTING IFILECHECK TO 1'
        IFILECHECK=1
       ELSE
        WRITE(6,*)'TIME IS ',TIME
       ENDIF
      ENDIF
      OLDTIME=0
      ITIMECHECK=0
      NBINSMAX=0
      IF(IAFTFORE.EQ.2)RDELCORTA=RDELCORTAS(2)
C      WRITE(6,*)'START XNIQ AND XNIQTA = ',XNIQ,XNIQTA
c7040  write(6,*)'calling readtape'
7040  CALL READTAPE(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,RCAZM,
     +ITAPEOPEN,RADARFILE,NUMREC,PCORS,DCORS,RCORS,AZMCORS,
     +RDELCORTAS,ELCORS,ISIGMET,NDO)
c      write(6,*)'RA,GROUNDADJUST = ',RA,GROUNDADJUST
      DO I=1,MAX_HRD_DIM
         RADIIATTEN(I)=RADIITA(I)
      ENDDO
      RA=RA-GROUNDADJUST
c      WRITE(6,*)'CORRECTED RA = ',RA
C      WRITE(99,*)'RADVGS,RADVWS,NBINS = ',RADVGS,RADVWS,NBINS
      IF(IAFTFORE.EQ.1.AND.ELEV.GE.0..AND.ICALLSWEEPIN.NE.0)GO TO 7040
      IF(IAFTFORE.EQ.2.AND.ELEV.LE.0..AND.ICALLSWEEPIN.NE.0)GO TO 7040
      IF(IAFTFORE.EQ.1.AND.AFTVNYQ.GT.0.)THEN
         XNIQ=AFTVNYQ
         XNIQTA=AFTVNYQ
      ENDIF
      TIMES=TIME
      ISCANDIM=NBINS
      IF((IYEARTEST.GE.2019.AND.INAIR.EQ.1).OR.
     +   (IYEARTEST.GE.2020.AND.INAIR.EQ.2))THEN
         DO I=1,76
            IF(REF(I).GT.-32.)REF(I)=REF(I)+9.
         ENDDO
      ENDIF
      DO I=1,NBINS
         IF(REF(I).LE.-32..AND.BIN(I).GT.-800..AND.I.GT.200)THEN
            WRITE(6,*)'I,REF,BIN = ',I,REF(I),BIN(I)
         ENDIF
      ENDDO
      IF(NDO.NE.0)GO TO 76583
      CALL VRLOCATER(TIMES,OLAT,OLON,
     +  RLAT,RLON,RA,EV,AZM,RDTAIIN,XR,YR,ZR,
     +  ISCANDIM,SMOTIONU,SMOTIONV,CENTIME)
C       PAUSE
C      WRITE(6,*)'NUM_RAYS = ',NUM_RAYS
C      WRITE(6,*)'BIN = ',(BIN(I),I=1,NBINS)
c      WRITE(6,*)'SWPASS = ',SWPASS
      SWPASSTEST=SWPASS*XNIQTA
      SWPASSTEST7=SWPASSTEST*.45
c      SWPASS=0.
c      WRITE(6,*)'SWPASSTEST = ',SWPASSTEST
c      WRITE(6,2684)(WIDTHBUFFER(I),I=1,200)
c      WRITE(6,2684)(DBZBUFFER(I),I=1,200)
 2684 FORMAT(10F8.2)
      RA1000=RA/1000.
c      WRITE(6,*)'RA1000 = ',RA1000
C      WRITE(6,*)'IYEAR,IYEARTAPETEST,SWPASS,SWPASS2 = ',
C     +           IYEAR,IYEARTAPETEST,SWPASS,SWPASS2
      DO I=1,MAX_HRD_DIM
       RADDIFF=ABS(RDTAIIN(I)-RA/1000.)
       RATEST=RDTAIIN(I)/RA1000
       IF(IYEARTEST.GT.2016.AND.RDTAIIN(I).LT.10..AND.IPLANE.EQ.1)THEN
          IYEARTAPETEST=1
       ELSE
          IYEARTAPETEST=0
       ENDIF
       IF(ISIGMET.EQ.8.AND.WIDTHBUFFER(I).LT.SWPASS2)THEN
         BIN(I)=-888.8
         REF(I)=-32.
       ENDIF
       IF(WIDTHBUFFER(I).LT.SWPASS.AND.ISIGMET.EQ.8)THEN
        IF(IPLANE.NE.1.OR.RADDIFF.LT.2..OR.IYEARTAPETEST.EQ.1)THEN
         BIN(I)=-888.8
         REF(I)=-32.
        ENDIF
       ELSEIF(ISIGMET.EQ.5.AND.
     + ((WIDTHBUFFER(I).GT.SWPASSTEST.AND.RADDIFF.LT.2.).OR.
     +  WIDTHBUFFER(I).LE.0.02))THEN
        BIN(I)=-888.8
        REF(I)=-32.
       ELSEIF(ISIGMET.EQ.5.AND.
     + ((WIDTHBUFFER(I).GT.SWPASSTEST.AND.RATEST.LT.2..AND.
c     + ((WIDTHBUFFER(I).GT.5..AND.RATEST.LT.2..AND.
     +   ZR(I).LE.2.).OR.
c     +   RATEST.GT.1.2.AND.RADDIFF.GE.2..AND.ZR(I).LT.3.).OR.
     +  WIDTHBUFFER(I).LE.0.02))THEN
c        write(6,*)'i,widthbuffer,ra,rdtaiin,ratest,zr,swpasstest = ',
c     + i,widthbuffer(i),ra,rdtaiin(i),ratest,zr(i),swpasstest
        BIN(I)=-888.8
        REF(I)=-32.
       ENDIF
      ENDDO
c spectral width
c      DO I=1,MAX_HRD_DIM
c       IF(REF(I).GT.0.)REF(I)=REF(I)*10.
c      ENDDO
c spectral width
      IF(ABS(V0).GT.100.)THEN
       DO I=1,MAX_HRD_DIM
        BIN(I)=-888.8
       ENDDO
      ENDIF
C      WRITE(99,*)'7040 NUM_RAYS = ',NUM_RAYS
C      write(99,*)'BIN IN sweepread_vrrms_rvp8_new.f'
C      WRITE(99,6427)(BIN(I),I=1,600)
C      IF(NUM_RAYS.GT.0)PAUSE
 6427 FORMAT(10F8.1)
      IF(NIX.EQ.-200)GO TO 7040
      IF(NBINS.EQ.0)GO TO 7040
      IF(NBINS.GT.NBINSMAX)NBINSMAX=NBINS
      DO I=2,MAX_HRD_DIM
       IF(RADIITA(I).LT.RADIITA(I-1))THEN
        RADIITA(I)=1000.
       ENDIF
      ENDDO
      DO I=1,NBINS
       IF(REF(I).GT.-32..AND.RADIITA(I).GT.0.)THEN
        DBZRADIUS=REF(I)-10*ALOG10(RADIITA(I)/10.)
        IF(DBZRADIUS.LT.DBZRADIUSMIN)DBZRADIUSMIN=DBZRADIUS
c        WRITE(6,*)'I,REF,RADIITA,DBZRADIUS = ',
c     +   I,REF(I),RADIITA(I),DBZRADIUS
        IF(DBZRADIUS.LT.-100.)THEN
         VELBUFFER(I)=-888.88
         DBZBUFFER(I)=-32.00
         REF(I)=-888.88
         BIN(I)=-888.88
        ENDIF
       ENDIF
      ENDDO
      TRACKLATLON=180./3.14159*ATAN2(GSE,GSN)
      IF(TRACKLATLON.LT.0.)TRACKLATLON=TRACKLATLON+360.
      TRACKDIFF=TRACK-TRACKLATLON
      IF(TRACKDIFF.GT.180.)TRACKDIFF=TRACKDIFF-360.
      IF(TRACKDIFF.LT.-180.)TRACKDIFF=TRACKDIFF+360.
      IF(TRACKDIFF.GT.2.)THEN
c      IF(ABS(TRACKDIFF).GT.2..OR.ABS(PITCH).LT..1.OR.
c     +   ABS(HEADING).LT..1)THEN
C     +   ABS(ROLL).LT..1.OR.ABS(HEADING).LT..1)THEN
       DO I=1,MAX_HRD_DIM
        BIN(I)=-888.8
        BIN1(I)=-888.8
        REF(I)=-32.
        REF1(I)=-32.
       ENDDO
      ENDIF
c      IF(IPLANE.EQ.1)THEN
       DO I=1,MAX_HRD_DIM
        IF(REF(I).GT.-32.)REF(I)=REF(I)+FLOAT(IDBZADD)
       ENDDO
c      ENDIF
      IF(IADD86400.EQ.1)TIME=TIME+86400.
C      write(99,*)'BIN AFTER IFRANCETEST, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,6427)(BIN(I),I=1,600)
      IF(ABS(ELEV).LT..001.OR.ABS(ROLL).GT.ROLLTOL)THEN
       DO I=1,MAX_HRD_DIM
        BIN(I)=-888.88
       ENDDO
      ENDIF
C      write(99,*)'BIN AFTER ROLLTEST, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,*)'ELEV AND ROLL = ',ELEV,ROLL
C      WRITE(99,6427)(BIN(I),I=1,600)
      IF(ABS(ELEV).LT..001)THEN
       WRITE(6,*)'ELEV,DBZ = ',ELEV
       DO I=1,MAX_HRD_DIM
        REF(I)=-32.
       ENDDO
      ENDIF
C      write(99,*)'BIN AFTER ELEVTEST, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,6427)(BIN(I),I=1,600)
      IF(ABS(RADVGS).GT.15)THEN
       DO I=1,MAX_HRD_DIM
        BIN(I)=-888.88
       ENDDO
      ENDIF
C      write(99,*)'BIN AFTER RADVGSTEST, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,6427)(BIN(I),I=1,600)
      DO I=1,MAX_HRD_DIM
       IF(REF(I).GT.60.)THEN
        REF(I)=-32.
        BIN(I)=-888.88
       ENDIF
      ENDDO
C      write(99,*)'BIN AFTER REFTEST, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,6427)(BIN(I),I=1,600)
      DO I=2,MAX_HRD_DIM
       IF(RADIITA(I).LT.RADIITA(I-1))THEN
        DO L=I,MAX_HRD_DIM
         RADIITA(L)=1000.
        ENDDO
        GO TO 5699
       ENDIF
      ENDDO
5699  CONTINUE
C      write(99,*)'BIN AFTER 5699, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,6427)(BIN(I),I=1,600)
c      write(6,*)'back from readtape'
C      WRITE(6,*)'TIME,NTASWEEP,ISWEEPSET,ISWEEPCHECK = ',
C     + TIME,NTASWEEP,ISWEEPSET,ISWEEPCHECK
c      write(6,*)'time,stime = ',time,stime
      IF(TIME.GT.ETIME)THEN
c       write(6,*)'time,etime = ',time,etime
       IF(TIME-ETIME.GT.1000..AND.NTIMER.LT.100)THEN
        TIME=1
        ITIMEX(2)=1
        NTIMER=NTIMER+1
        GO TO 7040
       ELSE
        NTIMER=0
       ENDIF
      ENDIF
c      IF(TIME-ETIME.GT.1000.)GO TO 7040
      IF(TIME.GT.STIME.AND.IFILECHECK.EQ.0.AND.ITAPEOPEN.EQ.1)THEN
c       WRITE(6,*)'BACKING UP TWO FILES LOOKING FOR STARTIME'
       CALL TAPECONTROL(LUNR,2,1) !back up 1 file
       CALL TAPECONTROL(LUNR,2,1) !back up 1 file
C        WRITE(6,*)'STOP AT 5'
C        STOP
       IFILECHECK=1
       GO TO 971
      ELSE
       IFILECHECK=1
      ENDIF
      OOLAT=RLAT
      OOLON=RLON
      ALAT=.5*(RLAT+OLAT)
      ALON=.5*(RLON+OLON)
      XMOVE=(CENTIME-TIME)*SMOTIONU/1000.
      YMOVE=(CENTIME-TIME)*SMOTIONV/1000.
      DELX=XMOVE+(111.1*COS(ALAT*3.14159/180.)*(RLON-OLON))
      DELY=YMOVE+(111.1*(RLAT-OLAT))
      OLATDRIFT=OLAT-YMOVE/111.1
      OLONDRIFT=OLON-XMOVE/111.1/COS(ALAT*3.14159/180.)
      IF(ABS(DELX).LT..0001.AND.ABS(DELY).LT..0001)THEN
       STORMRADIUS=.0001
       DELX=.0001
       DELY=.0001
      ELSE
       STORMRADIUS=SQRT(DELX*DELX+DELY*DELY)
      ENDIF
      STORMAZIMUTH=180./3.14159*ATAN2(DELY,DELX)
c      WRITE(6,*)'DELX,DELY,STORMRADIUS,STORMAZIMUTH = ',DELX,DELY,
c     1 STORMRADIUS,STORMAZIMUTH
      IF(STORMRADIUS.GT.1000.)THEN
       STORMRADIUS=.0001
       DELX=.0001
       DELY=.0001
      ENDIF
c      WRITE(6,*)'DELX,DELY,STORMRADIUS,STORMAZIMUTH = ',DELX,DELY,
c     1 STORMRADIUS,STORMAZIMUTH
      VRAD=(UCOM*DELX+VCOM*DELY)/STORMRADIUS
      VTAN=(VCOM*DELX-UCOM*DELY)/STORMRADIUS
      IF(STORMAZIMUTH.LT.0.)STORMAZIMUTH=STORMAZIMUTH+360.
      TIMES=TIME
      TIMESINCE=TIMES-TIMESLAST
      AZITEST1=90.-AZIIN
      IF(AZITEST1.LT.0.)AZITEST1=AZITEST1+360.
      AZITEST2=90.-AZIOUT
      IF(AZITEST2.LT.0.)AZITEST2=AZITEST2+360.
      AZIDIFF1=STORMAZIMUTH-AZITEST1
      IF(AZIDIFF1.GT.180.)AZIDIFF1=AZIDIFF1-360.
      IF(AZIDIFF1.LT.-180.)AZIDIFF1=AZIDIFF1+360.
      AZIDIFF1=ABS(AZIDIFF1)
      AZIDIFF2=STORMAZIMUTH-AZITEST2
      IF(AZIDIFF2.GT.180.)AZIDIFF2=AZIDIFF2-360.
      IF(AZIDIFF2.LT.-180.)AZIDIFF2=AZIDIFF2+360.
      AZIDIFF2=ABS(AZIDIFF2)
C      WRITE(6,*)'STORMAZIMUTH,AZIDIFF1,AZIDIFF2 = ',
C     + STORMAZIMUTH,AZIDIFF1,AZIDIFF2
c      WRITE(6,*)'BEFORE AZIDIFF1,INOUT = ',AZIDIFF1,INOUT
      IF(AZIDIFF1.LT.45..AND.INOUT.EQ.1)THEN
       INOUTWRITE=1
      ELSEIF(AZIDIFF2.LT.45..AND.INOUT.EQ.2)THEN
       INOUTWRITE=2
      ELSE 
       INOUTWRITE=0
      ENDIF
c      WRITE(6,*)'AFTER AZIDIFF1,INOUT = ',AZIDIFF1,INOUTWRITE
c      write(6,*)'times,timeslast,timesince,inout,radius,azi = ',
c     + times,timeslast,timesince,inout,stormradius,stormazimuth
c      WRITE(6,'(4F10.4)')RLAT,OLAT,RLON,OLON
      INTTIME=INT(TIMES)
      ITH=INTTIME/3600
      ITM=(INTTIME-IH*3600)/60
      ITM1=ITM/10
      ITM2=ITM-ITM1*10
      ITS=INTTIME-IH*3600-IM*60
      ITS1=ITS/10
      ITS2=ITS-ITS1*10
      IF(TIMESINCE.GE.1.)THEN
       RAOUTPUT=RA/1000.
       WRITE(95,5207)INOUTWRITE,STORMRADIUS,STORMAZIMUTH,
     + ITH,ITM1,ITM2,ITS1,ITS2,RAOUTPUT
       WRITE(96,5207)INOUTWRITE,STORMRADIUS,STORMAZIMUTH,ITH,ITM1,ITM2,
     + ITS1,ITS2,VRAD,VTAN,DELX,DELY,UCOM,VCOM,OLATDRIFT,OLONDRIFT,
     + RADVWS,RADGS,RADVGS
c       WRITE(95,*)'AZITEST1,AZIDIFF1 = ',AZITEST1,AZIDIFF1
c       WRITE(95,*)'AZITEST2,AZIDIFF2 = ',AZITEST2,AZIDIFF2
5207   FORMAT(I1,2F8.2,X,I2,4I1,6F8.2,5F10.4)
       TIMESLAST=TIMES
      ENDIF
c      WRITE(95,'(8F10.4)')RLAT,OLAT,RLON,OLON,
c     1 DELX,DELY,STORMRADIUS,STORMAZIMUTH
      IF(IUSEWIND.NE.1)CENTIME=TIME
      ISCANDIM=MAX_HRD_DIM
      IBINS=MAX_HRD_DIM
      I150BEFORE=I150
      IF((RADIITA(51)-RADIITA(50)).GT..145)THEN
       I150=1
      ELSE
       I150=0
      ENDIF
      IF(ISIGMET.EQ.8)I150=1
      IF(I150BEFORE.NE.I150.AND.ICALLSWEEPIN.NE.0)IBLANKSWEEP=1
      RADRES=RADIITA(51)-RADIITA(50)
      MAXIAVG=300.
      IF(RADTEST.GT.0..AND.RADIITA(50).NE.RADTEST)THEN
       INEWRAD=1
       RADTEST=RADIITA(50)
      ELSE
       INEWRAD=0
      ENDIF     
      IF(TIME.LT.STIME)THEN
c       write(6,*)'calling int'
       ITIME=INT(TIME)
c       write(6,*)'returned from int'
       IF(ITIME.GT.ITIMECHECK)THEN
c        WRITE(6,*)'TIME,STIME = ',TIME,STIME
        ITIMECHECK=ITIME
       ENDIF
c       write(6,*)'going to 7040 time,stime = ',time,stime
       GO TO 7040
      ENDIF
c      if(trakazm.gt.85.and.trakazm.lt.86)then
c       write(6,*)'bin = ',bin
c      endif
c      write(6,*)'calling vrlocater'
c      IF(IUSEWIND.NE.1)THEN
c       I=1
c       RA1000=(RA/1000.)-.2
c       DO I=1,30
c        IF(BIN(I).GT.-98..AND.REF(I).GT.20.)GO TO 29654
c        IF(RADIITA(I).GT.2.)THEN
cc         WRITE(6,*)'GOING TO 7040 I,RADIITA,RA = ',I,RADIITA(i),RA1000
c         GO TO 7040
c        ENDIF
c       ENDDO
cc       WRITE(6,*)'GOING TO 7040'
c       GO TO 7040
c      ENDIF
29654 CALL VRLOCATER(TIMES,OLAT,OLON,
     + RLAT,RLON,RA,EV,AZM,RDTAIIN,XR,YR,ZR,
     + ISCANDIM,SMOTIONU,SMOTIONV,CENTIME)
c       write(6,*)'olat,olon,rlat,rlon = ',olat,olon,rlat,rlon
c      write(6,*)'returned from vrlocater'
       IF(NUM_RAYS.GE.0.AND.IUSEWIND.EQ.1)THEN
c        write(6,*)'olat,olon,rlat,rlon = ',olat,olon,rlat,rlon
c        write(6,*)'smotionu,smotionv,centime',smotionu,smotionv,centime
c        WRITE(6,*)'TRAKAZM = ',TRAKAZM
c        WRITE(6,*)'NUM_RAYS SPOT,TIMES,EV,XR,YR,ZR AT 1 = ',
c     +   TIMES,EV,XR(1),YR(1),ZR(1)
        RADIANEV=EV*3.14159/180.
        RADIANAZM=AZM*3.14159/180.
        DIRCOSX=COS(RADIANEV)*COS(RADIANAZM)
        DIRCOSY=COS(RADIANEV)*SIN(RADIANAZM)
        DIRCOSZ=SIN(RADIANEV)
        XMIN=-XZ
        YMIN=-YZ
        XMAX=-XZ+IMX*SX
        YMAX=-YZ+JMX*SY
        ZZMAX=ZZ+(KMX-1)*SZ
c       WRITE(6,*)'SX,SY,SZ,XZ,YZ,ZZ = ',SX,SY,SZ,XZ,YZ,ZZ
c       WRITE(6,*)'XMIN,YMIN,ZZMIN = ',XMIN,YMIN,ZZMIN
c       WRITE(6,*)'XMAX,YMZX,ZZMAX = ',XMAX,YMAX,ZZMAX
        DO IR=1,MAX_HRD_DIM
         IF(BIN(IR).GT.-800.)THEN
          IINT=INT((XR(IR)+XZ+.5*SX)/SX)
          JINT=INT((YR(IR)+YZ+.5*SY)/SY)
          KINT=1+INT((ZR(IR)-ZZ)/SZ)
          VRRAD(IR,NUM_RAYS+1)=0.
          VRSUM=0.
          DO I=IINT,IINT+1
           DO J=JINT,JINT+1
            DO K=KINT,KINT+1
             IF(I.GE.1.AND.I.LE.IMX)THEN
              IF(J.GE.1.AND.J.LE.JMX)THEN
               IF(K.GE.1.AND.K.LE.KMX)THEN
                IF(U(I,J,K).GT.WFLAG)THEN
                 XG=(I-1)*SX-XZ+.5*SX
                 YG=(J-1)*SY-YZ+.5*SY
                 ZG=(K-1)*SZ+ZZ
                 XI=XR(IR)-XG
                 YI=YR(IR)-YG
                 ZI=ZR(IR)-ZG
                 RADR=SQRT(XR(IR)*XR(IR)+YR(IR)*YR(IR))
                 RADG=SQRT(XG*XG+YG*YG)
                 VRAD=(U(I,J,K)*XG+V(I,J,K)*YG)/RADG
                 VTAN=(V(I,J,K)*XG-U(I,J,K)*YG)/RADG
                 URAD=(VRAD*XR(IR)-VTAN*YR(IR))/RADR
                 VRAD=(VRAD*YR(IR)+VTAN*XR(IR))/RADR
                 DISTPOINT=SQRT(XI*XI+YI*YI+ZI*ZI)
                 IF(DISTPOINT.GT.0.)THEN
                  RINT=1./DISTPOINT
                 ELSE
                  RINT=1000000.
                 ENDIF
                 VRRAD(IR,NUM_RAYS+1)=VRRAD(IR,NUM_RAYS+1)+
     1              RINT*(URAD*DIRCOSX+VRAD*DIRCOSY+
     1              W(I,J,K)*DIRCOSZ)
                 VRSUM=VRSUM+RINT
                ENDIF
               ENDIF
              ENDIF
             ENDIF
            ENDDO
           ENDDO
          ENDDO
          IF(VRSUM.GT.0.)THEN
           VRRAD(IR,NUM_RAYS+1)=VRRAD(IR,NUM_RAYS+1)/VRSUM
          ELSE
           VRRAD(IR,NUM_RAYS+1)=-888.8
          ENDIF
         ELSE
          VRRAD(IR,NUM_RAYS+1)=-888.8
         ENDIF
        ENDDO
       ENDIF
        ISCANONE=1
        RDTAONE=.0001
        BINNONE=0.
        REFFONE=0.
        CALL VRLOCATER(TIMES,OLAT,OLON,
     +  RLAT,RLON,RA,EV,AZM,RDTAONE,XR,YR,ZR,
     +  ISCANONE,SMOTIONU,SMOTIONV,CENTIME)
        IF(NAIRCRAFT.NE.42)GO TO 76542
        DO IR=1,1
         I=1
         IF(I.EQ.1)THEN
          IINT=INT((XR(IR)+XZ+.5*SX)/SX)
          JINT=INT((YR(IR)+YZ+.5*SY)/SY)
          KINT=1+INT((ZR(IR)-ZZ)/SZ)
          UFILE=0.
          VFILE=0.
          UFILESUM=0.
c          WRITE(6,*)'IINT,JINT,KINT = ',IINT,JINT,KINT
          DO I=IINT,IINT+1
           DO J=JINT,JINT+1
            DO K=KINT,KINT+1
             IF(I.GE.1.AND.I.LE.IMX)THEN
              IF(J.GE.1.AND.J.LE.JMX)THEN
               IF(K.GE.1.AND.K.LE.KMX)THEN
                IF(U(I,J,K).GT.WFLAG)THEN
                 XG=(I-1)*SX-XZ+.5*SX
                 YG=(J-1)*SY-YZ+.5*SY
                 ZG=(K-1)*SZ+ZZ
                 XI=XR(IR)-XG
                 YI=YR(IR)-YG
                 ZI=ZR(IR)-ZG
                 RADR=SQRT(XR(IR)*XR(IR)+YR(IR)*YR(IR))
                 RADG=SQRT(XG*XG+YG*YG)
                 VRAD=(U(I,J,K)*XG+V(I,J,K)*YG)/RADG
                 VTAN=(V(I,J,K)*XG-U(I,J,K)*YG)/RADG
                 URAD=(VRAD*XR(IR)-VTAN*YR(IR))/RADR
                 VRAD=(VRAD*YR(IR)+VTAN*XR(IR))/RADR
                 DISTPOINT=SQRT(XI*XI+YI*YI+ZI*ZI)
                 IF(DISTPOINT.GT.0.)THEN
                  RINT=1./DISTPOINT
                 ELSE
                  RINT=1000000.
                 ENDIF
                 UFILE=UFILE+RINT*URAD
                 UFILESUM=UFILESUM+RINT
                 VFILE=VFILE+RINT*VRAD
                ENDIF
               ENDIF
              ENDIF
             ENDIF
            ENDDO
           ENDDO
          ENDDO
          IF(UFILESUM.GT.0.)THEN
           UFILE=UFILE/UFILESUM
           VFILE=VFILE/UFILESUM
           WDFILE=180./3.14159*ATAN2(-UFILE,-VFILE)
           IF(WDFILE.LT.0.)WDFILE=WDFILE+360.
           WSFILE=SQRT(UFILE*UFILE+VFILE*VFILE)
          ELSE
           UFILE=UCOM
           VFILE=VCOM
           WDFILE=RADWD
           WSFILE=RADWS
          ENDIF
         ELSE
          UFILE=UCOM
          VFILE=VCOM
          WDFILE=RADWD
          WSFILE=RADWS
         ENDIF
        ENDDO
        HEADSTORM=ATAN2(XR(1),YR(1))
        HEADSTORM=HEADSTORM*180./3.14159
        IF(HEADSTORM.LT.0.)HEADSTORM=HEADSTORM+360.
        IF(HEADSTORM.GE.360.)HEADSTORM=HEADSTORM-360.
        TANDIR=HEADSTORM+90.
        IF(TANDIR.GE.360.)TANDIR=TANDIR-360.
c        pause
        IFLAGGING=0
        TANDIF=ABS(TANDIR-RADWD)
        IF(TANDIF.GT.180.)TANDIF=360-TANDIF
        WSTANTEST=RADWS*TANDIF
        IF(WSTANTEST.GT.1200.)THEN
         IFLAGGING=1
        ENDIF
        IF(UFILESUM.GT.0.)THEN
         DIFFVECT=SQRT((UFILE-UCOM)*(UFILE-UCOM)+
     +                 (VFILE-VCOM)*(VFILE-VCOM))
         DIFFDIR=ABS(RADWD-WDFILE)
         IF(DIFFVECT.GT.40.)THEN
          IFLAGGING=1
         ELSEIF((DIFFVECT.GT.15..AND.DIFFVECT.LE.40)
     +           .AND.DIFFDIR.GT.15.)THEN
          IFLAGGING=1
         ENDIF
        ENDIF 
        IFLAGGING=0
        IF(IFLAGGING.EQ.1)THEN
c         WRITE(6,*)'FLAGGING RAY'
c         write(6,*)'headstorm,tandir = ',headstorm,tandir
c         write(6,*)'ucom,ufile,vcom,vfile = ',ucom,ufile,vcom,vfile
c         write(6,*)'radws,wsfile,radwd,wdfile = ',
c     +             radws,wsfile,radwd,wdfile
         DO I=1,MAX_HRD_DIM
          BIN(I)=-888.8
         ENDDO
76542 ENDIF
CC       IF(XR(80).GE.XMIN.AND.XR(80).LE.XMAX)THEN
C        IF(YR(80).GE.YMIN.AND.YR(80).LE.YMAX)THEN
C         IF(ZR(80).GE.ZMIN.AND.YR(80).LE.ZMAX)THEN
C          ILOC=1+(XR(80)+XZ)/SX
C          JLOC=1+(YR(80)+YZ)/SY
C          KLOC=1+(ZR(80)-ZZ)/SZ
C          WRITE(6,*)'ILOC,JLOC,KLOC = ',ILOC,JLOC,KLOC
C         ENDIF
C        ENDIF
C       ENDIF
76583 IF(NUM_RAYS.GT.0.AND.NDO.EQ.0)THEN
c       WRITE(6,*)'NUM_RAYS,XR = ',NUM_RAYS,XR
c       WRITE(6,*)'NUM_RAYS,YR = ',NUM_RAYS,YR
c       WRITE(6,*)'NUM_RAYS,ZR = ',NUM_RAYS,ZR 
c      WRITE(6,*)'RALT,RA,RA1000 = ',RALT,RA,RA1000
      CALL VRLOCATER(TIMES,OLAT,OLON,
     + RLAT,RLON,RA,EV,AZM,RDTAIIN,XR,YR,ZR,
     + MAX_GATES,SMOTIONU,SMOTIONV,CENTIME)
       DO I=1,MAX_HRD_DIM
        XRSWEEP(I,NUM_RAYS)=XR(I)
        YRSWEEP(I,NUM_RAYS)=YR(I)
        ZRSWEEP(I,NUM_RAYS)=ZR(I)
       ENDDO
      ENDIF
      SWEEPTEST=1.
      IF(ABS(ELEV).GT.0.)THEN
       SWEEPTEST=ELEV*SWEEPOLD
       SWEEPOLD=ELEV
      ENDIF
      IF(IFRANCE.NE.1.OR.ISIGMET.NE.5)SWEEPTEST=1.
      IF(ISWEEPCHECK.NE.NTASWEEP.AND.IFRANCE.NE.1)SWEEPTEST=-1.
      IF(ISWEEPCHECK.NE.NTASWEEP.AND.ISIGMET.NE.5)SWEEPTEST=-1.
C      IF(IFRANCE.NE.1.AND.ISWEEPCHECK.NE.NTASWEEP)SWEEPTEST=-1.
C      IF(IFRANCE.NE.1.AND.ISWEEPCHECK.EQ.NTASWEEP)SWEEPTEST=1.
      IF(ISWEEPSET.EQ.0)THEN
       ISWEEPCHECK=NTASWEEP
       ISWEEPSET=1
c       WRITE(6,*)'ISWEEP 0 NTASWEEP = ',NTASWEEP
C       WRITE(6,*)'INITIAL READ XNIQ,XNIQTA = ',XNIQ,XNIQTA
       GO TO 7040
C      ELSEIF(ISWEEPSET.EQ.1.AND.NTASWEEP.EQ.ISWEEPCHECK)THEN
      ELSEIF(ISWEEPSET.EQ.1.AND.SWEEPTEST.GE.0.)THEN
c       WRITE(6,*)'ISWEEP 1 NTASWEEP = ',NTASWEEP
       GO TO 7040
C      ELSEIF(ISWEEPSET.EQ.1.AND.NTASWEEP.NE.ISWEEPCHECK)THEN
      ELSEIF(ISWEEPSET.EQ.1.AND.SWEEPTEST.LT.0.)THEN
c       WRITE(6,*)'ISWEEP 1-1 NTASWEEP = ',NTASWEEP
C       RDDIFF=RADIITA(IBST(1)+1)-RADIITA(1)
       IF(IBST(1).GT.0)THEN
        DO I=1,IBST(1)
         RDTAIIN(I)=1000.
        ENDDO
       ENDIF
       DO I=IBST(1)+1,NBINSMAX
        RDTAIIN(I)=RADIITA(I)
       ENDDO
       IF(NBINSMAX.LT.MAX_HRD_DIM)THEN
        DO I=NBINSMAX+1,MAX_HRD_DIM
         RDTAIIN(I)=1000.
        ENDDO
       ENDIF
C       DO I=1,MAX_HRD_DIM-IBST(1)
C        WRITE(6,*)'I,RDTAIIN(I),RDDIFF,IBST = ',
C     1   I,RDTAIIN(I),RDDIFF,IBST(1)
C        RDTAIIN(I)=RADIITA(I)
C        WRITE(6,*)'I,RDTAIIN(I) = ',I,RDTAIIN(I)
C       ENDDO
C       DO I=MAX_HRD_DIM-IBST(1)+1,MAX_HRD_DIM
C        RDTAIIN(I)=RADIITA(I)
C       ENDDO
c       WRITE(6,*)'RDTAIIN = ',RDTAIIN
       ISWEEPSET=2
       ISWEEPCHECK=NTASWEEP
C      ELSEIF((ISWEEPSET.EQ.2.AND.NTASWEEP.NE.ISWEEPCHECK).OR.
C     1        NUM_RAYS.GE.800)THEN
      ELSEIF((ISWEEPSET.EQ.2.AND.SWEEPTEST.LT.0.).
     1       OR.NUM_RAYS.EQ.800)THEN
c       WRITE(6,*)'ENDING,NTASWEEP,ISWEEPCHECK = ',
c     1                   NTASWEEP,ISWEEPCHECK
c       write(6,*)'backspacing 2 records'
c       CALL TAPECONTROL(LUNR,4,10)
       ISWEEPCHECK=NTASWEEP
c       WRITE(6,*)'ISWEEPCHECK SET TO ',ISWEEPCHECK
       CALL CTME1(TIME,IIHH,IIMM,IISS)
       OPEN(72,FILE='lastsweep.txt')
       WRITE(72,72726)IIHH,IIMM,IISS
72726  FORMAT('VERTICAL PROFILE  PROCESSING COMPLETED ON ',
     1  'SWEEP ENDING AT ',3I2.2)
       WRITE(6,*)'SWEEP END TIME IS '
       WRITE(6,'(3I2)')IIHH,IIMM,IISS
       CALL DATE_AND_TIME(CHARDATE,CHARTIME,CHARZONE,TIMEVALUES)
       WRITE(72,72727)(TIMEVALUES(IJI),IJI=5,7),CHARDATE
       WRITE(6,72727)(TIMEVALUES(IJI),IJI=5,7),CHARDATE
72727  FORMAT('PROCESSOR TIME IS ',3I2.2,' on ',A)
       CLOSE(72)
c       RRLAT(NUM_RAYS)=RLAT
c       RRLON(NUM_RAYS)=RLON
c       RRA(NUM_RAYS)=RA
c       EAZM(NUM_RAYS)=AZM
c       EEV(NUM_RAYS)=EV
c       TMSWEEP(NUM_RAYS)=TIME
c       RDVWS(NUM_RAYS)=RADVWS
c       RDVWS(NUM_RAYS)=RADVWS
c       AZ_EL(1,NUM_RAYS)=TRAKAZM
c       AZ_EL(2,NUM_RAYS)=TRAKELEV
c       PELEV(NUM_RAYS)=ELEV
c       PAZM(NUM_RAYS)=RADAZM
c       V0SAVE(NUM_RAYS)=V0
c       SINTK=ABS(SIN(TRAKAZM*3.14159/180.))
c       IF(SINTK.GT.SIN45)THEN
       IF(ABS(EV).LT.ELEVLIMIT)THEN
c       AZELTEST=ABS(SIN(TRAKAZM*3.14159/180.))
c       IF(AZELTEST.GT..5)THEN
        DO I=1,MAX_HRD_DIM
         BIN(I)=-888.8
         REF(I)=-32.
        ENDDO
       ENDIF
       IF(IBST(1).GT.0)THEN
        DO I=1,IBST(1)
         BIN(I)=-888.8
         REF(I)=-32.
        ENDDO
       ENDIF
       DO I=IBST(1)+1,NBINS
        BIN(I)=BIN(I)
        REF(I)=REF(I)
       ENDDO
       IF(NBINS.LT.MAX_HRD_DIM)THEN
        DO I=NBINS+1,MAX_HRD_DIM
         BIN(I)=-888.8
         REF(I)=-32.
        ENDDO
       ENDIF
C       DO I=1,MAX_HRD_DIM-IBST(1)
C        BIN(I)=BIN(I+IBST(1))
c        BIN(I)=REF(I+IBST(1))
C        REF(I)=REF(I+IBST(1))
C       ENDDO
C       DO I=MAX_HRD_DIM-IBST(1)+1,MAX_HRD_DIM
C        BIN(I)=-888.8
C        REF(I)=-32.
C       ENDDO
       IF(TRAKAZM.GT.91..AND.TRAKAZM.LT.269.)THEN
       IBST1=IBST(1)
       RASEND=RA
       ISECONDTRIP=0
       RMAXTATA=299792/2/PRF_HIGHTA
c       WRITE(6,*)'TIMES,TRAKAZM 0 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
       CALL FIND_GROUND(RDTAIIN,DEG2RAD,BEAM_WID,RS_TH,RS_M,
     + DBZ_MAX,IBEG,NG2,IBST1,BIN,ISECONDTRIP,RMAXTATA,RASEND)
c       WRITE(6,*)'IBEG = ',IBEG
c spectral width
c       IBEG=0
c spectral width
       ZRADD1=0
       ZRADD2=0
       IF(IPLANE.EQ.2)THEN
        DO I=IBST1,NBINS
         IF(ZR(I).GT.1..AND.ZR(I).LE.2.AND.REF(I).GT.-32)GO TO 6999
         IF(ZR(I).LE.1..AND.REF(I).GT.-32.)THEN
          REF(I)=-32.
          BIN(I)=-888.8
         ENDIF
        ENDDO
       ENDIF
c       WRITE(6,*)'RS_TH,RS_M,DBZ_MAX,IBEG,NG2 = ',RS_TH,RS_M,DBZ_MAX,
c     +  IBEG,NG2
 6999   IBEGNEW=IBEG
c        WRITE(6,*)'IBEG = ',IBEG
        REFL=-32.
         IF(IBEG.GT.1)THEN
c         DO L=1,30
c          IBEGL=IBEG-L+1
c          IF((IBEGL-1).GE.5.AND.(IBEGL-1).GT.IBST(1))THEN
cc          WRITE(6,*)'IBEGL,L,REF(IBEGL),REF(IBEGL-1) = ',
cc     +               IBEGL,L,REF(IBEGL),REF(IBEGL-1)
c           IF(DBZBUFFER(IBEGL).GT.-31.95)REFL=DBZBUFFER(IBEGL)
c           IF(REFL.GT.-31.95.AND.DBZBUFFER(IBEGL-1).GT.-31.95)THEN
c            IF(REFL-DBZBUFFER(IBEGL-1).GT.5.)THEN
c             IBEGNEW=IBEGL
c            ENDIF
c           ENDIF
c          ENDIF
c         ENDDO
c         IBEG=IBEGNEW-1
c         write(6,*)'IBEGONE = ',IBEG
         IF(IBEG.LT.1)IBEG=1
         DO I=IBEG,MAX_HRD_DIM
          BIN(I)=-999.9
          REF(I)=-999.9
         ENDDO
         NUMMAX=3.5*RA1000
         IF(IPLANE.EQ.2)NUMMAX=1.5*RA1000
         IF(IBEG.GT.NUMMAX.AND.(IPLANE.EQ.2.OR.IYEARTEST.GE.2017))THEN
C         IF(IBEG.GT.NUMMAX)THEN
            IBEGPASS=IBEG-1
            EVPASS=EV
c            WRITE(6,*)'RA1000,NUMMAX = ',RA1000,NUMMAX
            CALL GROUNDCHECKI(REF,BIN,IBEGPASS,NBINS,EVPASS,NUMMAX)
         ENDIF
c        DO I=1,IBEG
c         IF(REF(I).GT.40.)THEN
c          WRITE(6,*)'NUM_RAYS,TRAKAZM,IBEG = ',NUM_RAYS,TRAKAZM,IBEG
c          WRITE(6,6927)(REF(I),DBZBUFFER(I),I=1,IBEG)
c6927      FORMAT(10F8.2)
c          GO TO 2222
c         ENDIF
c        ENDDO
        ELSEIF(IBEG.LE.0)THEN
c         write(6,*)'ibeg = minus1, trakazm = ',trakazm
         DO I=1,MAX_HRD_DIM
          BIN(I)=-999.9
          REF(I)=-999.9
         ENDDO 
        ENDIF
       ENDIF
       IF(TRAKAZM.LT.0.)TRAKAZM=TRAKAZM+360.
c       WRITE(6,*)'TIMES,TRAKAZM 1 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
 1039  FORMAT(8F10.2)
c       IF(IYEARTEST.GE.2017.AND.IPLANE.EQ.1)THEN
        CALL INTERVENATTEN2(REF,NBINS,RADIIATTEN,BINOUT)
        DO I=1,MAX_GATES
         IF(REF(I).GT.-32.)THEN
            REFTESTSUB=10.**(BINOUT(I)/10)-10.**(REF(I)/10)
         ELSE
            REFTESTSUB=0.
         ENDIF
         RADIUSRATIO=RDTAIIN(I)*1000./RA
         ZRDIFF=ZR(I)-(RA/1000)
         IF((RADIUSRATIO.LE.RADRAT.OR.ABS(RDTAIIN(I)).LE.RADMASK).
     +     AND.ZRDIFF.LT.ZRDIFFMAX )THEN
c         IF(RADIUSRATIO.LE.RADRAT.OR.ABS(RDTAIIN(I)).LE.RADMASK)THEN
          RADIUSDIFF=(RDTAIIN(I)-RA/1000.)
          IRADIUS1=NINT(RADIUSDIFF*10.)+110
          IRADIUS2=NINT(RDTAIIN(I)*10.)+10
          IF(IRADIUS1.GT.610.OR.IRADIUS1.LE.0)IRADIUS1=-1
          IF(IRADIUS2.GT.610.OR.IRADIUS2.LE.0)IRADIUS2=-1
          IF(TRAKAZM.LT.0.)THEN
           TRACKAZM=TRAKAZM+360.
          ELSE
           TRACKAZM=TRAKAZM
          ENDIF
          JTRAKAZM=NINT(TRACKAZM)+1
          IF(JTRAKAZM.GT.360)JTRAKAZM=1
c       WRITE(6,*)'I,J,RA,RDTAIIN(I),TRAKAZM,IRADIUS,JTRAKAZM = ',
c     1            I,J,RA,RDTAIIN(I),TRAKAZM,IRADIUS,JTRAKAZM
          IF(REF(I).GT.-32..AND.IRADIUS1.GT.0.AND.IRADIUS1.LE.610
     1       .AND.JTRAKAZM.GT.JTRAKAZMMIN.AND.
     1        JTRAKAZM.LT.JTRAKAZMMAX)THEN
           REFTEST=AVGDBZ1(IRADIUS1,JTRAKAZM)+FLOAT(IDBZMASK)
           REFTEST102A=10.**(REFTEST/10.)-REFTESTSUB
           REFTEST10B=10.**(REF(I)/10.)
c           IF(REF(I).LT.REFTEST.AND.IAPPLYMASK.EQ.1)THEN
           IF(REFTEST10B.LT.REFTEST102A.AND.IAPPLYMASK.EQ.1)THEN
            REF(I)=-32.
            BIN(I)=-999.9
           ENDIF
C         NUM1(IRADIUS,JTRAKAZM)=NUM1(IRADIUS,JTRAKAZM)+1
C         DBZSUMMER(IRADIUS,JTRAKAZM)=DBZSUMMER(IRADIUS,JTRAKAZM)
C     1    +REF(I)
          ENDIF
          IF(REF(I).GT.-32..AND.IRADIUS2.GT.0.AND.IRADIUS2.LE.610
     1       .AND.JTRAKAZM.GT.JTRAKAZMMIN.AND.
     1        JTRAKAZM.LT.JTRAKAZMMAX)THEN
           REFTEST=AVGDBZ2(IRADIUS2,JTRAKAZM)+FLOAT(IDBZMASK)
           IF(REF(I).LT.REFTEST.AND.IAPPLYMASK.EQ.1)THEN
            REF(I)=-32.
            BIN(I)=-999.9
           ENDIF
C         NUM1(IRADIUS,JTRAKAZM)=NUM1(IRADIUS,JTRAKAZM)+1
C         DBZSUMMER(IRADIUS,JTRAKAZM)=DBZSUMMER(IRADIUS,JTRAKAZM)
C     1    +REF(I)
          ENDIF
         ENDIF
        ENDDO
c       WRITE(6,*)'TIMES,TRAKAZM 2 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
c       ENDIF
       GO TO 2000
      ENDIF
      IF(NDO.NE.0)GO TO 7040
      IF(IFRANCENO.EQ.1.AND.ABS(ELEV).LT..001)GO TO 7040
      NUM_RAYS=NUM_RAYS+1
c      IF((BIN(5).GT.-800..AND.BIN(6).GT.-800.AND.
c     + ABS(BIN(6)-BIN(5)).GT.XNIQ).OR.NUM_RAYS.EQ.2)THEN
c       WRITE(6,*)'NUM_RAYS,RADIITA = ',NUM_RAYS,(RADIITA(LI),LI=1,10)
c       WRITE(6,*)'NUM_RAYS,BIN = ',NUM_RAYS,(BIN(LI),LI=1,10)
c       WRITE(6,*)'NUM_RAYS,REF = ',NUM_RAYS,(REF(LI),LI=1,10)
c       IF(NUM_RAYS.NE.2)PAUSE
c      ENDIF
      RRLAT(NUM_RAYS)=RLAT
      RRLON(NUM_RAYS)=RLON
      RRA(NUM_RAYS)=RA
      EAZM(NUM_RAYS)=AZM
      EEV(NUM_RAYS)=EV
      RDVWS(NUM_RAYS)=RADVWS
      RDVWS(NUM_RAYS)=RADVWS
      TMSWEEP(NUM_RAYS)=TIME
      AZ_EL(1,NUM_RAYS)=TRAKAZM
      AZ_EL(2,NUM_RAYS)=TRAKELEV
      PELEV(NUM_RAYS)=ELEV
      PAZM(NUM_RAYS)=RADAZM
      V0SAVE(NUM_RAYS)=V0
c      write(6,*)'num_rays = ',num_rays
C      SINTK=ABS(SIN(TRAKAZM*3.14159/180.))
c      write(6,*)'trakazm,ev,sintk = ',trakazm,ev,sintk
C      IF(SINTK.GT.SIN45)THEN
c       write(6,*)'removing '
c       write(6,*)'trakazm,ev = ',trakazm,ev
      IF(ABS(EV).LT.ELEVLIMIT)THEN
c      AZELTEST=ABS(SIN(TRAKAZM*3.14159/180.))
c      write(6,*)'trakazm,trakelev,ev,azeltest = ',
c     + trakazm,trakelev,ev,azeltest
c      IF(AZELTEST.GT..5)THEN
c       write(6,*)'removing'
       DO I=1,MAX_HRD_DIM
        BIN(I)=-888.8
        REF(I)=-32.
       ENDDO
c      ELSE
c       write(6,*)'dbz,vr = ',ref,bin
      ENDIF
      IF(TRAKAZM.GT.91..AND.TRAKAZM.LT.269.)THEN
c       WRITE(6,*)'TIMES,TRAKAZM 0 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
       IBST1=IBST(1)
       RASEND=RA
       ISECONDTRIP=0
       RMAXTATA=299792/2/PRF_HIGHTA
       CALL FIND_GROUND(RDTAIIN,DEG2RAD,BEAM_WID,RS_TH,RS_M,
     + DBZ_MAX,IBEG,NG2,IBST1,BIN,ISECONDTRIP,RMAXTATA,RASEND)
c       WRITE(6,*)'IBEG = ',IBEG
C       CALL FIND_GROUND(RDTAIIN,DEG2RAD,BEAM_WID,RS_TH,RS_M,
C     + DBZ_MAX,IBEG,NG2,IBST1,BIN,RASEND)
c       WRITE(6,*)'RS_TH,RS_M,DBZ_MAX,IBEG,NG2 = ',RS_TH,RS_M,DBZ_MAX,
c     +  IBEG,NG2
c          WRITE(6,*)'TRAKAZM,IBEG = ',TRAKAZM,IBEG
c          WRITE(6,6927)(REF(I),DBZBUFFER(I),I=1,50)
c spectral width
c       IBEG=0
c spectral width
       ZRADD1=0
       ZRADD2=0
       IF(IPLANE.EQ.2)THEN
        DO I=IBST1,NBINS
         IF(ZR(I).GT.2..AND.ZR(I).LE.3.AND.REF(I).GT.-32)GO TO 6998
         IF(ZR(I).LE.2..AND.REF(I).GT.-32.)THEN
          REF(I)=-32.
          BIN(I)=-888.8
         ENDIF
        ENDDO
       ENDIF
 6998  IBEGNEW=IBEG
       REFL=-32.
c       WRITE(6,*)'IBEG = ',IBEG
       IF(IBEG.GT.0)THEN
c        DO L=1,30
c         IBEGL=IBEG-L+1
c         IF((IBEGL-1).GE.5.AND.(IBEGL-1).GT.IBST(1))THEN
cc          WRITE(6,*)'IBEGL,L,REF(IBEGL),REF(IBEGL-1) = ',
cc     +               IBEGL,L,REF(IBEGL),REF(IBEGL-1)
c          IF(DBZBUFFER(IBEGL).GT.-31.95)REFL=DBZBUFFER(IBEGL)
c          IF(REFL.GT.-31.95.AND.DBZBUFFER(IBEGL-1).GT.-31.95)THEN
c           IF(REFL-DBZBUFFER(IBEGL-1).GT.5.)THEN
c            IBEGNEW=IBEGL
c           ENDIF
c          ENDIF
c         ENDIF
c        ENDDO
c        IBEG=IBEGNEW-1
        IF(IBEG.LT.1)IBEG=1
c        WRITE(6,*)'IBEG2,MAX_HRD_DIM = ',IBEG,MAX_HRD_DIM
        DO I=IBEG,MAX_HRD_DIM
         BIN(I)=-999.9
         REF(I)=-999.9
        ENDDO
        NUMMAX=3.5*RA1000
        IF(IPLANE.EQ.2)NUMMAX=1.5*RA1000
        IF(IBEG.GT.NUMMAX.AND.(IPLANE.EQ.2.OR.IYEARTEST.GE.2017))THEN
           IBEGPASS=IBEG-1
           EVPASS=EV
c           WRITE(6,*)'RA1000,NUMMAX = ',RA1000,NUMMAX
           CALL GROUNDCHECKI(REF,BIN,IBEGPASS,NBINS,EVPASS,NUMMAX)
        ENDIF
        IBEGDONE=IBEG-NG2-1
        I=I-1
C      write(99,*)'BIN AFTER FIND_GROUND, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,6427)(BIN(I),I=1,600)
c        DO I=1,50
c         IF(REF(I).GT.41.)THEN
c          WRITE(6,*)'TRAKAZM,IBEG = ',TRAKAZM,IBEG
c          WRITE(6,6927)(REF(I),DBZBUFFER(I),I=1,50)
6927      FORMAT(10F8.2)
c          GO TO 2222
c         ENDIF
c        ENDDO
c       ELSEIF(IBEG.EQ.1)THEN
c          WRITE(6,*)'TRAKAZM,IBEG = ',TRAKAZM,IBEG
c          WRITE(6,6927)(REF(I),DBZBUFFER(I),I=1,50)
c          PAUSE
       ELSEIF(IBEG.LE.0)THEN
c        write(6,*)'ibeg = minus1, trakazm = ',trakazm
        DO I=1,MAX_HRD_DIM
         BIN(I)=-999.9
         REF(I)=-999.9
        ENDDO 
       ENDIF
      ENDIF
c      IF(IYEARTEST.GE.2017.AND.IPLANE.EQ.1)THEN
c       WRITE(6,*)'TIMES,TRAKAZM 1 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
       CALL INTERVENATTEN2(REF,NBINS,RADIIATTEN,BINOUT)
       DO I=1,MAX_GATES
        IF(REF(I).GT.-32.)THEN
           REFTESTSUB=10.**(BINOUT(I)/10)-10.**(REF(I)/10)
        ELSE
           REFTESTSUB=0.
        ENDIF
        RADIUSRATIO=RDTAIIN(I)*1000./RA
         ZRDIFF=ZR(I)-(RA/1000)
         IF((RADIUSRATIO.LE.RADRAT.OR.ABS(RDTAIIN(I)).LE.RADMASK).
     +     AND.ZRDIFF.LT.ZRDIFFMAX )THEN
c        IF(RADIUSRATIO.LE.RADRAT.OR.ABS(RDTAIIN(I)).LE.RADMASK)THEN
         RADIUSDIFF=(RDTAIIN(I)-RA/1000.)
         IRADIUS1=NINT(RADIUSDIFF*10.)+110
         IRADIUS2=NINT(RDTAIIN(I)*10.)+10
         IF(IRADIUS1.GT.610.OR.IRADIUS1.LE.0)IRADIUS1=-1
         IF(IRADIUS2.GT.610.OR.IRADIUS2.LE.0)IRADIUS2=-1
         IF(TRAKAZM.LT.0.)THEN
          TRACKAZM=TRAKAZM+360.
         ELSE
          TRACKAZM=TRAKAZM
        ENDIF
         JTRAKAZM=NINT(TRACKAZM)+1
         IF(JTRAKAZM.GT.360)JTRAKAZM=1
c       WRITE(6,*)'I,J,RA,RDTAIIN(I),TRAKAZM,IRADIUS,JTRAKAZM = ',
c     1            I,J,RA,RDTAIIN(I),TRAKAZM,IRADIUS,JTRAKAZM
         IF(REF(I).GT.-32..AND.IRADIUS1.GT.0.AND.IRADIUS1.LE.610
     1       .AND.JTRAKAZM.GT.JTRAKAZMMIN.AND.
     1        JTRAKAZM.LT.JTRAKAZMMAX)THEN
          REFTEST=AVGDBZ1(IRADIUS1,JTRAKAZM)+FLOAT(IDBZMASK)
          REFTEST102A=10.**(REFTEST/10.)-REFTESTSUB
          REFTEST10B=10.**(REF(I)/10.)
c          IF(REF(I).LT.REFTEST.AND.IAPPLYMASK.EQ.1)THEN
          IF(REFTEST10B.LT.REFTEST102A.AND.IAPPLYMASK.EQ.1)THEN
           REF(I)=-32.
           BIN(I)=-999.9
          ENDIF
C         NUM1(IRADIUS,JTRAKAZM)=NUM1(IRADIUS,JTRAKAZM)+1
C         DBZSUMMER(IRADIUS,JTRAKAZM)=DBZSUMMER(IRADIUS,JTRAKAZM)
C     1    +REF(I)
         ENDIF
         IF(REF(I).GT.-32..AND.IRADIUS2.GT.0.AND.IRADIUS2.LE.610
     1       .AND.JTRAKAZM.GT.JTRAKAZMMIN.AND.
     1        JTRAKAZM.LT.JTRAKAZMMAX)THEN
          REFTEST=AVGDBZ2(IRADIUS2,JTRAKAZM)+FLOAT(IDBZMASK)
          IF(REF(I).LT.REFTEST.AND.IAPPLYMASK.EQ.1)THEN
           REF(I)=-32.
           BIN(I)=-999.9
          ENDIF
C         NUM1(IRADIUS,JTRAKAZM)=NUM1(IRADIUS,JTRAKAZM)+1
C         DBZSUMMER(IRADIUS,JTRAKAZM)=DBZSUMMER(IRADIUS,JTRAKAZM)
C     1    +REF(I)
         ENDIF
        ENDIF
       ENDDO
c       WRITE(6,*)'TIMES,TRAKAZM 2 = ',TIMES,TRAKAZM
c       WRITE(6,1039)(REF(I),I=1,200)
c      ENDIF
c      WRITE(6,*)'TIME,TRAKAZM,REF = ',TIME,TRAKAZM,(REF(I),I=1,MAX_HRD_DIM)      
c      IF (TIME.GT.ETIME .OR. NIX.EQ.-100)GO TO 2000
2222  IF (NIX.EQ.-100)GO TO 2000
      IF (TAPE .EQ. 'Y') THEN 
C          call radartaperewind(lunr)
          WRITE(6,*)'STOP AT 7'
          WRITE(6,'("Change Radar Tape; RETURN to continue")')
7060      PAUSE
          WRITE(6,'("1-continue, 2-pause:")')
          READ(5,*,err=7060) irewind
          if (irewind .ne. 1) go to 7060
          TAPE='N'
          GO TO 7040
      ENDIF 
C 
C Write Radar Information To Disk  
      ITIME=TIME
C      WRITE(320,IOSTAT=IERR,ERR=1040) TIME,RLAT,RLON,RA,RADAZM,ELEV,
C     +                 (BIN(I),I=1,MAX_HRD_DIM)
c      WRITE(6,*)'TIME,RLAT,RLON,RA,AZM,EV = ',
c     +   TIME,RLAT,RLON,RA,AZM,EV
c      WRITE(6,*)'PRF_FLAGTA,PRF_HIGHTA = ',PRF_FLAGTA,PRF_HIGHTA
c      WRITE(6,*)'XNIQ,XNIQTA = ',XNIQ,XNIQTA
c      WRITE(6,*)'NTASWEEP = ',NTASWEEP
c      write(6,*)'num_rays = ',num_rays
      AZ_EL(1,NUM_RAYS)=TRAKAZM
      AZ_EL(2,NUM_RAYS)=TRAKELEV
      PELEV(NUM_RAYS)=ELEV
      PAZM(NUM_RAYS)=RADAZM
c      WRITE(6,*)'NUM_RAYS,AZIMUTH,ELEVATION = ',
c     1           NUM_RAYS,AZ_EL(1,NUM_RAYS),AZ_EL(2,NUM_RAYS)
      V0SAVE(NUM_RAYS)=V0
      IF(IBST(1).GT.0)THEN
       DO I=1,IBST(1)
        BIN(I)=-888.8
        REF(I)=-32.
       ENDDO
      ENDIF
      DO I=IBST(1)+1,NBINS
         IF(I.GT.100.AND.REF(I).LE.-32..AND.BIN(I).GT.-800.)THEN
            WRITE(6,*)'I,REF,BIN = ',I,REF(I),BIN(I)
         ENDIF
       SWEEP(I,NUM_RAYS)=BIN(I)
c       SWEEP(I,NUM_RAYS)=BIN(I)
       SWEEPZ(I,NUM_RAYS)=REF(I)
c       IF(BIN1(I).NE.BIN(I))THEN
c        WRITE(6,'(I5,3F10.4)')I,VELBUFFER(I),BIN1(I),BIN(I)
c       ENDIF
      ENDDO
C      write(99,*)'BIN WHEN COPYING, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,6427)(BIN(I),I=1,600)
C      write(99,*)'SWEEP WHEN COPYING, and NUM_RAYS = ',NUM_RAYS
C      WRITE(99,6427)(SWEEP(I,NUM_RAYS),I=1,600)
      IF(NBINS.LT.MAX_HRD_DIM)THEN
       DO I=NBINS+1,MAX_HRD_DIM
        SWEEP(I,NUM_RAYS)=-888.8
        SWEEPZ(I,NUM_RAYS)=-32.
       ENDDO
      ENDIF
c      if(az_el(1,num_rays).gt.85..and.az_el(1,num_rays).lt.86.)then
c       write(6,*)'sweep = ',(sweep(i,num_rays),i=1,MAX_HRD_DIM)
c      endif
c      WRITE(6,*)'I,BIN,SWEEP = ',I,(SWEEP(I,NUM_RAYS),I=1,MAX_HRD_DIM)
C      IF(RADAZM.GT.270..AND.RADAZM.LT.277.)THEN
C       WRITE(6,*)'RADAZM,rdelta,ngate1,v0 = ',RADAZM,rdelta,ngate1,v0
C       WRITE(6,'(9F8.2)')(BIN(I),REF(I),WIDTHBUFFER(I),I=1,MAX_HRD_DIM)
C      ENDIF
C      WRITE(6,5674)(I,VELBUFFER(I),BIN1(I),BIN(I),I=1,MAX_HRD_DIM)
C      WRITE(6,5674)(I,DBZBUFFER(I),REF1(I),REF(I),I=1,MAX_HRD_DIM)
c      WRITE(6,5675)(I,WIDTHBUFFER(I),I=1,MAX_HRD_DIM)
C5674  FORMAT(3(I4,3F10.4))
5675  FORMAT(4(I3,F10.4))
      IF (MOD(ITIME,60).EQ.0 .AND. itime.NE.OLDTIME) THEN
         CALL CTME1(TIME,IH,IM,IS)
         WRITE(6,'(" Writing: ",3i2.2,1x,2(f8.3,1x),3(f12.4,1x))')
     +        IH,IM,IS,RLAT,RLON,RA,AZM,EV
      ENDIF
      OLDTIME=ITIME
      GO TO 7040
C 
C <<<<<<Error Conditions<<<<<<
970   WRITE(LP,'(1X," Error searching for start time:",i6)') IERR
      GO TO 2000
998   WRITE(LP,'(1X,"Error Opening Input File: ",A,1X,"IERR= ",I6)')
     +      IFILE,IERR
      GO TO 2000
999   WRITE(LP,'(1X,"Bad Input Data",I4)') IERR 
      GO TO 2000
1000  WRITE(LP,1030)IERR,NAMEO
1030  FORMAT(1X,'Error on Creating Output File= ',I5,1X,A) 
      GO TO 2000
1040  WRITE(LP,1045)IERR,NAMEO
1045  FORMAT(1X,'Error on Write= ',I5,1X,A)
      GO TO 2000
1050  WRITE(LP,'("Error on opening Ram File: ",I5,1X,A80)') IERR,NAMERAM 
2000  NUM_RAYS=NUM_RAYS-1
      NBINS=NBINSMAX
      IF(NUM_RAYS.LT.1)THEN
       NUM_RAYS=0
       WRITE(6,*)'NUM_RAYS,MAX_RAYS,MAX_GATES,MAX_HRD_DIM = ',
     1   NUM_RAYS,MAX_RAYS,MAX_GATES,MAX_HRD_DIM
       WRITE(6,*)'RETURNING'
c       PAUSE
       RETURN
      ENDIF
c      write(6,*)'num_rays = ',num_rays
C      DO J=1,NUM_RAYS
C       WRITE(99,*)'AFTER 2000 SWEEP J roll az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(SWEEP(I,J),I=1,600)
C      ENDDO
      IF(NUM_RAYS.GT.0.AND.ISIGMET.NE.5)THEN
c       WRITE(6,*)'AZ_EL = '
c       WRITE(6,'(10F8.2)')(AZ_EL(1,J),J=1,NUM_RAYS)
       DO I=1,2
        DO J=1,NUM_RAYS
         AZEL(I,J)=AZ_EL(I,J)
        ENDDO
       ENDDO
c       WRITE(6,*)'AZEL = '
c       WRITE(6,'(10F8.1)')(AZEL(1,J),J=1,NUM_RAYS)
c       WRITE(6,*)'ONE'
       CALL AZISORT(NUM_RAYS,AZ_EL,RDVWS)
       CALL AZISORT(NUM_RAYS,AZ_EL,PAZM)
       CALL AZISORT(NUM_RAYS,AZ_EL,PELEV)
       CALL AZISORT(NUM_RAYS,AZ_EL,EAZM)
       CALL AZISORT(NUM_RAYS,AZ_EL,EEV)
       CALL AZISORT(NUM_RAYS,AZ_EL,RRLAT)
       CALL AZISORT(NUM_RAYS,AZ_EL,RRLON)
       CALL AZISORT(NUM_RAYS,AZ_EL,RRA)
       CALL AZISORT(NUM_RAYS,AZ_EL,TMSWEEP)
       CALL AZISORT(NUM_RAYS,AZ_EL,V0SAVE)
       NUMI=2
c       WRITE(6,*)'TWO'
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,AZEL)
       NUMI=MAX_GATES
c       WRITE(6,*)'THREE'
c       WRITE(6,*)'THREE D'
c       WRITE(6,*)'THREE C'
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,TMP1)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,TMP2)
c       WRITE(6,*)'THREE B'
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,SWEEP)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,SWEEPSAVE)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,VRRAD)
c       WRITE(6,*)'THREE A'
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,NYQ)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,XRSWEEP)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,YRSWEEP)
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,ZRSWEEP)
c       WRITE(6,*)'FOUR'
       CALL AZISORT2(NUMI,NUM_RAYS,AZ_EL,SWEEPZ)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,ISEG)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,ISEGE)
       CALL IAZISORT2(NUMI,NUM_RAYS,AZ_EL,IKEEP)
 7777  FORMAT(20F10.3)
       DO I=1,2
        DO J=1,NUM_RAYS
         AZ_EL(I,J)=AZEL(I,J)
        ENDDO
       ENDDO
      ENDIF
C
C THIS IS A NEW TEST FOR RADAR ALTITUDE RING
C
      DO J=1,NUM_RAYS
         DO I=1,NBINS
            IF(I.GT.100.AND.SWEEP(I,J).GT.-800..
     +         AND.SWEEPZ(I,J).LE.-32.)THEN
               WRITE(6,*)'AFTERSORT,I,J,SWEEP,SWEEPZ = ',
     +                    I,J,SWEEP(I,J),SWEEPZ(I,J)
            ENDIF
         ENDDO
      ENDDO
      IF(IALTRINGREMOVE.EQ.1)THEN
         DO I=NBINS,1,-1
            RARATIO=RDTAIIN(I)*1000./RA
            IF(RARATIO.GT.2.0.AND.RDTAIIN(I).LT.999.)NBINSUSE=I
         ENDDO
         IF(IAFTFORE.EQ.1)THEN
            RARATIO1=.3
            RARATIO2=.8
            RARATIO3=1.5
            RARATIO4=2.0
         ELSE
            RARATIO1=.5
            RARATIO2=1.0
            RARATIO3=1.5
            RARATIO4=2.0
         ENDIF
         DO J=1,NUM_RAYS
            SUMDBZIN=0.
            NSUMDBZIN=0
            SUMDBZAT=0.
            NSUMDBZAT=0
            SUMDBZOUT=0.
            NSUMDBZOUT=0.
            DO I=1,NBINSUSE
               RARATIO=RDTAIIN(I)*1000./RA
c          WRITE(6,*)'I,RALT,RDTAIIN,RARATIO = ',
c     +               I,RALT,RDTAIIN(I),RARATIO
               IF(RARATIO.GT.RARATIO1.AND.RARATIO.LT.RARATIO2)THEN
                  SUMDBZIN=SUMDBZIN+SWEEPZ(I,J)
                  NSUMDBZIN=NSUMDBZIN+1
               ELSEIF(RARATIO.GE.RARATIO2.AND.RARATIO.LE.RARATIO3)THEN
                  SUMDBZAT=SUMDBZAT+SWEEPZ(I,J)
                  NSUMDBZAT=NSUMDBZAT+1
               ELSEIF(RARATIO.GT.RARATIO3.AND.RARATIO.LT.RARATIO4)THEN
                  IF(ZRSWEEP(I,J).LT..5)THEN
                     NSUMDBZOUT=NSUMDBZOUT+1
                     SUMDBZOUT=SUMDBZOUT+100.
                  ELSE
                     SUMDBZOUT=SUMDBZOUT+SWEEPZ(I,J)
                     NSUMDBZOUT=NSUMDBZOUT+1
                  ENDIF
               ENDIF
            ENDDO
            DBZIN=SUMDBZIN/NSUMDBZIN
            DBZOUT=SUMDBZOUT/NSUMDBZOUT
            DBZAT=SUMDBZAT/NSUMDBZAT
c         WRITE(6,*)'DBZIN,DBZAT,DBZOUT = ',DBZIN,DBZAT,DBZOUT
            IF(DBZAT.GT.DBZIN+4..AND.DBZAT.GT.DBZOUT+4.)THEN
               DO I=1,NBINSUSE
                  RARATIO=RDTAIIN(I)*1000./RA
                  IF(RARATIO.GE.RARATIO2.AND.RARATIO.LE.RARATIO3)THEN
                     SWEEP(I,J)=-888.8
                     SWEEPZ(I,J)=-32.
                  ENDIF
               ENDDO
            ENDIF
         ENDDO
      ENDIF
C
C END OF RING ADDITION
C
      DO J=1,NUM_RAYS
         DO I=1,NBINS
            IF(I.GT.100.AND.SWEEP(I,J).GT.-800..
     +         AND.SWEEPZ(I,J).LE.-32.)THEN
               WRITE(6,*)'AFTERRING,I,J,SWEEP,SWEEPZ = ',
     +                    I,J,SWEEP(I,J),SWEEPZ(I,J)
            ENDIF
         ENDDO
      ENDDO
      if(num_rays.ge.1)then
       radvwmax=0.
       sumvw=0.
       do j=1,num_rays
        radvwtest=abs(rdvws(j))
        if(abs(radvwtest).gt.100.)then
         do i=1,nbins
          sweep(i,j)=-999.9
         enddo
        else
         sumvw=sumvw+rdvws(j)
         ssumvw=ssumvw+1
c         write(6,*)'j,rdvws,radvwtest,radvwmax = ',j,rdvws(j),
c     1   radvwtest,radvwmax
         if(radvwtest.gt.radvwmax)radvwmax=radvwtest
        endif
       enddo
       if(ssumvw.gt.0)then
        radvwmean=sumvw/ssumvw
       else
        radvwmean=999.9
       endif
c       write(6,*)'radvwmax,radvwmean = ',radvwmax,radvwmean
       radvwmean=abs(radvwmean)
       if(radvwmax.gt.30..or.radvwmean.gt.15.)then
        do j=1,num_rays
         do i=1,nbins
          sweep(i,j)=-888.8
         enddo
        enddo
       endif
      endif
C      DO J=1,NUM_RAYS
C       WRITE(99,*)'AFTER VW AND VGS TESTS J roll az_el,rdvws,nbis = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J),RDVWS(J),NBINS
C       WRITE(99,6528)(SWEEP(I,J),I=1,600)
C      ENDDO
      RATEST=RA/1000.
      JSTART=0
      DO J=1,NUM_RAYS
       IF(AZ_EL(1,J).GT.90..AND.AZ_EL(1,J).LT.271.)THEN
        JSTART=J
        GO TO 18187
       ENDIF
      ENDDO
      GO TO 19187
18187 JEND=0
      DO J=JSTART+1,NUM_RAYS
       IF(AZ_EL(1,J).GT.270.)THEN
        JEND=J-1
        GO TO 18181
       ENDIF
      ENDDO
C18181 WRITE(6,*)'JSTART,JEND SET TO ',JSTART,JEND
18181 CONTINUE
      DO I=1,NBINS
       IF(RDTAIIN(I).GT.RATEST)THEN
        IGTEST=0
        J=NUM_RAYS+1
        JSTART=1
        JJ=JSTART
        DO WHILE(JJ.LE.NUM_RAYS.AND.AZ_EL(1,JJ).LT.180.)
         IF(SWEEPZ(I,JJ).GT.-32.)THEN
          J=JJ+1
C         ELSE
C          GO TO 6498
         ENDIF
         JJ=JJ+1
        ENDDO
6498    IF(J.LE.NUM_RAYS.AND.AZ_EL(1,J).LT.180.)THEN
         ICHECK=1
C         write(6,*)'icheck,j,azel = ',icheck,j,az_el(1,j)
         CALL GROUNDCHECK(SWEEP,SWEEPZ,NUM_RAYS,I,J,ICHECK)
        ENDIF
        J=0
        JJ=JEND
c        write(6,*)'i,j,jend = ',i,j,jend
        JAZTEST=1
        DO WHILE(JJ.GE.1.AND.JAZTEST.EQ.1)
         IF(AZ_EL(1,JJ).GT.180.)THEN
C         write(6,*)'i,j,sweep(i,j) = ',i,j,sweep(i,j)
          IF(SWEEPZ(I,JJ).GT.-32.)THEN
           J=JJ-1
C         ELSE
C          GO TO 6499
          ENDIF
          JJ=JJ-1
          JAZTEST=1
         ELSE
          JAZTEST=0
         ENDIF
        ENDDO
c        WRITE(6,*)'J,JEND = ',J,JEND
6499    IF(J.GE.1)THEN
         IF(AZ_EL(1,J).GT.180.)THEN
          ICHECK=2
c         write(6,*)'icheck,j,azel = ',icheck,j,az_el(1,j)
          CALL GROUNDCHECK(SWEEP,SWEEPZ,NUM_RAYS,I,J,ICHECK)
         ENDIF
        ENDIF
       ENDIF
      ENDDO
      DO J=1,NUM_RAYS
         DO I=1,NBINS
            IF(I.GT.100.AND.SWEEP(I,J).GT.-800..
     +         AND.SWEEPZ(I,J).LE.-32.)THEN
               WRITE(6,*)'AFTERGROUND,I,J,SWEEP,SWEEPZ = ',
     +                    I,J,SWEEP(I,J),SWEEPZ(I,J)
            ENDIF
         ENDDO
      ENDDO
c      WRITE(6,*)'TEST 1'
C      DO J=1,NUM_RAYS
C       WRITE(99,*)'AFTER GROUNDCHECK SWEEP J roll az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(SWEEP(I,J),I=1,600)
C      ENDDO
c      WRITE(6,*)'I GOT THERE 1'
C      WRITE(6,'(" NCEPWRITE_FILE....ending.")')
C      DO J=1,NUM_RAYS
C       DO I=1,MAX_HRD_DIM
C        ZDIFF(I,J)=-888.8
C       ENDDO
C      ENDDO
C      DO J=1,NUM_RAYS
C       J1=J-1
C       J2=J+1
C       IF(J.EQ.1)THEN
C        J1=NUM_RAYS
C       ELSEIF(J.EQ.NUM_RAYS)THEN
C        J2=1
C       ENDIF
C       AZ1=AZ_EL(1,J1)
C       AZ2=AZ_EL(1,J2)
C       AZDIFF=AZ2-AZ1
C       IF(AZDIFF.LT..0)AZDIFF=AZDIFF+360.
C       DO I=IBST(1),MAX_HRD_DIM
C        IF(SWEEPZ(I,J2).GT.-31.99.AND.SWEEPZ(I,J1).GT.-31.99.AND.
C     +    AZDIFF.LT.5..AND.AZDIFF.GE..5)THEN
C         ZDIFF(I,J)=(SWEEPZ(I,J2)-SWEEPZ(I,J1))/AZDIFF
CC         WRITE(6,*)'I,J,SWEEPZ1,SWEEPZ2,AZ1,AZ2,AZDIFF,ZDIFF = ',
CC     +   I,J,SWEEPZ(I,J1),SWEEPZ(I,J2),AZ1,AZ2,AZDIFF,ZDIFF(I,J)
C        ENDIF
C       ENDDO
C      ENDDO
C      DO I=1,MAX_HRD_DIM
C       DO J=1,NUM_RAYS
C        XRMAX(I,J)=XRSWEEP(I,J)
C        YRMAX(I,J)=YRSWEEP(I,J)
C        ZRMAX(I,J)=ZRSWEEP(I,J)
C        XRMIN(I,J)=XRSWEEP(I,J)
C        YRMIN(I,J)=YRSWEEP(I,J)
C        ZRMIN(I,J)=ZRSWEEP(I,J)
C        AZMIN(I,J)=AZ_EL(1,J)
C        AZMAX(I,J)=AZ_EL(1,J)
C        IF(ZDIFF(I,J).GT.-888.8)THEN
C         ZMIN(I,J)=ZDIFF(I,J)
C         ZMAX(I,J)=ABS(ZDIFF(I,J))
C        ELSE
C         ZMIN(I,J)=888.8
C         ZMAX(I,J)=-888.8
C        ENDIF
C       ENDDO
C      ENDDO
C      DO I=1,MAX_HRD_DIM
C       DO J=1,11
C        DO L=J+1,NUM_RAYS
C         IF(ZMAX(I,L).GT.ZMAX(I,J))THEN
C          ABC=ZMAX(I,J)
C          ZMAX(I,J)=ZMAX(I,L)
C          ZMAX(I,L)=ABC
C          ABC=XRMAX(I,J)
C          XRMAX(I,J)=XRMAX(I,L)
C          XRMAX(I,L)=ABC
C          ABC=YRMAX(I,J)
C          YRMAX(I,J)=YRMAX(I,L)
C          YRMAX(I,L)=ABC
C          ABC=ZRMAX(I,J)
C          ZRMAX(I,J)=ZRMAX(I,L)
C          ZRMAX(I,L)=ABC
C          ABC=AZMAX(I,J)
C          AZMAX(I,J)=AZMAX(I,L)
C          AZMAX(I,L)=ABC
C          ABC=ZMIN(I,J)
C          ZMIN(I,J)=ZMIN(I,L)
C          ZMIN(I,L)=ABC
C         ENDIF
Cc         IF(ZMIN(I,L).LT.ZMIN(I,J))THEN
Cc          ABC=ZMIN(I,J)
Cc          ZMIN(I,J)=ZMIN(I,L)
Cc          ZMIN(I,L)=ABC
Cc          ABC=XRMIN(I,J)
Cc          XRMIN(I,J)=XRMIN(I,L)
Cc          XRMIN(I,L)=ABC
Cc          ABC=YRMIN(I,J)
Cc          YRMIN(I,J)=YRMIN(I,L)
Cc          YRMIN(I,L)=ABC
Cc          ABC=ZRMIN(I,J)
Cc          ZRMIN(I,J)=ZRMIN(I,L)
Cc          ZRMIN(I,L)=ABC
Cc          ABC=AZMIN(I,J)
Cc          AZMIN(I,J)=AZMIN(I,L)
Cc          AZMIN(I,L)=ABC
Cc         ENDIF
C        ENDDO
C       ENDDO
C      ENDDO
Cc      DO I=IBST(1),MAX_HRD_DIM
Cc       DO J=1,10
Cc        IF(ZMAX(I,J).GT.-888.)THEN
Cc         WRITE(6,412)I,J,ZMIN(I,J),AZMAX(I,J),XRMAX(I,J),YRMAX(I,J),
Cc     +               ZRMAX(I,J)
Cc        ENDIF
Cc       ENDDO
Cc      ENDDO
C412   FORMAT(' MAX ',2I4,5F8.2)
CC      DO I=IBST(1),MAX_HRD_DIM
CC       DO J=1,10
CC        IF(ZMIN(I,J).LT.888.)THEN
CC         WRITE(6,413)I,J,ZMIN(I,J),AZMIN(I,J),XRMIN(I,J),YRMIN(I,J),
CC     +               ZRMIN(I,J)
CC        ENDIF
CC       ENDDO
CC      ENDDO
CC413   FORMAT(' MIN ',2I4,5F8.2)
c      DO J=1,NUM_RAYS
c       DO I=1,MAX_HRD_DIM
c        SWEEP(I,J)=SWEEPZ(I,J)
c       ENDDO
c      ENDDO
C      DO J=1,NUM_RAYS
C       WRITE(99,*)'BEFORE 19187 SWEEP J roll az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(SWEEP(I,J),I=1,600)
C      ENDDO
19187 IDESPECKLE2=1
C
C     BEGINNING OF OLD DESPECKLE CODE
C
C THESE NEED TO BE TAKEN OUT AFTER TESTING
      IDESPECKLE1=-1
c      IDESPECKLE=1
C
c      CALL CTME1(TIME,IIIHH,IIIMM,IIISS)
c      WRITE(89,72729)IIIHH,IIIMM,IIISS
c72729 FORMAT('TIME IS ',3I2.2)       
c      DO J=1,NUM_RAYS
c         DO I=1,NBINS
c            IF(I.GT.100.AND.SWEEP(I,J).GT.-800..
c     +         AND.SWEEPZ(I,J).LE.-32.)THEN
c               WRITE(6,*)'BEFORELTLT,I,J,SWEEP,SWEEPZ = ',
c     +                    I,J,SWEEP(I,J),SWEEPZ(I,J)
c            ENDIF
c         ENDDO
c      ENDDO
c      DO I=1,NBINS
c         DO J=1,NUM_RAYS
c            IF(SWEEP(I,J).LT.-888.)SWEEP(I,J)=-888.8
c            IF(SWEEPZ(I,J).LT.-32.)SWEEPZ(I,J)=-32.
c         ENDDO
c      ENDDO
c      DO J=1,NUM_RAYS
c         DO I=1,NBINS
c            IF(I.GT.100.AND.SWEEP(I,J).GT.-800..
c     +         AND.SWEEPZ(I,J).LE.-32.)THEN
c               WRITE(6,*)'AFTERLTLT,I,J,SWEEP,SWEEPZ = ',
c     +                    I,J,SWEEP(I,J),SWEEPZ(I,J)
c            ENDIF
c         ENDDO
c      ENDDO
c      ICHECKSWEEP=0
c      WRITE(89,*)'ICHECKSWEEP = ',ICHECKSWEEP
c      DO J=1,NUM_RAYS
c         DO III=1,40
c            II=(III-1)*10+1
c            IJ=III*10
c            WRITE(89,*)'J,II,IJ = ',J,II,IJ
c            WRITE(89,8989)J,(SWEEP(I,J),I=II,IJ)
c            WRITE(89,8989)J,(SWEEPZ(I,J),I=II,IJ)
c         ENDDO
c      ENDDO
      IDESPECKLE1=-1
      IF(IDESPECKLE1.GE.1)THEN
      DO ICHECKSWEEP=1,3
       DO I=1,NBINS
        DO J=1,NUM_RAYS
         IKEEP(I,J)=1
         IF(SWEEP(I,J).GT.-800.)THEN
          DO I1=1,5
           II=I+I1-3
           IF(II.GT.0.AND.II.LE.NBINS)THEN
            IF(SWEEP(II,J).GT.-800)THEN
             IITEST(I1)=1
            ELSE
             IITEST(I1)=0
            ENDIF
           ELSE
            IITEST(I1)=0
           ENDIF
          ENDDO
          DO J1=1,5
           JJ=J+J1-3
           IF(JJ.GT.0.AND.JJ.LE.NUM_RAYS)THEN
            IF(SWEEP(I,JJ).GT.-800)THEN
             JJTEST(J1)=1
            ELSE
             JJTEST(J1)=0
            ENDIF
           ELSE
            JJTEST(J1)=0
           ENDIF
          ENDDO
          IKEEPER=0
          IF(IITEST(2).EQ.1.AND.IITEST(4).EQ.1)THEN
           IKEEPER=1
          ELSEIF(IITEST(1).EQ.1.AND.IITEST(2).EQ.1)THEN
           IKEEPER=1
          ELSEIF(IITEST(4).EQ.1.AND.IITEST(5).EQ.1)THEN
           IKEEPER=1
          ENDIF
          JKEEPER=0
          IF(JJTEST(2).EQ.1.AND.JJTEST(4).EQ.1)THEN
           JKEEPER=1
          ELSEIF(JJTEST(1).EQ.1.AND.JJTEST(2).EQ.1)THEN
           JKEEPER=1
          ELSEIF(JJTEST(4).EQ.1.AND.JJTEST(5).EQ.1)THEN
           JKEEPER=1
          ENDIF
          IF(IKEEPER.EQ.0.OR.JKEEPER.EQ.0)THEN
           IKEEP(I,J)=0
          ENDIF
         ENDIF
        ENDDO
       ENDDO
C CHANGE FOR TESTING From now on this should usually be off
c          IDESPECKLE1=2
c       IF(IDESPECKLE1.EQ.2)THEN
c       DO I=1,NBINS
c        DO J=1,NUM_RAYS
c         IF(IKEEP(I,J).EQ.0)SWEEP(I,J)=-999.9
c        ENDDO
c       ENDDO
c       ENDIF
C CHANGE FOR TESTING
       DO I=1,NBINS
        DO J=1,NUM_RAYS
         IKEEP(I,J)=1
         IF(SWEEPZ(I,J).GT.-32.)THEN
          DO I1=1,5
           II=I+I1-3
           IF(II.GT.0.AND.II.LE.NBINS)THEN
            IF(SWEEPZ(II,J).GT.-32.)THEN
             IITEST(I1)=1
            ELSE
             IITEST(I1)=0
            ENDIF
           ELSE
            IITEST(I1)=0
           ENDIF
          ENDDO
          DO J1=1,5
           JJ=J+J1-3
           IF(JJ.GT.0.AND.JJ.LE.NUM_RAYS)THEN
            IF(SWEEPZ(I,JJ).GT.-32.)THEN
             JJTEST(J1)=1
            ELSE
             JJTEST(J1)=0
            ENDIF
           ELSE
            JJTEST(J1)=0
           ENDIF
          ENDDO
          IKEEPER=0
          IF(IITEST(2).EQ.1.AND.IITEST(4).EQ.1)THEN
           IKEEPER=1
          ELSEIF(IITEST(1).EQ.1.AND.IITEST(2).EQ.1)THEN
           IKEEPER=1
          ELSEIF(IITEST(4).EQ.1.AND.IITEST(5).EQ.1)THEN
           IKEEPER=1
          ENDIF
          JKEEPER=0
          IF(JJTEST(2).EQ.1.AND.JJTEST(4).EQ.1)THEN
           JKEEPER=1
          ELSEIF(JJTEST(1).EQ.1.AND.JJTEST(2).EQ.1)THEN
           JKEEPER=1
          ELSEIF(JJTEST(4).EQ.1.AND.JJTEST(5).EQ.1)THEN
           JKEEPER=1
          ENDIF
          IF(IKEEPER.EQ.0.OR.JKEEPER.EQ.0)THEN
           IKEEP(I,J)=0
          ENDIF
         ELSE
           IKEEP(I,J)=0
         ENDIF
        ENDDO
       ENDDO
c       IF(IDESPECKLE1.NE.2)THEN
       DO I=1,NBINS
        DO J=1,NUM_RAYS
         IF(IKEEP(I,J).EQ.0)THEN
          SWEEPZ(I,J)=-32.
          SWEEP(I,J)=-888.8
         ENDIF
        ENDDO
       ENDDO
c       ENDIF
      ENDDO
      ENDIF
C
C END OF OLD 
C
      IF(IDESPECKLE.EQ.1)THEN
         CALL DESPECKLE(MAX_GATES,MAX_RAYS,NBINS,NUM_RAYS,NUMTIMES,
     +                  NUMCONTIG,SWEEP,SWEEPZ,IKEEP,IOLDDESPECKLE,
     +                  ZRSWEEP,ZRDIFFMAX,RA,ZSPECKLEMAX)
      ENDIF
      WRITE(89,*)'ICHECKSWEEP = ',ICHECKSWEEP
      DO J=1,NUM_RAYS
         DO III=1,40
            II=(III-1)*10+1
            IJ=III*10
            WRITE(89,*)'J,II,IJ = ',J,II,IJ
            WRITE(89,8989)J,(SWEEP(I,J),I=II,IJ)
            WRITE(89,8989)J,(SWEEPZ(I,J),I=II,IJ)
 8989       FORMAT(I5,10F7.2)
         ENDDO
      ENDDO
      IF(ICONSERVE.EQ.1)THEN
c       WRITE(6,*)'ICONSERVE'
c       PAUSE
       DO J=1,NUM_RAYS
        RADSAVER=0.
        I=1
        DO WHILE(I.LT.NBINS)
         IF(SWEEP(I,J).GT.-98..OR.RDTAIIN(I).LT.2.)THEN
          RADSAVER=RDTAIIN(I)
          I=I+1
         ELSEIF(RDTAIIN(I)-RADSAVER.GT.1.)THEN
          DO L=I,NBINS
           SWEEP(L,J)=-888.8
          ENDDO
          GO TO 6305
         ELSE
          I=I+1
         ENDIF
        ENDDO
6305   ENDDO
      ENDIF
C      DO J=1,NUM_RAYS
C       WRITE(99,*)'AFTER 6305 SWEEP J roll az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(SWEEP(I,J),I=1,600)
C      ENDDO
      IRINSIDE=1
      IF(IPLANE.EQ.2)THEN
       RADIFFTEST=1.0
      ELSE
       RADIFFTEST=0.5
      ENDIF
      IROUTSIDE=NBINS
      DO I=IBST(1)+1,NBINS
C       RADIFFTEST=RATEST/1.5
       RALTDIFF=RDTAIIN(I)*COS(PELEV(J)*3.14159/180.)-RATEST
       IF(RALTDIFF.GT.-RADIFFTEST.AND.IRINSIDE.EQ.0)THEN
        IRINSIDE=I
       ENDIF
       IF(RALTDIFF.GT.RADIFFTEST)THEN
        IROUTSIDE=I-1
        GO TO 18182
       ENDIF
      ENDDO
18182 CONTINUE
C      WRITE(6,*)'IRINSIDE,IROUTSIDE = ',IRINSIDE,IROUTSIDE
c      DO J=1,NUM_RAYS
c       DO I=1,100
c        IF(RDTAIIN(I).LE.3.)THEN
c         SWEEP(I,J)=-888.88
c         SWEEPZ(I,J)=-32.0
c        ENDIF
c       ENDDO
c      ENDDO
      SUMNDBZ=0.
      SUMRDBZ=0.
      ALT2=RATEST*2.
      RADIITEST1=RATEST*1.5
      RADIITEST2=RATEST*2.5
      IF(RADIITEST2.LT.8.)RADIITEST2=8.
      IRUNME=0
      IF(IRUNME.GT.0)THEN
      DO J=1,NUM_RAYS       
       DO I=1,200
        IF(ZRSWEEP(I,J).GT.1.AND.ZRSWEEP(I,J).LE.ALT2.AND.
     1  RDTAIIN(I).GT.RADIITEST1.AND.RDTAIIN(I).LE.RADIITEST2)THEN
         IF(SWEEPZ(I,J).GT.-32.)THEN
          ZTEST=10.**(SWEEPZ(I,J)/10.)
         ELSE
          ZTEST=0.
         ENDIF
         SUMNDBZ=SUMNDBZ+1.
         SUMRDBZ=SUMRDBZ+ZTEST
        ENDIF
       ENDDO
      ENDDO
c      IF(SUMRDBZ.GT.0.0001.AND.SUMNDBZ.GT.0.00001)THEN
      IF(SUMRDBZ.GT.0.0001.AND.SUMNDBZ.GT.10.)THEN
       ZTEST=SUMRDBZ/SUMNDBZ
      ELSE
       ZTEST=0.
      ENDIF
c      WRITE(6,*)SUMNDBZ,SUMRDBZ,ZTEST
c      WRITE(6,*)RATEST,RADIITEST1,RADIITEST2
      IF(ZTEST.LT.5..AND.IPLANE.NE.2)THEN
c       WRITE(6,*)'REMOVE DATA INSIDE ',IROUTSIDE
       DO I=1,200
        DO J=1,NUM_RAYS
         IF(RDTAIIN(I).LE.RADIITEST2.AND.ZRSWEEP(I,J).LE.ALT2)THEN
          SWEEP(I,J)=-999.9
          SWEEPZ(I,J)=-32.0
c         WRITE(6,*)I,J,SWEEP(I,J),SWEEPZ(I,J)
         ENDIF
        ENDDO
       ENDDO
      ELSE
c       WRITE(6,*)'KEEP DATA'
      ENDIF
c      write(6,*)'clearing ring from to ', irinside,iroutside
c      pause
      ENDIF
C      WRITE(6,*)IRINSIDE,IROUTSIDE+7
      DO I=IRINSIDE,IROUTSIDE+7
       SUMNDBZ=0.
       RAYNUM=0.
       RAYZNUM=0.
       DO J=1,NUM_RAYS
        IF(IRINSIDE.GT.0)THEN
         IF(SWEEPZ(I,J).LT.20..AND.IPLANE.EQ.2.AND.I.LE.IROUTSIDE)THEN
          SWEEPZ(I,J)=-32.
          SWEEP(I,J)=-999.9
         ENDIF
        ENDIF
c        IF(SWEEPZ(I,J).LT.20..OR.ZRSWEEP(I,J).LE.0.1)THEN
c        IF(I.LE.IROUTSIDE)THEN
c         SWEEP(I,J)=-999.9
c         SWEEPZ(I,J)=-32.
c        ELSEIF(SWEEPZ(I,J).LT.20.)THEN
C        IF(SWEEPZ(I,J).LT.20..OR.
C     1     (ZRSWEEP(I,J).LT.1.AND.SWEEPZ(I,J).LT.30.))THEN
C         SWEEP(I,J)=-999.9
C         SWEEPZ(I,J)=-32.
        IF(AZ_EL(1,J).GT.150..AND.AZ_EL(1,J).LT.210.)THEN
         IF(SWEEPZ(I,J).GT.-32.)THEN
          RAYZNUM=RAYZNUM+1.
         ENDIF
C        ELSE
         RAYNUM=RAYNUM+1
        ENDIF
C         if(ZRSWEEP(I,J).LT..2.AND.SWEEPZ(I,J).LT.60.)SWEEPZ(I,J)=-32.
c         if(ZRSWEEP(I,J).LT..3)SWEEPZ(I,J)=-32.
       ENDDO
       IF(RAYNUM.GT.0.)THEN
        SUMNDBZ=RAYZNUM/RAYNUM
       ELSE
        SUMNDBZ=0.
       ENDIF
       IF(SUMNDBZ.LT..5)THEN
        DO J=1,NUM_RAYS
         IF(AZ_EL(1,J).GT.150..AND.AZ_EL(1,J).LT.210.)THEN
          SWEEP(I,J)=-999.9
          SWEEPZ(I,J)=-32.
         ENDIF
        ENDDO
       ENDIF
      ENDDO
      XNIQTA1=XNIQTA
C      DO J=1,NUM_RAYS
C       WRITE(99,*)'BEFORE UNFOLD J roll az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(SWEEP(I,J),I=1,600)
C      ENDDO
c      WRITE(6,*)'I GOT HERE 2'
c      CALL DEFRECKLE(IMAXBINS,JMAXRAYS,
c     1 NBINSMAX,NUM_RAYS,PAZM,SWEEP,VROUT,XNIQTA1)
c      WRITE(6,*)'BEGINNING LOOP TO RUN UNFLDNEW'
C      WRITE(6,*)'NUM_RAYS = ',NUM_RAYS
      IF(NUM_RAYS.GT.0)THEN
       DO J=1,NUM_RAYS
        V00=V0SAVE(J)
        M=INOB(1)
        IRS=IBST(1)
        NB=NBINS
        VN=XNIQTA
C       WRITE(99,*)'UNFLDNEW,VARUNFLD SWEEP J az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(SWEEP(I,J),I=1,300)
C       WRITE(99,*)'UNFLDNEW,VARUNFLD VRRAD J az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(VRRAD(I,J),I=1,300)
        DO I=1,NBINSMAX
         RAY(I)=SWEEP(I,J)
         IF(IUSEWIND.NE.1)THEN
          VRRAD(I,J)=-888.8
         ELSEIF(IUSEWIND.EQ.1)THEN
cc         write(6,*)'iusewind,vrrad,ray = ',iusewind,vrrad(i,j),ray(i)
          IF(VRRAD(I,J).LT.-800.)THEN
           RAY(I)=-888.8
          ENDIF
         ENDIF
         URAY(I)=VRRAD(I,J)
        ENDDO
c       write(6,*)'AZM = ',az_el(1,j)
c       write(6,*)'calling unfolder'
c       CALL UNFLD1(V00,VN,M,IRS,NB,RAY,URAY,NB)
        NB1=NBINSMAX
        NB2=NBINSMAX
c       WRITE(99,*)'NBINS,NB1,NB2 = ',NBINSMAX,NB1,NB2
c       WRITE(99,*)'RAY = '
c       WRITE(99,6452)(RAY(I),I=1,NBINSMAX)
c 6452  FORMAT(8F10.2)
c        WRITE(6,*)'IRS,NB1,NBINSMAX,NBINS = ',IRS,NB1,NBINSMAX,NBINS
c        WRITE(6,*)'UNFLDNEW,IAFTFORE,VN = ',IAFTFORE,VN
        IF(NB1.GT.IRS)CALL UNFLDNEW(V00,VN,M,IRS,NB1,RAY,URAY,NB2)
c       WRITE(6,*)'ENDING LOOP TO RUN UNFLDNEW'
        DO I=1,NBINSMAX
         SWEEP(I,J)=URAY(I)
        ENDDO
c       write(6,*)'finished calling unfolder'
       ENDDO
c      DO J=1,NUM_RAYS
c       DO I=1,MAX_HRD_DIM
c        SWEEP(I,J)=SWEEPZ(I,J)
c       ENDDO
c      ENDDO
       XXNIQTA=XNIQTA*.7
       XXNIQ=XNIQTA
       write(6,*)'setting nyq to ',xxniq
       DO I=1,MAX_GATES
        DO J=1,NUM_RAYS
         NYQ(I,J)=XXNIQ
        ENDDO
       ENDDO
c      write(6,*)'finished setting nyq'
c      write(6,*)'calling aziunfld'
       NB=NBINSMAX
c      WRITE(6,*)'I GOT HERE 3'
c      WRITE(6,*)'CALLING AZIUNFLD'
c      PAUSE
      ENDIF
C      ALLOWEDDIFF=XXNIQ
C      IF(ALLOWEDDIFF.GT.20.)ALLOWEDDIFF=20.
C      IF(ALLOWEDDIFF.LT.8.)ALLOWEDDIFF=8.
C      ALLOWEDDIFF=8.
6528  FORMAT(10F8.2)
c      WRITE(6,*)'TEST 2, num_rays = ',num_rays
      IF(NUM_RAYS.GT.0)THEN
c       WRITE(6,*)'TEST 3'
       IF(IVARIATIONAL.EQ.1)THEN
c        WRITE(6,*)'TEST 4'
        VFLAG=-888.8
        VTOL1=1.
        WRITE(6,*)'CALLING CONFIG'
c        PAUSE
        CALL CONTIG(SWEEP,ICOL,JCOL,MAX_HRD_DIM,MAX_RAYS,VFLAG,
     1              NB,NUM_RAYS,PAZM,PELEV,VTOL1,XXNIQ)
c        WRITE(6,*)'RETURNED FROM CONFIG'
c        PAUSE
c      OPEN(99,FILE='looksweepvar')
c      WRITE(6,*)'WRITING SWEEP'
C      DO J=1,400
C       WRITE(99,*)'BEFORE,VARUNFLD SWEEP J az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(SWEEP(I,J),I=1,300)
C      ENDDO
        INDEXCALL=1
        WRITE(6,*)'CALLING VARUNFLD'
        WRITE(6,*)'ALLOWEDDIFF = ',ALLOWEDDIFF
c        PAUSE
        CALL VARUNFLD(SWEEP,MAX_GATES,NB,MAX_RAYS,RDTAIIN,AZ_EL,
     1                NUM_RAYS,VRRAD,PAZM,XXNIQ,JCOL,ALLOWEDDIFF,
     1                INDEXCALL,VTOL1)
c        WRITE(6,*)'RETURNED FROM VARUNFLD'
c       PAUSE
C      DO J=1,400
C       WRITE(99,*)'AFTER,VARUNFLD SWEEP J az_el = ',
C     1     J,AZ_EL(1,J),AZ_EL(2,J)
C       WRITE(99,6528)(SWEEP(I,J),I=1,300)
C      ENDDO
c      WRITE(6,*)'WRITING SWEEP2'
c      DO J=1,400
c       WRITE(99,*)'SWEEP2 J az_el = ',J,AZ_EL(1,J),AZ_EL(2,J)
c       WRITE(99,6528)(SWEEP(I,J),I=1,300)
c      ENDDO
c       INDEXCALL=2
c       CALL VARUNFLD(SWEEP,MAX_GATES,NB,MAX_RAYS,RDTAIIN,AZ_EL,
c     1                NUM_RAYS,VRRAD,PAZM,XXNIQ,JCOL,ALLOWEDDIFF,
c     1                INDEXCALL)
c      WRITE(6,*)'WRITING SWEEP3'
c      DO J=1,400
c       WRITE(99,*)'SWEEP3 J az_el = ',J,AZ_EL(1,J),AZ_EL(2,J)
c       WRITE(99,6528)(SWEEP(I,J),I=1,300)
c      ENDDO
C      ENDIF
c      CLOSE(99)
c      PAUSE
       ELSE
c        DO J=1,NUM_RAYS
c         WRITE(6,*)'BEFORE SWEEP,J = ',J
c         WRITE(6,6529)(SWEEP(I,J),I=1,NB)
c 6529    FORMAT(30F6.1)
c         WRITE(6,*)'BEFORE VRRAD,J = ',J
c         WRITE(6,6529)(VRRAD(I,J),I=1,NB)
         CALL AZIUNFLDG(SWEEP,ISEG,ISEGE,MAX_GATES,NB,MAX_RAYS,
     1    XXNIQTA,RDTAIIN,AZ_EL,XXNIQ,NUM_RAYS,VRRAD,IUSEWIND,PAZM,
     1    ALLOWEDDIFF)
c         WRITE(6,*)'AFTER SWEEP,J = ',J
c         WRITE(6,6529)(SWEEP(I,J),I=1,NB)
c        ENDDO
       ENDIF
      ENDIF
c      WRITE(6,*)'CALLING VARUNFLD'
c      CALL VARUNFLD(SWEEP,MAX_GATES,NBINS,MAX_RAYS,
c     1 RDTAIIN,AZ_EL,NUM_RAYS,VRRAD,PAZM,XXNIQ)
c      WRITE(6,*)'I GOT HERE 4'
c      WRITE(6,*)'RETURNED FROM AZIUNFLD'
      FLAGVAL=-888.8
      IVADFLAG=10
c      DO J=1,NUM_RAYS
c       DO I=1,MAX_GATES
c        VRRAD(I,J)=SWEEP(I,J)
c       ENDDO
c      ENDDO
C      DO J=1,NUM_RAYS
C       DO I=1,MAX_GATES
c        IF(ILATERSWEEP.EQ.0.OR.SWEEP(I,J).LT.-200.)THEN
C         VRRAD(I,J)=SWEEP(I,J)
c        ELSE
c         VRRAD(I,J)=SWEEPSAVE(I,J)
c        ENDIF
C       ENDDO
C      ENDDO
      IMINRNG=1
      NRANG=NBINS
c      DO J=1,NUM_RAYS
c       WRITE(6,*)'J,AZ = ',J,AZ_EL(1,J),AZ_EL(2,J)
c       WRITE(6,*)'SWEEP = ',(SWEEP(I,J),I=1,MAX_HRD_DIM)
c       WRITE(6,*)'VRRAD = ',(VRRAD(I,J),I=1,MAX_HRD_DIM)
c      ENDDO
c      write(6,*)'returning from aziunfld'
c      write(6,*)'num_rays,iminrng,nrang,flagval,ivadflag,vnyq = ',
c     1           num_rays,iminrng,nrang,flagval,ivadflag,XNIQTA
      DO J=1,NUM_RAYS
       DO I=1,NBINS
        SWEEPSAVE(I,J)=SWEEP(I,J)
       ENDDO
      ENDDO
c      CALL DEALIAS_EILTS(MAX_GATES,MAX_RAYS,SWEEP,NUM_RAYS,IMINRNG,
c     1 NRANG,VRRAD,NYQ,FLAGVAL,IVADFLAG,UNFVEL,TMP1,TMP2,JINDEX,
c     1 JIINDEX)
c      CALL UNFNQC(MAX_GATES,MAX_RAYS,NRANG,NUM_RAYS,SWEEP,XXNIQ,
c     1 UNFVEL,TMP1,TMP2,IVADFLAG,VRRAD,JINDEX)
c      write(6,*)'returning from aziunfld'
c      write(6,*)'num_rays,iminrng,nrang,flagval,ivadflag = ',
c     1           num_rays,iminrng,nrang,flagval,ivadflag
c      DO J=1,NUM_RAYS
cc       write(6,*)j,(unfvel(i,j),i=1,MAX_HRD_DIM)
c       DO I=1,MAX_GATES
cc        SWEEP(I,J)=VRRAD(I,J)
c        IF(SWEEPSAVE(I,J).GT.-800)THEN
c         SWEEP(I,J)=UNFVEL(I,J)
c         SWEEPSAVE(I,J)=UNFVEL(I,J)
c        ELSE
c         SWEEP(I,J)=-888.8
c         SWEEPSAVE(I,J)=-888.8
c        ENDIF
c       ENDDO
c      ENDDO
      ILATERSWEEP=1
      IF(I150.EQ.1)THEN
       IF(RADRES.LE..1)THEN
        ITEST1=MAXIAVG
        MULT1=1
        MAXIAVGNUM=MAXIAVG
       ELSE
        ITEST1=MAXIAVG
        MULT1=1
        MAXIAVGNUM=MAXIAVG
       ENDIF
       ITEST2=-1
       ITEST3=-1
       ITEST4=-1
       MULT1=1
       MULT2=-1
       MULT3=-1
       MULT4=-1
       KSTART1=1
       KSTART2=-1000
       KSTART3=-1000
      ELSE
       MULT1=2
       MULT2=8
       MULT3=4
       MAXIAVGNUM=256
       KSTART1=1
       KSTART2=257
       KSTART3=385
       ITEST1=128
       ITEST2=129
       ITEST3=32
       ITEST4=33
      ENDIF
      DO J=1,NUM_RAYS
       DO I=1,MAXIAVGNUM
        K=KSTART1+(I-1)*MULT1
        M=I*MULT1
        SUM=0.
        SUMD=0.
        SUMND=0.
        SUMN=0.
        RADSUM=0.
        RADSUMN=0.
        DO L=K,M
         IF((ICALLSWEEPIN.EQ.0..OR.INEWRAD.EQ.1).AND.J.EQ.1)THEN
          IF(RDTAIIN(L).LT.200.)THEN
           RADSUMN=RADSUMN+1
           RADSUM=RADSUM+RDTAIIN(L)
c           write(6,*)'L,RADIITA,RDTAIIN = ',L,RADIITA(L),RDTAIIN(L)
          ENDIF
         ENDIF
c         if(j.eq.1)
C        write(6,*)'i,l,radsumn,radsum,RDTAIIN,icallsweepin = ',
C     1 i,l,radsum,radsumn,RDTAIIN(l),icallsweepin
         IF(SWEEP(L,J).GT.-888.8)THEN
          SUM=SUM+SWEEP(L,J)
          SUMN=SUMN+1.
         ENDIF
         IF(SWEEPZ(L,J).GT.-20.)THEN
          SUMD=SUMD+SWEEPZ(L,J)
          SUMND=SUMND+1.
         ENDIF
        ENDDO
        IF(SUMN.GT.0..AND.IBLANKSWEEP.EQ.0)THEN
         SWEEP(I,J)=SUM/SUMN
        ELSE
         SWEEP(I,J)=-888.8
        ENDIF
        IF((ICALLSWEEPIN.EQ.0..OR.INEWRAD.EQ.1).AND.J.EQ.1)THEN
         IF(RADSUMN.GT.0.)THEN
          RDTAI(I)=RADSUM/RADSUMN
         ELSE
          RDTAI(I)=1000.
         ENDIF
        ENDIF
        IF(SUMND.GT.0..AND.IBLANKSWEEP.EQ.0)THEN
         SWEEPZ(I,J)=SUMD/SUMND
        ELSE
         SWEEPZ(I,J)=-32.
        ENDIF
c        if(j.eq.1)then
c         write(6,*)'sum,sumn,sumnd,sumd,radsum,radsumn = ',
c     1             sum,sumn,sumnd,sumd,radsum,radsumn
c         write(6,*)'i,rdtai,sweep,sweepz = ',
c     1             i,rdtai(i),sweep(i,j),sweepz(i,j)
c        endif
       ENDDO
c       DO I=1,NUM_RAYS
c       ENDDO
       I=1
c       DO WHILE(RDTAI(I).LE.3.0.OR.RDTAI(I).GT.999.9)
c         SWEEP(I,J)=-888.8
c         SWEEPZ(I,J)=-32.
c         I=I+1
c       ENDDO
       DO I=301,MAX_HRD_DIM
        SWEEP(I,J)=-888.8
        SWEEPZ(I,J)=-32
        IF(ICALLSWEEPIN.EQ.0.AND.J.EQ.1)RDTAI(I)=1000.
       ENDDO
c       WRITE(6,*)'J,SWEEPZ = ',J,(SWEEPZ(IJIJIJ,J),IJIJIJ=1,40)
      ENDDO
c      DO J=130,131
c       DO I=1,128
c        IF(SWEEP(I,J).GT.-800.)THEN
c         WRITE(6,*)'J,max_gates,max_rays = ',J,max_gates,max_rays
c         WRITE(6,'(I4,3E11.3,I4,3E11.3)')
c     1            (LL,SWEEP(LL,J),SWEEPZ(LL,J),RDTAI(LL),LL=I,128)
c         GO TO 3337
c        ENDIF
c       ENDDO
c3337  ENDDO
      DO J=1,NUM_RAYS
       IF(IBST(1).GT.0)THEN
        DIFFSW=SWEEP(IBST(1)+2,J)-SWEEP(IBST(1)+1,J)
        DIFFSW=ABS(DIFFSW)
c        IF(SWEEP(IBST(1)+1,J).GT.-888..AND.DIFFSW.GT.5.)THEN
c         WRITE(6,*)'J,SWEEP = ',J,(SWEEP(I,J),I=IBST(1),IBST(1)+10)
c         PAUSE
c        ENDIF
       ENDIF
      ENDDO
c      WRITE(6,*)'LEAVING SWEEPREAD'
      IF(ICALLSWEEPIN.EQ.0)THEN
       ICALLSWEEPIN=1
       GO TO 4275
      ENDIF
      DO J=1,400
       WRITE(99,*)'RETURNING SWEEP J az_el = ',
     1     J,AZ_EL(1,J),AZ_EL(2,J)
       WRITE(99,6528)(SWEEP(I,J),I=1,300)
      ENDDO
      WRITE(6,*)'RETURNING TO ABCD'
c      PAUSE
      RETURN
      END 
c      SUBROUTINE AZIUNFLD(SWEEP,ISEG,ISEGE,MAX_GATES,MAX_RAYS,
c     1 XXNIQTA,RDTAI,AZ_EL,XXNIQ,NUM_RAYS,VRRAD,IUSEWIND)
c      REAL SWEEP(MAX_GATES,MAX_RAYS)
c      INTEGER ISEG(MAX_GATES,MAX_RAYS),ISEGE(MAX_GATES,MAX_RAYS)
c      REAL RDTAI(MAX_GATES),AZ_EL(2,MAX_RAYS)
c      REAL VRRAD(MAX_GATES,MAX_RAYS)
c      REAL SWEEPKEEP(MAX_HRD_DIM,800)
c      XXNIQ2=XXNIQ*2.
cc      OPEN(77,FILE='lister')
cc      IF(IUSEWIND.NE.1)THEN
c      write(6,*)'iusewind = ',iusewind
c      write(6,*)'setting sweepkeep'
c       DO J=1,NUM_RAYS
c        DO I=1,MAX_GATES
c         SWEEPKEEP(I,J)=SWEEP(I,J)
c        ENDDO
c       ENDDO
cc      ENDIF
c      DO J=1,NUM_RAYS
c       IFIRST=0
c       DO I=1,MAX_GATES
c        ISEG(I,J)=0
c       ENDDO
c       DO I=1,MAX_HRD_DIM
c        IF(SWEEP(I,J).GT.-800..AND.IFIRST.EQ.0)THEN
cC---VERY FIRST GOOD GATE IN RAY
c         BEFORE=SWEEP(I,J)
c         IFIRST=1
c         ISEG(I,J)=-1
c         ILAST=I
c        ELSEIF(SWEEP(I,J).GT.-800.)THEN
c         IF(ABS(SWEEP(I,J)-BEFORE).GE.XXNIQTA.OR.
c     1      RDTAI(I)-RDTAI(ILAST).GT..9)THEN
cC---DIFFERENCE BETWEEN GATE AND PREVIOUS GOOD GATE MORE THEN .7*VNYQ
cc         WRITE(6,*)'SWEEP,BEFORE,XNIQTA7 = ',
cc     1               SWEEP(I,J),BEFORE,XXNIQTA
cc          WRITE(6,*)'RDTAII,RDTAILAST = ',RDTAI(I),RDTAI(ILAST)
cC
cC---ISEG AT THE LAST GOOD GATE BEFORE THIS LARGE SHIFT IS SET TO 1
c          ISEG(ILAST,J)=1
c          ISEG(I,J)=-1
cC---ISEG AT THIS BREAKPOINT IS SET TO -1
cc          WRITE(6,*)'ILAST,I,AZ_EL = ',ILAST,I,AZ_EL(1,J)
c         ENDIF
cC
cC---GOOD VALUES SET ILAST AND BEFORE TO THESE VALUES
c         ILAST=I
c         BEFORE=SWEEP(I,J)
c        ENDIF
c       ENDDO
cC---VERY LAST GOOD VALUE GETS AN ISEG VALUE OF 1
c       IF(IFIRST.EQ.1)ISEG(ILAST,J)=1
c       IISEGE=-1
c       DO I=MAX_GATES,1,-1
c        IF(ISEG(I,J).EQ.1)THEN
c         IISEGE=I
c         ISEGE(I,J)=IISEGE
c        ELSEIF(ISEG(I,J).EQ.-1)THEN
c         ISEGE(I,J)=IISEGE
c         IISEGE=-1
c        ELSE
c         ISEGE(I,J)=IISEGE
c        ENDIF
c       ENDDO
cc       WRITE(77,'(F10.2,2I5,F10.2)')
cc     1        (SWEEP(I,J),ISEGE(I,J),I,AZ_EL(1,J),I=1,MAX_HRD_DIM)       
c      ENDDO
cc      CLOSE(77)
c      IUSETEST=0
c      DO J=2,NUM_RAYS
c       JMAX=J-1
cc       WRITE(6,*)'J,AZ_EL = ',J,AZ_EL(1,J)
c       IF(AZ_EL(1,J).GT.180..AND.AZ_EL(1,J).LT.320.)GO TO 777
c       I=1
c       DO WHILE(I.LE.511)
c        IF(SWEEP(I,J).GT.-800.AND.SWEEP(I,J-1).GT.-800.)THEN
c         NSUM=0
c         SUM=0
c         N=ISEGE(I,J)
c         DO L=I,N
c          IF(SWEEP(L,J).GT.-800.AND.SWEEP(L,J-1).GT.-800.)THEN
c           SUM=SUM+SWEEP(L,J)-SWEEP(L,J-1)
c           NSUM=NSUM+1
c          ENDIF
c         ENDDO
cc         write(6,*)'j,i,n,sum,nsum = ',j,i,n,sum,nsum
c         IF(NSUM.GE.1)THEN
c          DIFMEAN=SUM/NSUM
c          IF(DIFMEAN.GT.XXNIQ)THEN
c           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
cc           write(6,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
cc     1      j,nsum,difmean,change,xxniq,xxniq2
c           DO L=I,N
c            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
c           ENDDO
c          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
c           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
cc           write(6,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
cc     1      j,nsum,difmean,change,xxniq,xxniq2
c           DO L=I,N
c            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
c           ENDDO
c          ENDIF
c         ENDIF
c         I=N+1
c        ELSE
c         I=I+1
c        ENDIF
c       ENDDO        
c      ENDDO
c777   NSUM=0
c      SUM=0.
c      DO J=1,JMAX
c       DO I=1,MAX_HRD_DIM
c        IF(SWEEP(I,J).GT.-800.AND.VRRAD(I,J).GT.-800.)THEN
c         DIFF=SWEEP(I,J)-VRRAD(I,J)
c         NSUM=NSUM+1
c         SUM=SUM+DIFF
c        ENDIF
c       ENDDO
c      ENDDO
c      IF(NSUM.GT.0)THEN
c       IUSETEST=1
c       DIFF=SUM/FLOAT(NSUM)
c       write(6,*)'difference on right side is ',DIFF
c       IF(ABS(DIFF).GT.XXNIQ)THEN
c        IF(DIFF.GT.0.)THEN
c         VCHANGE=-XXNIQ2
c        ELSE
c         VCHANGE=XXNIQ2
c        ENDIF
c        DO J=1,JMAX
c         DO I=1,MAX_HRD_DIM
c          IF(SWEEP(I,J).GT.-800.)THEN
c           SWEEP(I,J)=SWEEP(I,J)+VCHANGE
c          ENDIF
c         ENDDO
c        ENDDO
c       ENDIF
c      ELSE
c       IUSETEST=0
c      ENDIF
c      IF(IUSEWIND.NE.1.OR.IUSETEST.NE.1)THEN
c       NSUM=0
c       SUM=0
c       DO J=1,JMAX
c        DO I=1,MAX_HRD_DIM
c         IF(SWEEP(I,J).GT.-800.AND.SWEEPKEEP(I,J).GT.-800.)THEN
c          SUM=SUM+SWEEP(I,J)-SWEEPKEEP(I,J)
c          NSUM=NSUM+1
c         ENDIF
c        ENDDO
c       ENDDO
cc       write(6,*)'iusewind,sum,nsum = ',iusewind,sum,nsum
c       IF(NSUM.GT.0)THEN
c        DIFFMEAN=SUM/NSUM
c        CHANGE=0.
c        IF(DIFFMEAN.GT.XXNIQ)THEN
c         CHANGE=-XXNIQ2
c        ELSEIF(DIFFMEAN.LT.-XXNIQ)THEN
c         CHANGE=XXNIQ2
c        ENDIF
c        write(6,*)'right change = ',change
c        IF(CHANGE.NE.0.)THEN
c         write(6,*)'changing'
c         DO J=1,JMAX
c          DO I=1,MAX_HRD_DIM
c           IF(SWEEP(I,J).GT.-800.)THEN
c            SWEEP(I,J)=SWEEP(I,J)+CHANGE
c           ENDIF
c          ENDDO
c         ENDDO
c        ENDIF
c       ENDIF
c      ENDIF
c      IUSETEST=0
c      DO J=NUM_RAYS-1,1,-1
c       JMIN=J+1
cc       WRITE(6,*)'J,AZ_EL = ',J,AZ_EL(1,J)
c       IF(AZ_EL(1,J).LT.180..AND.AZ_EL(1,J).GT.40.)GO TO 778
c       I=1
c       DO WHILE(I.LE.511)
c        IF(SWEEP(I,J).GT.-800.AND.SWEEP(I,J+1).GT.-800.)THEN
c         NSUM=0
c         SUM=0
c         N=ISEGE(I,J)
c         DO L=I,N
c          IF(SWEEP(L,J).GT.-800.AND.SWEEP(L,J+1).GT.-800.)THEN
c           SUM=SUM+SWEEP(L,J)-SWEEP(L,J+1)
c           NSUM=NSUM+1
c          ENDIF
c         ENDDO
c         IF(NSUM.GE.1)THEN
c          IUSETEST=1
c          DIFMEAN=SUM/NSUM
c          IF(DIFMEAN.GT.XXNIQ)THEN
c           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
cc           write(6,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
cc     1      j,nsum,difmean,change,xxniq,xxniq2
c           DO L=I,N
c            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
c           ENDDO
c          ELSEIF(DIFMEAN.LT.-XXNIQ)THEN
c           CHANGE=NINT(DIFMEAN/XXNIQ2)*XXNIQ2
cc           write(6,*)'j,nsum,difmean,change,xxniq,xxniq2 = ',
cc     1      j,nsum,difmean,change,xxniq,xxniq2
c           DO L=I,N
c            IF(SWEEP(L,J).GT.-800.)SWEEP(L,J)=SWEEP(L,J)-CHANGE
c           ENDDO
c          ENDIF
c         ENDIF
c         I=N+1
c        ELSE
c         I=I+1
c        ENDIF
c       ENDDO        
c      ENDDO
c778   NSUM=0
c      SUM=0.
c      DO J=JMIN,NUM_RAYS
c       DO I=1,MAX_HRD_DIM
c        IF(SWEEP(I,J).GT.-800.AND.
c     1      VRRAD(I,J).GT.-800.)THEN
c         DIFF=SWEEP(I,J)-VRRAD(I,J)
c         NSUM=NSUM+1
c         SUM=SUM+DIFF
c        ENDIF
c       ENDDO
c      ENDDO
c      IF(NSUM.GT.0)THEN
c       IUSETEST=1
c       DIFF=SUM/FLOAT(NSUM)
c       write(6,*)'difference on left side is ',DIFF
c       IF(ABS(DIFF).GT.XXNIQ)THEN
c        IF(DIFF.GT.0.)THEN
c         VCHANGE=-XXNIQ2
c        ELSE
c         VCHANGE=XXNIQ2
c        ENDIF
c        DO J=JMIN,NUM_RAYS
c         DO I=1,MAX_HRD_DIM
c          IF(SWEEP(I,J).GT.-800.)THEN
c           SWEEP(I,J)=SWEEP(I,J)+VCHANGE
c          ENDIF
c         ENDDO
c        ENDDO
c       ENDIF
c      ELSE
c       IUSETEST=0
c      ENDIF
c      IF(IUSEWIND.NE.1.OR.IUSETEST.NE.1)THEN
c       NSUM=0
c       SUM=0
c       DO J=JMIN,NUM_RAYS
c        DO I=1,MAX_HRD_DIM
c         IF(SWEEP(I,J).GT.-800.AND.SWEEPKEEP(I,J).GT.-800.)THEN
c          SUM=SUM+SWEEP(I,J)-SWEEPKEEP(I,J)
c          NSUM=NSUM+1
c         ENDIF
c        ENDDO
c       ENDDO
c       WRITE(6,*)'LEFT SIDE SUM,NSUM = ',SUM,NSUM
c       IF(NSUM.GT.0)THEN
c        DIFFMEAN=SUM/NSUM
c        CHANGE=0.
c        IF(DIFFMEAN.GT.XXNIQ)THEN
c         CHANGE=-XXNIQ2
c        ELSEIF(DIFFMEAN.LT.-XXNIQ)THEN
c         CHANGE=XXNIQ2
c        ENDIF
c        write(6,*)'left change = ',change
c        IF(CHANGE.NE.0.)THEN
c         write(6,*)'changing'
c         DO J=JMIN,NUM_RAYS
c          DO I=1,MAX_HRD_DIM
c           IF(SWEEP(I,J).GT.-800.)THEN
c            SWEEP(I,J)=SWEEP(I,J)+CHANGE
c           ENDIF
c          ENDDO
c         ENDDO
c        ENDIF
c       ENDIF
c      ENDIF
c      RETURN
c      END
      SUBROUTINE GROUNDCHECK1(SWEEP,SWEEPZ,NUM_RAYS,I,JSTART,ICHECK)
      INCLUDE "hrd_radar_settings.f"
      PARAMETER(MAX_RAYS=800)
      PARAMETER(MAX_GATES=MAX_HRD_DIM)
      REAL SWEEP(MAX_GATES,MAX_RAYS),SWEEPZ(MAX_GATES,MAX_RAYS)
      IF(ICHECK.LT.1.OR.ICHECK.GT.2)THEN
       WRITE(6,*)'PROBLEM WITH ICHECK IN GROUNDCHECK'
       STOP
      ENDIF
      IF(SWEEPZ(I,JSTART).GT.-32.)THEN
       WRITE(6,*)'SWEEP(I,JSTART) GT -999.'
       WRITE(6,*)'ICHECK,I,JSTART,SWEEP,SWEEPZ = ',
     +  ICHECK,I,JSTART,SWEEP(I,JSTART),SWEEPZ(I,JSTART)
       STOP
      ENDIF
      IF(ICHECK.EQ.1)THEN
       IF(JSTART.LT.5)RETURN
c       IF(JSTART.LT.10)RETURN
       J=JSTART-9
c       WRITE(6,*)'RIGHT,I,JSTART,VEL = ',I,JSTART,
c     +             (SWEEP(I,L),L=J,JSTART)
c       WRITE(6,*)'RIGHT,I,JSTART,DBZ = ',I,JSTART,
c     +             (SWEEPZ(I,L),L=J,JSTART)
      SWTEST1=SWEEPZ(I,JSTART-1)-SWEEPZ(I,JSTART-3)
      SWTEST2=SWEEPZ(I,JSTART-2)-SWEEPZ(I,JSTART-3)
      IF(SWTEST1.GT.10..OR.SWTEST2.GT.10.)THEN
C       IF((SWEEPZ(I,JSTART-1).GT.-32..OR.SWEEPZ(I,JSTART-2).GT.-32.).
C     +  AND.SWEEPZ(I,JSTART-3).LE.-32.)THEN
        SWEEPZ(I,JSTART-1)=-32.
        SWEEPZ(I,JSTART-2)=-32.
        SWEEP(I,JSTART-1)=-888.8
        SWEEP(I,JSTART-2)=-888.8
       ENDIF
c       WRITE(6,*)'RIGHT,I,JSTART,VEL = ',I,JSTART,
c     +             (SWEEP(I,L),L=J,JSTART)
c       WRITE(6,*)'RIGHT,I,JSTART,DBZ = ',I,JSTART,
c     +             (SWEEPZ(I,L),L=J,JSTART)
      ELSE
c       IF(NUM_RAYS-JSTART.LT.4)RETURN
       IF(NUM_RAYS-JSTART.LT.9)RETURN
c       JEND=JSTART+4
       JEND=JSTART+9
c       WRITE(6,*) 'LEFT,I,JSTART,VEL = ',I,JSTART,
c     +             (SWEEP(I,L),L=JSTART,JEND)
c       WRITE(6,*) 'LEFT,I,JSTART,DBZ = ',I,JSTART,
c     +             (SWEEPZ(I,L),L=JSTART,JEND)
       SWTEST1=SWEEPZ(I,JSTART+1)-SWEEPZ(I,JSTART+3)
       SWTEST2=SWEEPZ(I,JSTART+2)-SWEEPZ(I,JSTART+3)
       IF(SWTEST1.GT.10..OR.SWTEST2.GT.10.)THEN
C       IF((SWEEPZ(I,JSTART+1).GT.-32..OR.SWEEPZ(I,JSTART+2).GT.-32.).
C     +  AND.SWEEPZ(I,JSTART+3).LE.-32.)THEN
        SWEEPZ(I,JSTART+1)=-32.
        SWEEPZ(I,JSTART+2)=-32.
        SWEEP(I,JSTART+1)=-888.8
        SWEEP(I,JSTART+2)=-888.8
       ENDIF
c       WRITE(6,*) 'LEFT,I,JSTART,VEL = ',I,JSTART,
c     +             (SWEEP(I,L),L=JSTART,JEND)
c       WRITE(6,*) 'LEFT,I,JSTART,DBZ = ',I,JSTART,
c     +             (SWEEPZ(I,L),L=JSTART,JEND)
      ENDIF
      RETURN
      END
C ********************
      SUBROUTINE READTAPE2(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,
     +                    RCAZM,ITAPEOPEN,RADARFILE,NUMREC,
     +                    PCORS,DCORS,RCORS,AZMCORS,
     +                    RDELCORTAS,ELCORS,ISIGMET)
      INCLUDE "hrd_radar_common_blocks_johns.f"
      COMMON /AREA1/ INM,IFLT,STIME,ETIME,WD,WS,NIX,NGATE1,LP,LUNR,
     +               IVT,RAMFL
      COMMON /PARAMS/ trakazm,trakelev,driftnew,
     +                rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(2),
     +                inob(2),ileg,xniq,irsw,maxnbins,v0,
     +                pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
     +                iunfoldflag,iattenflag,
     +                badstabflag,surfelimflag,echoflag,atmflag
      LOGICAL badstabflag, surfelimflag, echoflag, atmflag
      INTEGER RTYPE
      REAL PCORS(2),DCORS(2),RCORS(2),AZMCORS(2)
      REAL RDELCORTAS(2),ELCORS(2)
      CHARACTER IFLT*8, INM*12
      CHARACTER *1 RAMFL, IVT
      CHARACTER*80 RADARFILE
      DIMENSION BIN(MAX_HRD_DIM),REF(MAX_HRD_DIM),BIN1(MAX_HRD_DIM)
      DIMENSION REF1(MAX_HRD_DIM)
      DATA RTYPE/6/
C Subroutine to read doppler and Reflectivity data from the new 1988
C format radar tapes.  Reads refl/doppler when rtype=6 and dop/ref/sw when
C rtype=7.  It returns one ray per call.
C NIX = -100 determines an end-of-file
C Read data from tape:
      NIX=0
      IHEADERFLAG=1
      DO I=1,MAX_HRD_DIM
       BIN(I)=-888.8
       REF(I)=-32.
       BIN1(I)=-888.8
       REF1(I)=-32.
      ENDDO
c      write(6,5656)BIN
c 5656 FORMAT(10F8.1)
      WRITE(6,*)'PAUSE 1'
c      PAUSE
c      IF (SWTHRESH.GT.0.0 .AND. SWTHRESH.LE.13.0) RTYPE=7
      RTYPE=7
c50    write(6,*)'calling radartaperead1'
c      write(6,*)'itapeopen,numrec = ',itapeopen,numrec
c      write(6,'(A80)')radarfile
50    IF(ITAPEOPEN.EQ.0)THEN
       write(6,*)'calling radar_rvp8_read'
c       pause
       call radar_rvp8_read(LUNR,2,0,RTYPE,IERR)
c       CALL RADARDISCREAD1(LUNR,2,0,RTYPE,IERR)
C       CALL RADARFILEREAD(LUNR,2,0,RTYPE,IERR,ITAPEOPEN,RADARFILE,
C     + NUMREC)
       write(6,*)'calling radar_rvp8_read'
c       pause
      ELSE
       CALL RADARTAPEREAD(LUNR,2,0,RTYPE,IERR)
c        WRITE(6,*)'STOP AT 6'
c        STOP
       IF(IERR.NE.0)THEN
        write(6,*)'returned from radartaperead ierr = ',ierr
       ENDIF
      ENDIF
c      IF(NBINS.LT.MAX_HRD_DIM)THEN
c       DO I=NBINS+1,MAX_HRD_DIM
c        RADIITA(I)=0.
c       ENDDO
c      ENDIF
      IF (IERR .LT. 0) THEN
         NIX= -100
         RETURN
      ENDIF
c      WRITE(6,5656)BIN
c      WRITE(6,*)'PAUSE 2'
c      PAUSE
      IF(ELEV.LT.0.)THEN
       PCOR=PCORS(1)
       DCOR=DCORS(1)
       RCOR=RCORS(1)
       AZMCOR=AZMCORS(1)
       ELCOR=ELCORS(1)
      ELSE
       PCOR=PCORS(2)
       DCOR=DCORS(2)
       RCOR=RCORS(2)
       AZMCOR=AZMCORS(2)
       ELCOR=ELCORS(2)
      ENDIF
C    clear nix variable
      NIX= 0
C    time in seconds  
      TIME=RADTIME
C    raw azimuth
      TRAKAZM=RADAZM
c    roll corrected azimuth but in heading rather than track
      RCAZM=RADAZM+RCOR+ROLL
C    raw elevation
      TRAKELEV=ELEV
C    raw drift
      DRIFTNEW=DRIFT
C    nyquist velocity
      XNIQ=XNIQTA
      track = AMOD(heading + driftnew + 360.0, 360.0)
C ANGLECOR corrects the aircraft pitch,drift,roll,azimuth,elevation and
C adds the roll to the azimuth.
c      write(6,*)'roll,rcor,radazm,rcazm = ',roll,rcor,radazm,rcazm
      CALL ANGLECOR(PITCH,DRIFTNEW,ROLL,TRAKAZM,TRAKELEV,2,PCOR,
     +              DCOR,RCOR,AZMCOR,ELCOR)
c      write(6,*)'after roll,trakazm = ',roll,trakazm
C Convert aircraft angles to earth relative shperical coordinates
c      write(6,*)'calling convertangles track = ',track
      CALL CONVERTANGLES(TRACK,TRAKAZM,TRAKELEV,HORAZM,HORELEV)
c      write(6,*)'returned from convertangles track = ',track
C    azimuth earth relative
      AZM=HORAZM
C    elevation earth relative
      EV=HORELEV
C get information from the ram files.
      IF (RAMFL .EQ. 'Y')
     *   CALL READRAMFILE(TIME,TIMERAM,RADLAT,RADLON,RADALT,
     *                    RADWD,RADWS,UCOM,VCOM,RADVWS,RADVGS,IOS)
C get information from the radar tape or the standard tape
      GS=RADGS                       !ground speed
      VGS=RADVGS                     !vertical ground speed
      VWS=RADVWS                     !vertical wind speed
      RLAT=RADLAT                    !latitude(deg)
      RLON=RADLON                    !longitude(deg)
      RA=RADALT                      !radar altitude(meters) 
      WD=RADWD                       !wind direction
      WS=RADWS                       !wind speed
C RAYCOR corrects the velocities one ray at a time.  It returns the airplane
C track, the first guess wind, the stabilized, vt corrected and unfolded
c velocities as well as the dbz values from the tail radar.
c      WRITE(6,5656)BIN
c      WRITE(6,*)'PAUSE 3'
c      PAUSE
      IUNFOLDFLAG=0
c      WRITE(6,*)'MAX_HRD_DIM = ',MAX_HRD_DIM
      write(6,*)'calling raycor1 with elcor = ',ELCOR
      CALL RAYCOR1(BIN1,REF1)
      IUNFOLDFLAG=1
      CALL RAYCOR1(BIN,REF)
      IUNFOLDFLAG=1
c      WRITE(6,5656)BIN
c      WRITE(6,*)'PAUSE 4'
c      PAUSE
      RETURN
      END 
C ********************
      BLOCK DATA
      INCLUDE "hrd_radar_settings.f"
      COMMON /AREA1/ INM,IFLT,STIME,ETIME,WD,WS,NIX,NGATE1,LP,LUNR,
     +               IVT,RAMFL
      COMMON /PARAMS/ trakazm,trakelev,driftnew,
     +                rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(2),
     +                inob(2),ileg,xniq,irsw,maxnbins,v0,
     +                pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
     +                iunfoldflag,iattenflag,
     +                badstabflag,surfelimflag,echoflag,atmflag
      LOGICAL badstabflag, surfelimflag, echoflag, atmflag
      CHARACTER IFLT*8, INM*12
      CHARACTER *1 RAMFL, IVT
      DATA NIX/0/, NGATE1/5/, IVT/'N'/, RAMFL/'N'/ 
      DATA rot/0.0/, htbb/-99./, dbb/2.0/, thresh/-99.0/, swthresh/99./,
     1     dbzrs/-99./, ibst/2*0/, inob/2*0/, ileg/1/, xniq/12.8/,
     2     irsw/0/, maxnbins/MAX_HRD_DIM/, 
     3     pcor,dcor,rcor,azmcor,elcor,dbzcor/6*0.0/, dbzslope/1.0/,
     4     iunfoldflag/0/, iattenflag/0/,
     5     badstabflag/.true./, surfelimflag/.false./,
     6     echoflag/.false./, atmflag/.true./
      END 
      SUBROUTINE VRLOCATER(TIMES,OLAT,OLON,
     + RLAT,RLON,ALT,ELEV,AZIM,RANGE,XR,YR,ZR,
     + ISCANDIM,SMOTIONU,SMOTIONV,CENTIME)
      include "hrd_radar_settings.f"
      REAL RANGE(ISCANDIM),XR(ISCANDIM),YR(ISCANDIM),ZR(ISCANDIM)
      REAL SUM(MAX_HRD_DIM),WSUM(MAX_HRD_DIM),WEIGHT(200)
      REAL VR(MAX_HRD_DIM)
      RALT=ALT/1000.
      PI=ASIN(1.0)*2.
      DTR=PI/180.
      REARTH=6366.
C      SMOTIONU=0.
C      SMOTIONV=0.
      TDIFF=TIMES-CENTIME
c      write(6,*)'olat,rlat,times,centime,tdiff,smotionu,smotionv = ',
c     + olat,rlat,times,centime,tdiff,smotionu,smotionv
C      TDIFF=0.
C      JBINS=IBINS*3
c      DO I=1,ISCANDIM
c       SUM(I)=0
c       WSUM(I)=0
c       ISTART=I-JBINS
c       IEND=I+JBINS
c       IF(ISTART.LT.1)ISTART=1
c       IF(IEND.GT.ISCANDIM)IEND=ISCANDIM
c       DO J=ISTART,IEND
c        IF(VR(J).GT.-900.)THEN
c         IDIFF=J-I
c         IDIFF=IABS(IDIFF)
c         WSUM(I)=WSUM(I)+WEIGHT(IDIFF)
c         SUM(I)=SUM(I)+WEIGHT(IDIFF)*VR(J)
c        ENDIF
c       ENDDO
c      ENDDO
c      DO I=1,ISCANDIM
c       IF(WSUM(I).LE.0..AND.VR(I).LE.-900.)THEN
c        VR(I)=-999.9
c       ELSE
c        VR(I)=SUM(I)/WSUM(I)
c       ENDIF
c      ENDDO
      XSHIFT=TDIFF*SMOTIONU/1000.
      YSHIFT=TDIFF*SMOTIONV/1000.     
c      write(6,*)'xshift,yshift = ',xshift,yshift
      RAZIM=AZIM*DTR
      RELEV=ELEV*DTR
      DO I=1,ISCANDIM
c xradar=horizontal distance from aircraft
c yradar=vertical distance from center of earth
       IF(RANGE(I).LT.200.)THEN
        XRADAR=RANGE(I)*COS(RELEV)
        YRADAR=REARTH+RALT+RANGE(I)*SIN(RELEV)
c radnew=distance of datum from center of earth
        RADNEW=SQRT(XRADAR*XRADAR+YRADAR*YRADAR)
c delangle=angle between vertical at aircraft and vertical at datum
        DELANGLE=ATAN(XRADAR/YRADAR)
c distance along great circle from radar to datum
        DISTANCE=.5*(RADNEW+REARTH+RALT)*DELANGLE
c height=altitude of datum
        HEIGHT=RADNEW-REARTH
c distance2=xradar
        DISTANCE2=RANGE(I)*COS(RELEV)
c height2=altitude of datum not accounting for earth's curvature
        HEIGHT2=RALT+RANGE(I)*SIN(RELEV)
c delx=distance (aircraft/datum) along great circle due to east west
        DELY=DISTANCE*SIN(RAZIM)
c dely=distance(aircraft/datum)along great circle due to north-south
        DELX=DISTANCE*COS(RAZIM)
c dx=east west distance from origin to aircraft
        XLAT=.5*(RLAT+OLAT)*DTR
        DX=(RLON-OLON)*DTR*REARTH*COS(XLAT)
c dy=north south distance from origin to aircraft
        DY=(RLAT-OLAT)*DTR*REARTH
c xshift=east-west distance from lower left corner to origin
c yshift=north-south distance from lower left corner to origin
c XR=distance of datum from lower left corner
c YR=distance of datum from lower left corner
        XR(I)=DELX+DX-XSHIFT
c yshift=distance from lower left corner to origin
        YR(I)=DELY+DY-YSHIFT
        ZR(I)=HEIGHT
       ELSE
        XR(I)=-1000.
        YR(I)=-1000.
        ZR(I)=-1000.
       ENDIF
c       WRITE(6,*)'I,RANGE,DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,'
c     +  'YSHIFT = ',
c     +  I,RANGE(I),DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,YSHIFT
      ENDDO
      CONTINUE
      RETURN
      END
	subroutine find_groundA(rdtai,deg2rad, beam_wid, 
     +		rs_th, rs_m, dBz_max, ibeg, Ng2, ibst,bin,rasend)
C Find the surface, as in Testud's memo.
        include "hrd_radar_common_blocks.f"
	real lambda
        real rdtai(MAX_HRD_DIM),bin(max_hrd_dim)
        ra=rasend
c        write(6,*)'ra = ',ra
        radres=rdtai(101)-rdtai(100)
	theta = elev * deg2rad ! tilt relative to plane perp to radar axis
	beta = pitch * deg2rad
C In Testud's form, 0 is down, -90 port, 90 starboard:
c	phi = (180 - (azm + roll) ) * deg2rad 
        phi = (azm + roll -180) * deg2rad
	epsilon = beam_wid * deg2rad
C Now get elevation of beam rel to horizontal plane through radar
	sn_lambda = sin(theta) * sin(beta) - 
     *			cos(theta) * cos(beta) * cos(phi)
	lambda = asin(sn_lambda)
C Find theoretical range of surface. - sign because lambda neg
	rs_th = -ra / sn_lambda ! ra in m, radiita in km
C Find # of gates intersecting surface at theoretical range
C This would be formula if dR was constant:
C	Ng = rs_th * epsilon / (dR * tan(lambda) )
C But we may have varying beamwidths, so
Cout	slant_depth = -rs_th * epsilon / tan(lambda) ! slight approximation
Cout	rs_th_in = ( rs_th - slant_depth * 0.5 ) * 0.001
Cout	rs_th_out = ( rs_th + slant_depth * 0.5 ) * 0.001
C mod dec 8 92:
	rs_th_in = -ra / sin(lambda - epsilon * 0.75) * 0.001
	rs_th_out = -ra / sin(lambda + epsilon * 0.75) * 0.001
	rs_km = rs_th * 0.001
c        write(6,*)'rs_th_in,rs_km,rs_th_out = ',
c     +             rs_th_in,rs_km,rs_th_out
c	in = nbins-100
c        iout = nbins
        Nr = nbins-50
        in=-1
        iout=-1
	do i = 1, nbins
	    if( radiita(i) .gt. 0.0 )then
		if(radiita(i) .lt. rs_th_in) in = i
		if(radiita(i) .le. rs_th_out) iout = i
		if(radiita(i) .le. rs_km) Nr = i
	    end if
	end do
	if(in .eq. -1.or.iout.eq.-1)then
c		WRITE(6,*)' find_ground failure!'
c		WRITE(6,*)' ra:',ra
c		WRITE(6,*)'azm, phi: ', azm, phi
c		WRITE(6,*)'pitch, drift, roll: ',pitch, drift, roll
c		WRITE(6,*)'el, sin(lambda), lambda:',elev, 
c     +			sn_lambda, lambda
c		WRITE(6,*)'rs_th_in, rs_th_out, rs_km:'
c		WRITE(6,*)rs_th_in, rs_th_out, rs_km
c		WRITE(6,*)' find_gs in, iout, Nr: ',in, iout, Nr
c		pause ' pausing for this mystery '
		ibeg = 0
		return
	end if
	Ng = iout - in + 1
        Ng2 = Ng
	Ng2 =  0.5 * Ng
	if (Ng2 .eq. 0) Ng2 = 1
c        write(6,*)'in,iout,ng,ng2,nr = ',in,iout,ng,ng2,nr
C changed radius of check to 30 bins = 2.25 km, because of huge
C range delays in Andrew 8 dec 92
C Then search the gates within +- 30 of gate at theoretical
C range to find the swath Ng/2 wide with greatest Total Ze.
C Return bounding bins.
	dBz_max = -1.0
	ibeg = -1
        if(ng2.gt.30)then
         n30=ng2
        else
         n30=30
        endif
c        n30=ng2
c	ist = max(in, Nr - n30)
        ist = Nr - Ng2
	ien = min(nbins-Ng2, Nr + n30 -Ng2)
c        if(ist.gt.20)ist=ist-20
        if(ist.lt.1)ist=1
c        WRITE(6,*)'find_gd in,iout,Ng,Ng2 = ',in,iout,Ng,Ng2
c	WRITE(6,*)'find_gd Nr, nbins,ist, ien: ',Nr,nbins,ist, ien
	do i = ist, ien
	   dBzsum = 0.0
           velsum = 0.0
           ndbzsum = 0
           nvelsum =0
	   do j = i, i + Ng2
               if(j.gt.ibst.and.dbzbuffer(j).gt.-32.)then
		dBzsum = dBzsum + dbzbuffer(j)
                if(bin(j).gt.-800.)then
                 nvelsum=nvelsum+1
                 velsum=velsum+bin(j)
                endif
c                write(6,*)'bin ',bin(j)
                ndbzsum=ndbzsum+1
               endif
c                dbzsum = dbzbuffer(i+Ng2)-dbzbuffer(i)
	   end do
           if(ndbzsum.gt.0)then
            dbzsum=dbzsum/ndbzsum
           else
            dbzsum=-32.
           endif
           if(nvelsum.gt.0)then
            velsum=velsum/nvelsum
           else
            velsum=-888.88
           endif
	   if( dBzsum .gt. dBz_max.and.dbzbuffer(i).lt.80)then
		dBz_max = dBzsum
		ibeg = i
                if(nvelsum.gt.0)then
                 vel_max = velsum
                else
                 vel_max = -888.88
                endif
	   end if
	end do
c        extra=.1/abs(sn_lambda)
        if(dbz_max.gt.0.)then
         extra=.1*40./dbz_max/abs(sn_lambda)
        else
         extra=0.
        endif
        ibeg=ibeg-int(extra/radres)
        if(ibeg.lt.1)ibeg=1
	iradius = ibeg + Ng2 * 0.5
	if( iradius .le.0) iradius = 1
        if( iradius .gt.nbins) iradius = nbins
	rs_m = radiita( iradius ) * 1000.0
        if(ibeg.lt.1)ibeg=1
	return
	end
C ********************
      SUBROUTINE READTAPE(TIME,RLAT,RLON,RA,AZM,EV,BIN,REF,BIN1,REF1,
     +                    RCAZM,ITAPEOPEN,RADARFILE,NUMREC,
     +                    PCORS,DCORS,RCORS,AZMCORS,
     +                    RDELCORTAS,ELCORS,ISIGMET,NDO)
      INCLUDE "hrd_radar_common_blocks_johns.f"
c      common/rvp8_files/sweep_open,current_fptr,current_fn
      COMMON /AREA1/ INM,IFLT,STIME,ETIME,WD,WS,NIX,NGATE1,LP,LUNR,
     +               IVT,RAMFL
      COMMON /PARAMS/ trakazm,trakelev,driftnew,
     +                rot,track,htbb,dbb,thresh,swthresh,dbzrs,ibst(2),
     +                inob(2),ileg,xniq,irsw,maxnbins,v0,
     +                pcor,dcor,rcor,azmcor,elcor,dbzcor,dbzslope,
     +                iunfoldflag,iattenflag,
     +                badstabflag,surfelimflag,echoflag,atmflag
      LOGICAL badstabflag, surfelimflag, echoflag, atmflag
c      logical*8 sweep_open
c      character*132 current_fn
c      integer*8 current_fptr
      INTEGER RTYPE
      REAL PCORS(2),DCORS(2),RCORS(2),AZMCORS(2)
      REAL RDELCORTAS(2),ELCORS(2)
      CHARACTER IFLT*8, INM*12
      CHARACTER *1 RAMFL, IVT
      CHARACTER*80 RADARFILE
      DIMENSION BIN(MAX_HRD_DIM),REF(MAX_HRD_DIM)
      DIMENSION BIN1(MAX_HRD_DIM),REF1(MAX_HRD_DIM)
      DATA RTYPE/6/
C Subroutine to read doppler and Reflectivity data from the new 1988
C format radar tapes.  Reads refl/doppler when rtype=6 and dop/ref/sw when
C rtype=7.  It returns one ray per call.
C NIX = -100 determines an end-of-file
C Read data from tape:
      NIX=0
      IHEADERFLAG=1
      DO I=1,MAX_HRD_DIM
       BIN(I)=-888.8
       REF(I)=-32.
       BIN1(I)=-888.8
       REF1(I)=-32.
      ENDDO
c      IF (SWTHRESH.GT.0.0 .AND. SWTHRESH.LE.13.0) RTYPE=7
      RTYPE=7
c50    write(6,*)'calling radartaperead1'
c      write(6,*)'itapeopen,numrec = ',itapeopen,numrec
c      write(6,'(A80)')radarfile
50    IF(ITAPEOPEN.EQ.0.AND.ISIGMET.EQ.5)THEN
c       write(6,*)'calling radardiscread,iheaderflag = ',iheaderflag
c       pause
c       write(6,*)'time is ',time
       LUNRNC=LUNR
       CALL RADARDISCREAD1(LUNRNC,2,IHEADERFLAG,RTYPE,IERR)
       LUNR=LUNRNC
c       write(6,*)'returned from radardiscread'
c       write(6,*)'time after rvp8 is ',time
c       write(6,*)'nbins,nbinsta = ',nbins,nbinsta
c       WRITE(6,*)'CALLED RADAR_RVP8_READ AND IERR = ',IERR
      ELSEIF(ITAPEOPEN.EQ.0)THEN
 6664   LUNRNC=LUNR
        call radar_rvp8_read(LUNRNC,2,0,RTYPE,IERR)
        IF(NDO.NE.0)RETURN
        LUNR=LUNRNC
C       CALL RADARFILEREAD(LUNR,2,0,RTYPE,IERR,ITAPEOPEN,RADARFILE,
C     + NUMREC)
       IF(NBINS.LT.1.OR.NBINS.GT.MAX_HRD_DIM)GO TO 6664
      ELSE
       LUNRNC=LUNR
       CALL RADARTAPEREAD(LUNRNC,2,0,RTYPE,IERR)
       LUNR=LUNRNC
c       write(6,*)'should not get here 2'
c       stop
       IF(IERR.NE.0)THEN
        write(6,*)'returned from radartaperead ierr = ',ierr
       ENDIF
      ENDIF
c      IF(NBINS.LT.MAX_HRD_DIM)THEN
c       DO I=NBINS+1,MAX_HRD_DIM
c        RADIITA(I)=0.
c       ENDDO
c      ENDIF
      IF (IERR .LT. 0.AND.ISIGMET.EQ.5) THEN
         IF(IERR.EQ.-4)THEN
          NIX=-200
         ELSE
          NIX= -100
         ENDIF
         RETURN
      ELSE
       NIX = 0
      ENDIF
      IF(ELEV.LT.0.)THEN
       PCOR=PCORS(1)
       DCOR=DCORS(1)
       RCOR=RCORS(1)
       AZMCOR=AZMCORS(1)
       ELCOR=ELCORS(1)
      ELSE
       PCOR=PCORS(2)
       DCOR=DCORS(2)
       RCOR=RCORS(2)
       AZMCOR=AZMCORS(2)
       ELCOR=ELCORS(2)
      ENDIF
C    clear nix variable
      NIX= 0
C    time in seconds  
      TIME=RADTIME
C    raw azimuth
      TRAKAZM=RADAZM
c    roll corrected azimuth but in heading rather than track
      RCAZM=RADAZM+RCOR+ROLL
C    raw elevation
      TRAKELEV=ELEV
C    raw drift
      DRIFTNEW=DRIFT
C    nyquist velocity
      XNIQ=XNIQTA
      track = AMOD(heading + driftnew + 360.0, 360.0)
C ANGLECOR corrects the aircraft pitch,drift,roll,azimuth,elevation and
C adds the roll to the azimuth.
c      write(6,*)'roll,rcor,radazm,rcazm = ',roll,rcor,radazm,rcazm
c      write(6,*)'driftnew,trakazm,trakelev = ',
c     1           driftnew,trakazm,trakelev
      TRAKAZMTEMP=TRAKAZM
      TRAKELEVTEMP=TRAKELEV
      PITCHTEMP=PITCH
      ROLLTEMP=ROLL
      PCORTEMP=PCOR
      DCORTEMP=DCOR
      RCORTEMP=RCOR
      AZMCORTEMP=AZMCOR
      ELCORTEMP=ELCOR
      DRIFTNEWTEMP=DRIFTNEW
      CALL ANGLECOR(PITCHTEMP,DRIFTNEWTEMP,ROLLTEMP,TRAKAZMTEMP,
     +              TRAKELEVTEMP,2,PCORTEMP,
     +              DCORTEMP,RCORTEMP,AZMCORTEMP,ELCORTEMP)
      PCOR=PCORTEMP
      TRAKAZM=TRAKAZMTEMP
      TRAKELEV=TRAKELEVTEMP
      PITCH=PITCHTEMP
      ROLL=ROLLTEMP
      DCOR=DCORTEMP
      RCOR=RCORTEMP
      AZMCOR=AZMCORTEMP
      ELCOR=ELCORTEMP
      DRIFTNEW=DRIFTNEWTEMP
c      write(6,*)'after roll,trakazm,track = ',roll,trakazm,track
C Convert aircraft angles to earth relative shperical coordinates
      IUNFOLDFLAG=0
      CALL RAYCOR1(BIN1,REF1)
      IUNFOLDFLAG=0
      CALL RAYCOR1(BIN,REF)
      IUNFOLDFLAG=0
      TRAKAZMTEMP=TRAKAZM
      TRAKELEVTEMP=TRAKELEV
      TRACKTEMP=TRACK
       CALL CONVERTANGLES(TRACKTEMP,TRAKAZMTEMP,TRAKELEVTEMP,
     1                    HORAZM,HORELEV)
      TRAKAZM=TRAKAZMTEMP
      TRAKELEV=TRAKELEVTEMP
      TRACK=TRACKTEMP
C       WRITE(6,*)'TRAKAZM,TRAKELEV = ',TRAKAZM,TRAKELEV
c      write(6,*)'after convertangles = ',trakazm,horazm
C    azimuth earth relative
      AZM=HORAZM
C    elevation earth relative
      EV=HORELEV
C get information from the ram files.
c      IF (RAMFL .EQ. 'Y')
c     *   CALL READRAMFILE(TIME,TIMERAM,RADLAT,RADLON,RADALT,
c     *                    RADWD,RADWS,UCOM,VCOM,RADVWS,RADVGS,IOS)
C get information from the radar tape or the standard tape
      GS=RADGS                       !ground speed
      VGS=RADVGS                     !vertical ground speed
      VWS=RADVWS                     !vertical wind speed
      RLAT=RADLAT                    !latitude(deg)
      RLON=RADLON                    !longitude(deg)
      RA=RADALT                      !radar altitude(meters) 
      WD=RADWD                       !wind direction
      WS=RADWS                       !wind speed
C RAYCOR corrects the velocities one ray at a time.  It returns the airplane
C track, the first guess wind, the stabilized, vt corrected and unfolded
c velocities as well as the dbz values from the tail radar.
c      IUNFOLDFLAG=0
c      CALL RAYCOR1(BIN1,REF1)
c      IUNFOLDFLAG=0
c      CALL RAYCOR1(BIN,REF)
c      IUNFOLDFLAG=0
      RETURN
      END 
      SUBROUTINE AZISORT(NUM_RAYS,AZI,X)
      REAL AZI(2,NUM_RAYS),X(NUM_RAYS),XSORT(800)
      AZITEST=361.
      JSTART=1
      IF(NUM_RAYS.GT.2)THEN
       AZICHECK=AZI(1,3)-AZI(1,2)
       IF(AZICHECK.LT.-180.)AZICHECK=AZICHECK+360.
       IF(AZICHECK.GT.180.)AZICHECK=AZICHECK-360.
      ENDIF
      DO J=1,NUM_RAYS
       IF(J.EQ.NUM_RAYS)THEN
        JLOW=NUM_RAYS
        JHIGH=1
       ELSE
        JLOW=J
        JHIGH=J+1
       ENDIF
       AZICHECK2=AZI(1,JHIGH)-AZI(1,JLOW)
       IF(ABS(AZICHECK2).GT.180.)THEN
        JSTART=J
        AZITEST=AZI(1,J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        I=JJ-NUM_RAYS
       ELSE
        I=JJ
       ENDIF
c       WRITE(6,*)'JJ,J,I,AZI = ',JJ,J,I,AZI(1,I)
       XSORT(J)=X(I)
      ENDDO
      DO J=1,NUM_RAYS
       I=NUM_RAYS-J+1
       IF(AZICHECK.LT.0.)THEN
        X(J)=XSORT(I)
       ELSE
        X(J)=XSORT(J)
       ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE AZISORT2(NUMI,NUM_RAYS,AZI,X)
      include "hrd_radar_settings.f"
      REAL AZI(2,NUM_RAYS),X(NUMI,NUM_RAYS),XSORT(MAX_HRD_DIM,800)
      JSTART=1
      AZITEST=361.
      IF(NUM_RAYS.GT.2)THEN
       AZICHECK=AZI(1,3)-AZI(1,2)
       IF(AZICHECK.LT.-180.)AZICHECK=AZICHECK+360.
       IF(AZICHECK.GT.180.)AZICHECK=AZICHECK-360.
      ENDIF
      DO J=1,NUM_RAYS
       IF(J.EQ.NUM_RAYS)THEN
        JLOW=NUM_RAYS
        JHIGH=1
       ELSE
        JLOW=J
        JHIGH=J+1
       ENDIF
       AZICHECK2=AZI(1,JHIGH)-AZI(1,JLOW)
       IF(ABS(AZICHECK2).GT.180.)THEN
        JSTART=J
        AZITEST=AZI(1,J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        K=JJ-NUM_RAYS
       ELSE
        K=JJ
       ENDIF
c       WRITE(6,*)'JJ,I,J,K,AZI = ',JJ,I,J,K,AZI(1,K)
       DO I=1,NUMI
        XSORT(I,J)=X(I,K)
       ENDDO
      ENDDO
      DO J=1,NUM_RAYS
       K=NUM_RAYS-J+1
       DO I=1,NUMI
        IF(AZICHECK.LT.0.)THEN
         X(I,J)=XSORT(I,K)
        ELSE
         X(I,J)=XSORT(I,J)
        ENDIF
       ENDDO       
      ENDDO
      RETURN
      END
      SUBROUTINE IAZISORT(NUM_RAYS,AZI,X)
      REAL AZI(2,NUM_RAYS)
      INTEGER X(NUM_RAYS),XSORT(800)
      JSTART=1
      AZITEST=361.
      IF(NUM_RAYS.GT.2)THEN
       AZICHECK=AZI(1,3)-AZI(1,2)
       IF(AZICHECK.LT.-180.)AZICHECK=AZICHECK+360.
       IF(AZICHECK.GT.180.)AZICHECK=AZICHECK-360.
      ENDIF
      DO J=1,NUM_RAYS
       IF(J.EQ.NUM_RAYS)THEN
        JLOW=NUM_RAYS
        JHIGH=1
       ELSE
        JLOW=J
        JHIGH=J+1
       ENDIF
       AZICHECK2=AZI(1,JHIGH)-AZI(1,JLOW)
       IF(ABS(AZICHECK2).GT.180.)THEN
        JSTART=J
        AZITEST=AZI(1,J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        I=JJ-NUM_RAYS
       ELSE
        I=JJ
       ENDIF
c       WRITE(6,*)'JJ,J,I,AZI = ',JJ,J,I,AZI(1,I)
       XSORT(J)=X(I)
      ENDDO
      DO J=1,NUM_RAYS
       I=NUM_RAYS-J+1
       IF(AZICHECK.LT.0.)THEN
        X(J)=XSORT(I)
       ELSE
        X(J)=XSORT(J)
       ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE IAZISORT2(NUMI,NUM_RAYS,AZI,X)
      include "hrd_radar_settings.f"
      REAL AZI(2,NUM_RAYS)
      INTEGER X(NUMI,NUM_RAYS),XSORT(MAX_HRD_DIM,800)
      AZITEST=361.
      JSTART=1
      IF(NUM_RAYS.GT.2)THEN
       AZICHECK=AZI(1,3)-AZI(1,2)
       IF(AZICHECK.LT.-180.)AZICHECK=AZICHECK+360.
       IF(AZICHECK.GT.180.)AZICHECK=AZICHECK-360.
      ENDIF
      DO J=1,NUM_RAYS
       IF(J.EQ.NUM_RAYS)THEN
        JLOW=NUM_RAYS
        JHIGH=1
       ELSE
        JLOW=J
        JHIGH=J+1
       ENDIF
       AZICHECK2=AZI(1,JHIGH)-AZI(1,JLOW)
       IF(ABS(AZICHECK2).GT.180.)THEN
        JSTART=J
        AZITEST=AZI(1,J)
       ENDIF
      ENDDO
      IF(JSTART.EQ.NUM_RAYS)THEN
       JSTART=1
      ELSE
       JSTART=JSTART+1
      ENDIF
      JEND=JSTART+NUM_RAYS-1
      DO JJ=JSTART,JEND
       J=JJ-JSTART+1
       IF(JJ.GT.NUM_RAYS)THEN
        K=JJ-NUM_RAYS
       ELSE
        K=JJ
       ENDIF
c       WRITE(6,*)'JJ,I,J,K,AZI = ',JJ,I,J,K,AZI(1,K)
       DO I=1,NUMI
        XSORT(I,J)=X(I,K)
       ENDDO
      ENDDO
      DO J=1,NUM_RAYS
       K=NUM_RAYS-J+1
       DO I=1,NUMI
        IF(AZICHECK.LT.0.)THEN
         X(I,J)=XSORT(I,K)
        ELSE
         X(I,J)=XSORT(I,J)
        ENDIF
       ENDDO       
      ENDDO
      RETURN
      END
      SUBROUTINE GROUNDCHECK(SWEEP,SWEEPZ,NUM_RAYS,I,JSTART,ICHECK)
      INCLUDE "hrd_radar_settings.f"
      PARAMETER(MAX_RAYS=800)
      PARAMETER(MAX_GATES=MAX_HRD_DIM)
      REAL SWEEP(MAX_GATES,MAX_RAYS),SWEEPZ(MAX_GATES,MAX_RAYS)
      IF(ICHECK.LT.1.OR.ICHECK.GT.2)THEN
       WRITE(6,*)'PROBLEM WITH ICHECK IN GROUNDCHECK'
       STOP
      ENDIF
c      IF(JSTART.GT.2.AND.JSTART.LT.NUM_RAYS-1)THEN
c       WRITE(6,*)'I,JSTART,SWEEPZ = ',I,JSTART,
c     + (SWEEPZ(I,J),J=JSTART-2,JSTART)
c      ENDIF
c      PAUSE
      IF(SWEEPZ(I,JSTART).GT.-32.)THEN
       WRITE(6,*)'SWEEP(I,JSTART) GT -999.'
       WRITE(6,*)'ICHECK,I,JSTART,SWEEP,SWEEPZ = ',
     +  ICHECK,I,JSTART,SWEEP(I,JSTART),SWEEPZ(I,JSTART)
       STOP
      ENDIF
      IDBZTEST=0
c      WRITE(6,*)'GROUNDCHECK STARTING AND JSTART = ',JSTART
c      IF(ICHECK.EQ.1.AND.JSTART.GE.5)THEN
c       JSTARTCHECK1=0
c       DO J=JSTART,JSTART-4
c        IF(SWEEPZ(I,J).GT.48.)JSTARTCHECK1=1
c       ENDDO
c       IF(JSTARTCHECK1.EQ.1)THEN
c         J=JSTART
c         WRITE(6,6296)J,(SWEEPZ(I,J),J=JSTART,JSTART-4,-1)
c 6296    FORMAT(I5,6F10.2)
c       ENDIF
c      ELSEIF(ICHECK.EQ.2.AND.JSTART+4.LE.NUM_RAYS)THEN
c       JSTARTCHECK2=0
c       DO J=JSTART,JSTART+4
c        IF(SWEEPZ(I,J).GT.48.)JSTARTCHECK2=1
c       ENDDO
c       IF(JSTARTCHECK2.EQ.1)THEN
c         J=JSTART
c         WRITE(6,6296)J,(SWEEPZ(I,J),J=JSTART,JSTART+4)
c       ENDIF
c      ENDIF
      IF(ICHECK.EQ.1)THEN
       IF(JSTART.LT.5)THEN
        DO J=JSTART,1,-1
         SWEEPZ(I,J)=-32.
         SWEEP(I,J)=-888.8
        ENDDO
        RETURN
       ELSE
        IF(SWEEPZ(I,JSTART-1).GT.40..OR.
     +     SWEEPZ(I,JSTART-4).GT.40.)IDBZTEST=1
c        IF(IDBZTEST.GT.0)WRITE(6,*)'BEFORE RIGHT,JSTART,SWEEPZ = ',
c     +    JSTART,(SWEEPZ(I,J),J=JSTART-9,JSTART)
       ENDIF
c       WRITE(6,*)'I,JSTART,SWEEPZ = ',
c     +  I,J,(SWEEPZ(I,J),J=JSTART-2,JSTART)
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART-1).GT.-32..AND.
     +    SWEEP(I,JSTART-2).LE.-32.)THEN
        SWEEPZ(I,JSTART-1)=-32.
        SWEEP(I,JSTART-1)=-888.8
c        write(6,*)'removed'
       ENDIF
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART-1).GT.-32..AND.
     +    SWEEP(I,JSTART-3).LE.-32.)THEN
        SWEEPZ(I,JSTART-1)=-32.
        SWEEP(I,JSTART-1)=-888.8
        SWEEPZ(I,JSTART-2)=-32.
        SWEEP(I,JSTART-2)=-888.8
c        write(6,*)'removed 2'
       ENDIF
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART-1).GT.-32..AND.
     +    SWEEP(I,JSTART-4).LE.-32.)THEN
        SWEEPZ(I,JSTART-1)=-32.
        SWEEP(I,JSTART-1)=-888.8
        SWEEPZ(I,JSTART-2)=-32.
        SWEEP(I,JSTART-2)=-888.8
        SWEEPZ(I,JSTART-3)=-32.
        SWEEP(I,JSTART-3)=-888.8
c        write(6,*)'removed 3'
       ENDIF
       DO J=JSTART-1,JSTART-3,-1
        IF(SWEEPZ(I,J).GT.-32..AND.SWEEPZ(I,J-1).GT.-32.AND.
     +      SWEEPZ(I,J)-SWEEPZ(I,J-1).GT.3.)THEN
c        IF(SWEEPZ(I,J)-SWEEPZ(I,J-1).GT.10.)THEN
         DO JJ=J,JSTART
          SWEEPZ(I,JJ)=-32.
          SWEEP(I,JJ)=-888.8
         ENDDO
        ENDIF
       ENDDO
c       IF(IDBZTEST.GT.0)WRITE(6,*)'AFTER RIGHT,JSTART,SWEEPZ = ',
c     +   JSTART,(SWEEPZ(I,J),J=JSTART-9,JSTART)
c       IF(IDBZTEST.GT.0)WRITE(6,*)'ZR AFTER RIGHT,JSTART,SWEEPZ = ',
c     +   JSTART,(ZRSWEEP(I,J),J=JSTART-9,JSTART)
c       IF(IDBZTEST.GT.0)WRITE(6,*)'RADIUS = ',RD(I)
c       IF(SWEEPZ(I,JSTART-9).GT.20.)THEN
c        WRITE(6,*)'SWEEPZ(I,JSTART-9) = ',SWEEPZ(I,JSTART-9)
c        WRITE(6,*)'ZRSWEEP(I,JSTART-9) = ',ZRSWEEP(I,JSTART-9)
c       WRITE(6,*)'RADIUS = ',RD(I)
c        PAUSE
c       ENDIF
      ELSE
       IF(NUM_RAYS-JSTART.LT.4)THEN
        DO J=JSTART,NUM_RAYS
         SWEEPZ(I,J)=-32.
         SWEEP(I,J)=-888.8
        ENDDO
        RETURN
       ELSE
        IF(SWEEPZ(I,JSTART+1).GT.40..OR.
     +     SWEEPZ(I,JSTART+4).GT.40.)IDBZTEST=1
c        IF(IDBZTEST.GT.0)WRITE(6,*)'BEFORE LEFT,JSTART,SWEEPZ = ',
c     +   JSTART,(SWEEPZ(I,J),J=JSTART,JSTART+9)
       ENDIF
c       WRITE(6,*)'I,JSTART,SWEEPZ = ',
c     +  I,J,(SWEEPZ(I,J),J=JSTART+1,JSTART+2)
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART+1).GT.-32..AND.
     +    SWEEP(I,JSTART+2).LE.-32.)THEN
        SWEEPZ(I,JSTART+1)=-32.
        SWEEP(I,JSTART+1)=-888.8
c        write(6,*)'removed'
       ENDIF
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART+1).GT.-32..AND.
     +    SWEEP(I,JSTART+3).LE.-32.)THEN
        SWEEPZ(I,JSTART+1)=-32.
        SWEEP(I,JSTART+1)=-888.8
        SWEEPZ(I,JSTART+2)=-32.
        SWEEP(I,JSTART+2)=-888.8
c        write(6,*)'removed 2'
       ENDIF
       IF(SWEEPZ(I,JSTART).LE.-32..AND.SWEEPZ(I,JSTART+1).GT.-32..AND.
     +    SWEEP(I,JSTART+4).LE.-32.)THEN
        SWEEPZ(I,JSTART+1)=-32.
        SWEEP(I,JSTART+1)=-888.8
        SWEEPZ(I,JSTART+2)=-32.
        SWEEP(I,JSTART+2)=-888.8
        SWEEPZ(I,JSTART+3)=-32.
        SWEEP(I,JSTART+3)=-888.8
c        write(6,*)'removed 3'
       ENDIF
       DO J=JSTART+1,JSTART+3
c        IF(SWEEPZ(I,J)-SWEEPZ(I,J+1).GT.10.)THEN
        IF(SWEEPZ(I,J).GT.-32..AND.SWEEPZ(I,J+1).GT.-32.AND.
     +      SWEEPZ(I,J)-SWEEPZ(I,J+1).GT.3.)THEN
         DO JJ=J,JSTART,-1
          SWEEPZ(I,JJ)=-32.
          SWEEP(I,JJ)=-888.8
         ENDDO
        ENDIF
       ENDDO
c       IF(IDBZTEST.GT.0)WRITE(6,*)'AFTERLEFT,JSTART,SWEEPZ = ',
c     +            JSTART,(SWEEPZ(I,J),J=JSTART,JSTART+9)
c       IF(IDBZTEST.GT.0)WRITE(6,*)'ZR AFTERLEFT,JSTART,SWEEPZ = ',
c     +            JSTART,(ZRSWEEP(I,J),J=JSTART,JSTART+9)
c       IF(IDBZTEST.GT.0)WRITE(6,*)'RADIUS = ',RD(I)
c       IF(SWEEPZ(I,JSTART+4).GT.20.)THEN
c        WRITE(6,*)'SWEEPZ(I,JSTART+9) = ',SWEEPZ(I,JSTART+9)
c        WRITE(6,*)'ZRSWEEP(I,JSTART+9) = ',ZRSWEEP(I,JSTART+9)
c        WRITE(6,*)'RADIUS = ',RD(I)
c        PAUSE
c       ENDIF
      ENDIF
c      WRITE(6,*)'GROUNDCHECK RETURNING'
c      IF(ICHECK.EQ.1.AND.JSTART.GE.5)THEN
c       JSTARTCHECK1=0
c       DO J=JSTART,JSTART-4
c        IF(SWEEPZ(I,J).GT.48.)JSTARTCHECK1=1
c       ENDDO
c       IF(JSTARTCHECK1.EQ.1)THEN
c         J=JSTART
c         WRITE(6,6296)J,(SWEEPZ(I,J),J=JSTART,JSTART-4,-1)
c         PAUSE
c       ENDIF
c      ELSEIF(ICHECK.EQ.2.AND.JSTART+4.LE.NUM_RAYS)THEN
c       JSTARTCHECK2=0
c       DO J=JSTART,JSTART+4
c        IF(SWEEPZ(I,J).GT.48.)JSTARTCHECK2=1
c       ENDDO
c       IF(JSTARTCHECK2.EQ.1)THEN
c         J=JSTART
c         WRITE(6,6296)J,(SWEEPZ(I,J),J=JSTART,JSTART+4)
c         PAUSE
c       ENDIF
c      ENDIF
      RETURN
      END
      SUBROUTINE GROUNDCHECKI(REF,BIN,IBEG,NBINS,EVPASS,NUMMAX)
      REAL REF(NBINS),BIN(NBINS)
      NUMCHECK=-SIN(EVPASS*3.14159/180.)*NUMMAX
      IF(NUMCHECK.LT.4)NUMCHECK=4
      IF(REF(IBEG).LE.-32..AND.REF(IBEG-1).GT.-32..AND.
     +   REF(IBEG-2).LE.-32.)THEN
         REF(IBEG-1)=-32.
         BIN(IBEG-1)=-888.8
      ENDIF
      IF(REF(IBEG).LE.-32..AND.REF(IBEG-1).GT.-32..AND.
     +   REF(IBEG-3).LE.-32.)THEN
         REF(IBEG-1)=-32.
         BIN(IBEG-1)=-888.8
         REF(IBEG-2)=-32.
         BIN(IBEG-2)=-888.8
      ENDIF
      IF(REF(IBEG).LE.-32..AND.REF(IBEG-1).GT.-32..AND.
     +   REF(IBEG-4).LE.-32.)THEN
         REF(IBEG-1)=-32.
         BIN(IBEG-1)=-888.8
         REF(IBEG-2)=-32.
         BIN(IBEG-2)=-888.8
         REF(IBEG-3)=-32.
         BIN(IBEG-3)=-888.8
      ENDIF
      DO I=IBEG,IBEG-NUMCHECK,-1
c         IF(REF(I).GT.-32..AND.REF(I-1).GT.-32..AND.
         IF(REF(I).GT.-32..AND.
     +      REF(I)-REF(I-1).GT.3.)THEN
            DO II=I,IBEG
               REF(II)=-32.
               BIN(II)=-888.8
            ENDDO
         ENDIF
      ENDDO
      RETURN
      END
	subroutine find_ground(rdtai,deg2rad, beam_wid, 
     +		rs_th, rs_m, dBz_max, ibeg, Ng2, ibst,bin,isecondtrip,
     +          rmaxtata,rasend)
C Find the surface, as in Testud's memo.
        include "hrd_radar_common_blocks.f"
	real lambda
        real rdtai(MAX_HRD_DIM),bin(max_hrd_dim)
C
        ra=rasend
c        write(6,*)'ra = ',ra
        radres=rdtai(101)-rdtai(100)
	theta = elev * deg2rad ! tilt relative to plane perp to radar axis
	beta = pitch * deg2rad
C In Testud's form, 0 is down, -90 port, 90 starboard:
c	phi = (180 - (azm + roll) ) * deg2rad 
        phi = (azm + roll -180) * deg2rad
	epsilon = beam_wid * deg2rad
C Now get elevation of beam rel to horizontal plane through radar
	sn_lambda = sin(theta) * sin(beta) - 
     *			cos(theta) * cos(beta) * cos(phi)
	lambda = asin(sn_lambda)
C Find theoretical range of surface. - sign because lambda neg
	rs_th = -ra / sn_lambda ! ra in m, radiita in km
C Find # of gates intersecting surface at theoretical range
C This would be formula if dR was constant:
C	Ng = rs_th * epsilon / (dR * tan(lambda) )
C But we may have varying beamwidths, so
Cout	slant_depth = -rs_th * epsilon / tan(lambda) ! slight approximation
Cout	rs_th_in = ( rs_th - slant_depth * 0.5 ) * 0.001
Cout	rs_th_out = ( rs_th + slant_depth * 0.5 ) * 0.001
C mod dec 8 92:
	rs_th_in = -ra / sin(lambda - epsilon * 0.75) * 0.001
	rs_th_out = -ra / sin(lambda + epsilon * 0.75) * 0.001
	rs_km = rs_th * 0.001
c        write(6,*)'rs_th_out,rmaxtata,theta = ',
c     +    rs_th_out,rmaxtata,theta
        if((rs_km.gt.rmaxtata.or.rs_th_out.le.0.)
     + .and.isecondtrip.eq.1)then
           ibeg=-2
           return
        elseif(rs_th_in.gt.rmaxtata)then
           ibeg=0
c           write(6,*)'returning with ibeg = 0'
           return
        endif
c           do i=1,nbins
c              if(radiita(i).gt.0.0)then
c                 if(radiita(i).lt.rs_second)ibeg=i
c              endif
c           enddo
c           write(6,*)'i got here and'
c           write(6,*)'elev,azm,rs_th_out,rs_th_in,rs_second,ibeg = ',
c     +                elev,azm,rs_th_out,rs_th_in,rs_second,ibeg
c           return
c        endif
c        write(6,*)'rs_th_in,rs_km,rs_th_out = ',
c     +             rs_th_in,rs_km,rs_th_out
c	in = nbins-100
c        iout = nbins
        Nr = nbins-50
        in=-1
        iout=-1
	do i = 1, nbins
	    if( radiita(i) .gt. 0.0 )then
		if(radiita(i) .lt. rs_th_in) in = i
		if(radiita(i) .le. rs_th_out) iout = i
		if(radiita(i) .le. rs_km) Nr = i
	    end if
	end do
	if(in .eq. -1.or.iout.eq.-1)then
c		WRITE(6,*)' find_ground failure!'
c		WRITE(6,*)' ra:',ra
c		WRITE(6,*)'azm, phi: ', azm, phi
c		WRITE(6,*)'pitch, drift, roll: ',pitch, drift, roll
c		WRITE(6,*)'el, sin(lambda), lambda:',elev, 
c     +			sn_lambda, lambda
c		WRITE(6,*)'rs_th_in, rs_th_out, rs_km:'
c		WRITE(6,*)rs_th_in, rs_th_out, rs_km
c		WRITE(6,*)' find_gs in, iout, Nr: ',in, iout, Nr
c		pause ' pausing for this mystery '
		ibeg = 0
		return
	end if
	Ng = iout - in + 1
        Ng2 = Ng
	Ng2 =  0.5 * Ng
	if (Ng2 .eq. 0) Ng2 = 1
c        write(6,*)'in,iout,ng,ng2,nr = ',in,iout,ng,ng2,nr
C changed radius of check to 30 bins = 2.25 km, because of huge
C range delays in Andrew 8 dec 92
C Then search the gates within +- 30 of gate at theoretical
C range to find the swath Ng/2 wide with greatest Total Ze.
C Return bounding bins.
	dBz_max = -1.0
	ibeg = -1
        if(ng2.gt.30)then
         n30=ng2
        else
         n30=30
        endif
c        n30=ng2
c	ist = max(in, Nr - n30)
        ist = Nr - Ng2
	ien = min(nbins-Ng2, Nr + n30 -Ng2)
c        if(ist.gt.20)ist=ist-20
        if(ist.lt.1)ist=1
c        WRITE(6,*)'find_gd in,iout,Ng,Ng2,ibst = ',in,iout,Ng,Ng2,ibst
c	WRITE(6,*)'find_gd Nr, nbins,ist, ien: ',Nr,nbins,ist, ien
	do i = ist, ien
	   dBzsum = 0.0
           velsum = 0.0
           ndbzsum = 0
           nvelsum =0
	   do j = i, i + Ng2
c               write(6,*)'j,dbzbuffer(j) = ',j,dbzbuffer(j)
               if(j.gt.ibst.and.dbzbuffer(j).gt.-32.)then
		dBzsum = dBzsum + dbzbuffer(j)
                if(bin(j).gt.-800.)then
                 nvelsum=nvelsum+1
                 velsum=velsum+bin(j)
                endif
c                write(6,*)'bin ',bin(j)
                ndbzsum=ndbzsum+1
c                write(6,*)'j,dbzbuffer,ndbzsum,dBzsum = ',
c     1                     j,dbzbuffer(j),ndbzsum,dBzsum
               endif
c                dbzsum = dbzbuffer(i+Ng2)-dbzbuffer(i)
	   end do
           if(ndbzsum.gt.0)then
            dbzsum=dbzsum/ndbzsum
           else
            dbzsum=-32.
           endif
           if(nvelsum.gt.0)then
            velsum=velsum/nvelsum
           else
            velsum=-888.88
           endif
c           write(6,*)'i,dBzsum,dBz_max,dbzbuffer(i) = ',
c     1                i,dBzsum,dBz_max,dbzbuffer(i)
	   if( dBzsum .gt. dBz_max.and.dbzbuffer(i).lt.80)then
		dBz_max = dBzsum
		ibeg = i
c                write(6,*)'ibeg,dBz_max,dBzsum = ',
c     1                     ibeg,dBz_max,dBzsum
                if(nvelsum.gt.0)then
                 vel_max = velsum
                else
                 vel_max = -888.88
                endif
	   end if
	end do
c        write(6,*)'final computed ibeg = ',ibeg
        if(dbz_max.gt.0.)then
         extra=.1*40./dbz_max/abs(sn_lambda)
        else
         extra=0.
        endif
        ibeg=ibeg-int(extra/radres)
        if(ibeg.lt.1)ibeg=1
	iradius = ibeg + Ng2 * 0.5
	if( iradius .le.0) iradius = 1
        if( iradius .gt.nbins) iradius = nbins
	rs_m = radiita( iradius ) * 1000.0
        if(ibeg.lt.1)ibeg=1
	return
	end


